using System;
using System.Data;
using System.Reflection;
using gov.va.med.vbecs.ExceptionManagement;

namespace gov.va.med.vbecs.BOL
{

		#region Header

		///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
		///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
		///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
		///<Developers>
		///	<Developer>Rob Heiberger</Developer>
		///</Developers>
		///<SiteName>Hines OIFO</SiteName>
		///<CreationDate>7/28/2004</CreationDate>
		///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
		///<summary></summary>

		#endregion

	public class Antigen
	{
		#region Methods

		///<Developers>
		///	<Developer>Margaret Jablonski</Developer>
		///</Developers>
		///<SiteName>Hines OIFO</SiteName>
		///<CreationDate>3/10/2004</CreationDate>
		///<TestCases>
		///	
		///<Case type="0" testid ="3905"> 
		///		<ExpectedInput>NA</ExpectedInput>
		///		<ExpectedOutput>DataTable</ExpectedOutput>
		///	</Case>
		///
		///<Case type="1" testid ="3906"> 
		///		<ExpectedInput>NA</ExpectedInput>
		///		<ExpectedOutput>NA</ExpectedOutput>
		///	</Case>
		///
		///</TestCases>
		///<Update></Update>
		///<ArchivePlan></ArchivePlan>
		///<Interfaces></Interfaces>
		/// <summary>
		/// GetAntigenLookupList
		/// </summary>
		/// <returns></returns>
		public static DataTable GetAntigenLookupList()
		{
			DataTable dt=gov.va.med.vbecs.DAL.Antigen.GetAntigenLookupList();
			//
			DataTable dtReturn = dt.Clone();
			//
			foreach(DataRow dr in dt.Rows)
			{
				if ((dr[Common.VbecsTables.AntigenType.AntigenTypeName].ToString() == "A") ||
					(dr[Common.VbecsTables.AntigenType.AntigenTypeName].ToString() == "B"))
				{
					continue;
				}
				dtReturn.Rows.Add(dr.ItemArray);
			}
			return dtReturn;
		}
		#endregion

	}
}
