using System;
using System.Data;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using BLOODUNITTEST = gov.va.med.vbecs.Common.VbecsTables.BloodUnitTest;
using SPECIMENTEST = gov.va.med.vbecs.Common.VbecsTables.SpecimenTest;
using System.Windows.Forms;


namespace gov.va.med.vbecs.GUI
{
	/// <summary>
	/// Class FrmInvalidatePatientTestResults
	/// </summary>
	public class FrmInvalidatePatientTestResults : gov.va.med.vbecs.GUI.VbecsBaseForm
	{
		//Arraylist of the tests that we're locking as the user navigates through the listview
		//We need a seperate array so our code can unluck as they select the next test
		private System.Collections.ArrayList _lockedRecords = new ArrayList();
		private BOL.Specimen _specimen;
		private System.Collections.ArrayList _selectedTests;
		private int _reportableTestId;
		private BOL.OrderedTest _orderedTest;
		private BOL.BloodUnit _selectedUnit;
		private System.Collections.ArrayList _transfusedUnits;
		private BOL.PatientTransfusionReaction _patientTransfusionReaction;
		private ArrayList _trwBloodUnitTests;
		private ArrayList _trwSpecimenTests;
		//
		private System.Windows.Forms.ColumnHeader columnHeader9;
		private System.Windows.Forms.ColumnHeader columnHeader8;
		private System.Windows.Forms.GroupBox grpPatientTestResults;
		private System.Windows.Forms.ListView lvPatientTestResults;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Panel pnlXM;
		private System.Windows.Forms.Panel pnlABORh;
		private System.Windows.Forms.TextBox txtRhComment;
		private System.Windows.Forms.Label lblRhComment;
		private System.Windows.Forms.TextBox txtABOComment;
		private System.Windows.Forms.Label lblABOComment;
		private System.Windows.Forms.GroupBox grpImage;
		private System.Windows.Forms.PictureBox picImage;
		private System.Windows.Forms.ColumnHeader columnHeader13;
		private System.Windows.Forms.ColumnHeader columnHeader14;
		private System.Windows.Forms.ColumnHeader columnHeader15;
		private System.Windows.Forms.ColumnHeader columnHeader20;
		private System.Windows.Forms.ColumnHeader columnHeader21;
		private System.Windows.Forms.ColumnHeader columnHeader31;
		private System.Windows.Forms.ColumnHeader columnHeader34;
		private System.Windows.Forms.ColumnHeader columnHeader35;
		private System.Windows.Forms.ColumnHeader columnHeader32;
		private System.Windows.Forms.GroupBox grpSelectedTest;
		private System.Windows.Forms.Label lblDateTested;
		private System.Windows.Forms.TextBox txtDateTested;
		private System.Windows.Forms.TextBox txtTestedBy;
		private System.Windows.Forms.Label lblTestedBy;
		private System.Windows.Forms.TextBox txtRack;
		private System.Windows.Forms.Label lblRack;
		private System.Windows.Forms.TextBox txtInstrumentName;
		private System.Windows.Forms.Label lblInstrumentName;
		private System.Windows.Forms.TextBox txtTestingMethod;
		private System.Windows.Forms.Label lblTestingMethod;
		private System.Windows.Forms.TextBox txtRhInterp;
		private System.Windows.Forms.Label lblRhInterp;
		private System.Windows.Forms.TextBox txtABOInterp;
		private System.Windows.Forms.Label lblABOInterp;
		private System.Windows.Forms.ListView lvABORh;
		private System.Windows.Forms.ListView lvXM;
		private System.Windows.Forms.Panel pnlAID;
		private System.Windows.Forms.ListView lvAID;
		private System.Windows.Forms.TextBox txtIDComment;
		private System.Windows.Forms.Label lblAIDComment;
		private System.Windows.Forms.ColumnHeader columnHeader6;
		private gov.va.med.vbecs.GUI.controls.VbecsButton btnInvalidate;
		private gov.va.med.vbecs.GUI.controls.PatientSpecimenSelector patientSpecimenSelector1;
		private System.Windows.Forms.Panel pnlSpecimenSelect;
		private System.Windows.Forms.Panel pnlTestResults;
		private gov.va.med.vbecs.GUI.controls.PatientSpecimenDisplayPanel patientSpecimenDisplayPanel1;
		private gov.va.med.vbecs.GUI.controls.VbecsButton btnOKSpecimen;
		private System.Windows.Forms.TextBox txtXMComment;
		private System.Windows.Forms.Label lblXMComment;
		private System.Windows.Forms.TextBox txtXMInterp;
		private System.Windows.Forms.Label lblXMInterp;
		private System.Windows.Forms.Panel pnlTRW;
		private System.Windows.Forms.TextBox txtTRWPostSpecimen;
		private System.Windows.Forms.Label lblTRWPostSpecimen;
		private System.Windows.Forms.TextBox txtTRWPreSpecimen;
		private System.Windows.Forms.Label lblTRWPreSpecimen;
		private System.Windows.Forms.ListView lvImplicatedUnits;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.Label lblImplicatedUnits;
		private System.Windows.Forms.Panel pnlTest;
		private System.Windows.Forms.ListView lvTest;
		private System.Windows.Forms.TextBox txtTestComment;
		private System.Windows.Forms.Label lblTestComment;
		private System.Windows.Forms.TextBox txtTestInterp;
		private System.Windows.Forms.Label lblTestInterp;
		private System.Windows.Forms.TextBox txtProduct;
		private System.Windows.Forms.Label lblProduct;
		private System.Windows.Forms.TextBox txtUnitID;
		private System.Windows.Forms.Label lblUnitID;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.Panel pnlTests;
		private System.Windows.Forms.Splitter splitter1;
		private System.ComponentModel.IContainer components = null;
		private System.Windows.Forms.Label lblTRWTests;
		private System.Windows.Forms.ListView lvTRWTests;
		private System.Windows.Forms.ColumnHeader columnHeader7;
		private System.Windows.Forms.ColumnHeader columnHeader10;
		private System.Windows.Forms.ColumnHeader columnHeader12;
		private ArrayList _alWorkloadProcessIds = null;

		/// <summary>
		/// Constructor
		/// </summary>
		public FrmInvalidatePatientTestResults()
		{
			this.LockController.LockFunction = Common.LockFunctions.UC094InvalidatePatientTestResults;

			// This call is required by the Windows Form Designer.
			InitializeComponent();

			SetComponentProperties();
			this.patientSpecimenSelector1.Focus();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FrmInvalidatePatientTestResults));
			this.grpPatientTestResults = new System.Windows.Forms.GroupBox();
			this.lvPatientTestResults = new System.Windows.Forms.ListView();
			this.columnHeader9 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader8 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.btnInvalidate = new gov.va.med.vbecs.GUI.controls.VbecsButton();
			this.grpSelectedTest = new System.Windows.Forms.GroupBox();
			this.txtTestingMethod = new System.Windows.Forms.TextBox();
			this.lblTestingMethod = new System.Windows.Forms.Label();
			this.txtRack = new System.Windows.Forms.TextBox();
			this.lblRack = new System.Windows.Forms.Label();
			this.txtTestedBy = new System.Windows.Forms.TextBox();
			this.lblTestedBy = new System.Windows.Forms.Label();
			this.txtDateTested = new System.Windows.Forms.TextBox();
			this.lblDateTested = new System.Windows.Forms.Label();
			this.txtInstrumentName = new System.Windows.Forms.TextBox();
			this.lblInstrumentName = new System.Windows.Forms.Label();
			this.pnlTest = new System.Windows.Forms.Panel();
			this.lvTest = new System.Windows.Forms.ListView();
			this.columnHeader31 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader34 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader35 = new System.Windows.Forms.ColumnHeader();
			this.txtTestComment = new System.Windows.Forms.TextBox();
			this.lblTestComment = new System.Windows.Forms.Label();
			this.txtTestInterp = new System.Windows.Forms.TextBox();
			this.lblTestInterp = new System.Windows.Forms.Label();
			this.pnlTRW = new System.Windows.Forms.Panel();
			this.lvTRWTests = new System.Windows.Forms.ListView();
			this.columnHeader7 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader10 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader12 = new System.Windows.Forms.ColumnHeader();
			this.lblTRWTests = new System.Windows.Forms.Label();
			this.lblImplicatedUnits = new System.Windows.Forms.Label();
			this.txtTRWPostSpecimen = new System.Windows.Forms.TextBox();
			this.lblTRWPostSpecimen = new System.Windows.Forms.Label();
			this.txtTRWPreSpecimen = new System.Windows.Forms.TextBox();
			this.lblTRWPreSpecimen = new System.Windows.Forms.Label();
			this.lvImplicatedUnits = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.pnlXM = new System.Windows.Forms.Panel();
			this.txtProduct = new System.Windows.Forms.TextBox();
			this.lblProduct = new System.Windows.Forms.Label();
			this.txtUnitID = new System.Windows.Forms.TextBox();
			this.lblUnitID = new System.Windows.Forms.Label();
			this.txtXMComment = new System.Windows.Forms.TextBox();
			this.lblXMComment = new System.Windows.Forms.Label();
			this.txtXMInterp = new System.Windows.Forms.TextBox();
			this.lvXM = new System.Windows.Forms.ListView();
			this.columnHeader20 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader21 = new System.Windows.Forms.ColumnHeader();
			this.lblXMInterp = new System.Windows.Forms.Label();
			this.pnlABORh = new System.Windows.Forms.Panel();
			this.lvABORh = new System.Windows.Forms.ListView();
			this.columnHeader13 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader14 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader15 = new System.Windows.Forms.ColumnHeader();
			this.txtRhComment = new System.Windows.Forms.TextBox();
			this.lblRhComment = new System.Windows.Forms.Label();
			this.txtRhInterp = new System.Windows.Forms.TextBox();
			this.lblRhInterp = new System.Windows.Forms.Label();
			this.txtABOComment = new System.Windows.Forms.TextBox();
			this.lblABOComment = new System.Windows.Forms.Label();
			this.txtABOInterp = new System.Windows.Forms.TextBox();
			this.lblABOInterp = new System.Windows.Forms.Label();
			this.pnlAID = new System.Windows.Forms.Panel();
			this.lvAID = new System.Windows.Forms.ListView();
			this.columnHeader32 = new System.Windows.Forms.ColumnHeader();
			this.txtIDComment = new System.Windows.Forms.TextBox();
			this.lblAIDComment = new System.Windows.Forms.Label();
			this.btnCancel = new System.Windows.Forms.Button();
			this.grpImage = new System.Windows.Forms.GroupBox();
			this.picImage = new System.Windows.Forms.PictureBox();
			this.patientSpecimenSelector1 = new gov.va.med.vbecs.GUI.controls.PatientSpecimenSelector();
			this.pnlSpecimenSelect = new System.Windows.Forms.Panel();
			this.btnOKSpecimen = new gov.va.med.vbecs.GUI.controls.VbecsButton();
			this.pnlTestResults = new System.Windows.Forms.Panel();
			this.pnlTests = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.patientSpecimenDisplayPanel1 = new gov.va.med.vbecs.GUI.controls.PatientSpecimenDisplayPanel();
			this.grpPatientTestResults.SuspendLayout();
			this.grpSelectedTest.SuspendLayout();
			this.pnlTest.SuspendLayout();
			this.pnlTRW.SuspendLayout();
			this.pnlXM.SuspendLayout();
			this.pnlABORh.SuspendLayout();
			this.pnlAID.SuspendLayout();
			this.grpImage.SuspendLayout();
			this.pnlSpecimenSelect.SuspendLayout();
			this.pnlTestResults.SuspendLayout();
			this.pnlTests.SuspendLayout();
			this.SuspendLayout();
			// 
			// vbecsLogo1
			// 
			this.vbecsLogo1.Name = "vbecsLogo1";
			this.vbecsLogo1.Size = new System.Drawing.Size(744, 30);
			this.vbecsLogo1.Title = "Invalidate Patient Test Results";
			// 
			// lblRequiredField
			// 
			this.lblRequiredField.Location = new System.Drawing.Point(0, 428);
			this.lblRequiredField.Name = "lblRequiredField";
			// 
			// grpPatientTestResults
			// 
			this.grpPatientTestResults.AccessibleDescription = "Patient Test Results";
			this.grpPatientTestResults.AccessibleName = "Patient Test Results";
			this.grpPatientTestResults.Controls.Add(this.lvPatientTestResults);
			this.grpPatientTestResults.Dock = System.Windows.Forms.DockStyle.Left;
			this.grpPatientTestResults.Location = new System.Drawing.Point(0, 0);
			this.grpPatientTestResults.Name = "grpPatientTestResults";
			this.grpPatientTestResults.Size = new System.Drawing.Size(344, 312);
			this.grpPatientTestResults.TabIndex = 0;
			this.grpPatientTestResults.TabStop = false;
			this.grpPatientTestResults.Text = "Patient Test Results";
			// 
			// lvPatientTestResults
			// 
			this.lvPatientTestResults.AccessibleDescription = "Patient Test Results";
			this.lvPatientTestResults.AccessibleName = "Patient Test Results";
			this.lvPatientTestResults.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvPatientTestResults.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																								   this.columnHeader9,
																								   this.columnHeader6,
																								   this.columnHeader8,
																								   this.columnHeader2});
			this.lvPatientTestResults.FullRowSelect = true;
			this.lvPatientTestResults.HideSelection = false;
			this.lvPatientTestResults.Location = new System.Drawing.Point(8, 16);
			this.lvPatientTestResults.MultiSelect = false;
			this.lvPatientTestResults.Name = "lvPatientTestResults";
			this.lvPatientTestResults.Size = new System.Drawing.Size(328, 288);
			this.lvPatientTestResults.TabIndex = 0;
			this.lvPatientTestResults.View = System.Windows.Forms.View.Details;
			this.lvPatientTestResults.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.lvPatientTestResults_ColumnClick);
			this.lvPatientTestResults.SelectedIndexChanged += new System.EventHandler(this.lvPatientTestResults_SelectedIndexChanged);
			// 
			// columnHeader9
			// 
			this.columnHeader9.Text = "Test";
			this.columnHeader9.Width = 80;
			// 
			// columnHeader6
			// 
			this.columnHeader6.Text = "Interp.";
			// 
			// columnHeader8
			// 
			this.columnHeader8.Text = "Date Tested";
			this.columnHeader8.Width = 90;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Unit ID";
			this.columnHeader2.Width = 94;
			// 
			// btnInvalidate
			// 
			this.btnInvalidate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnInvalidate.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnInvalidate.Image = ((System.Drawing.Image)(resources.GetObject("btnInvalidate.Image")));
			this.btnInvalidate.Location = new System.Drawing.Point(176, 284);
			this.btnInvalidate.Name = "btnInvalidate";
			this.btnInvalidate.Size = new System.Drawing.Size(156, 23);
			this.btnInvalidate.TabIndex = 15;
			this.btnInvalidate.Click += new System.EventHandler(this.btnInvalidate_Click);
			// 
			// grpSelectedTest
			// 
			this.grpSelectedTest.AccessibleDescription = "Selected Patient Tests";
			this.grpSelectedTest.AccessibleName = "Selected Patient Tests";
			this.grpSelectedTest.Controls.Add(this.txtTestingMethod);
			this.grpSelectedTest.Controls.Add(this.lblTestingMethod);
			this.grpSelectedTest.Controls.Add(this.txtRack);
			this.grpSelectedTest.Controls.Add(this.lblRack);
			this.grpSelectedTest.Controls.Add(this.txtTestedBy);
			this.grpSelectedTest.Controls.Add(this.lblTestedBy);
			this.grpSelectedTest.Controls.Add(this.txtDateTested);
			this.grpSelectedTest.Controls.Add(this.lblDateTested);
			this.grpSelectedTest.Controls.Add(this.btnInvalidate);
			this.grpSelectedTest.Controls.Add(this.txtInstrumentName);
			this.grpSelectedTest.Controls.Add(this.lblInstrumentName);
			this.grpSelectedTest.Controls.Add(this.pnlTest);
			this.grpSelectedTest.Controls.Add(this.pnlTRW);
			this.grpSelectedTest.Controls.Add(this.pnlXM);
			this.grpSelectedTest.Controls.Add(this.pnlABORh);
			this.grpSelectedTest.Controls.Add(this.pnlAID);
			this.grpSelectedTest.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grpSelectedTest.Location = new System.Drawing.Point(348, 0);
			this.grpSelectedTest.Name = "grpSelectedTest";
			this.grpSelectedTest.Size = new System.Drawing.Size(340, 312);
			this.grpSelectedTest.TabIndex = 10;
			this.grpSelectedTest.TabStop = false;
			this.grpSelectedTest.Text = "Selected Patient Test";
			// 
			// txtTestingMethod
			// 
			this.txtTestingMethod.AccessibleDescription = "method";
			this.txtTestingMethod.AccessibleName = "method";
			this.txtTestingMethod.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTestingMethod.Location = new System.Drawing.Point(236, 16);
			this.txtTestingMethod.Name = "txtTestingMethod";
			this.txtTestingMethod.ReadOnly = true;
			this.txtTestingMethod.Size = new System.Drawing.Size(96, 20);
			this.txtTestingMethod.TabIndex = 3;
			this.txtTestingMethod.Text = "";
			// 
			// lblTestingMethod
			// 
			this.lblTestingMethod.Location = new System.Drawing.Point(192, 16);
			this.lblTestingMethod.Name = "lblTestingMethod";
			this.lblTestingMethod.Size = new System.Drawing.Size(44, 20);
			this.lblTestingMethod.TabIndex = 2;
			this.lblTestingMethod.Text = "Method";
			this.lblTestingMethod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtRack
			// 
			this.txtRack.AccessibleDescription = "rack";
			this.txtRack.AccessibleName = "rack";
			this.txtRack.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.txtRack.Location = new System.Drawing.Point(300, 40);
			this.txtRack.Name = "txtRack";
			this.txtRack.ReadOnly = true;
			this.txtRack.Size = new System.Drawing.Size(32, 20);
			this.txtRack.TabIndex = 7;
			this.txtRack.Text = "";
			// 
			// lblRack
			// 
			this.lblRack.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.lblRack.Location = new System.Drawing.Point(268, 40);
			this.lblRack.Name = "lblRack";
			this.lblRack.Size = new System.Drawing.Size(32, 20);
			this.lblRack.TabIndex = 6;
			this.lblRack.Text = "Rack";
			this.lblRack.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtTestedBy
			// 
			this.txtTestedBy.AccessibleDescription = "tested by";
			this.txtTestedBy.AccessibleName = "tested by";
			this.txtTestedBy.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTestedBy.Location = new System.Drawing.Point(88, 40);
			this.txtTestedBy.Name = "txtTestedBy";
			this.txtTestedBy.ReadOnly = true;
			this.txtTestedBy.Size = new System.Drawing.Size(176, 20);
			this.txtTestedBy.TabIndex = 5;
			this.txtTestedBy.Text = "";
			// 
			// lblTestedBy
			// 
			this.lblTestedBy.Location = new System.Drawing.Point(8, 40);
			this.lblTestedBy.Name = "lblTestedBy";
			this.lblTestedBy.Size = new System.Drawing.Size(80, 20);
			this.lblTestedBy.TabIndex = 4;
			this.lblTestedBy.Text = "Tested By";
			this.lblTestedBy.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtDateTested
			// 
			this.txtDateTested.AccessibleDescription = "Date Tested";
			this.txtDateTested.AccessibleName = "Date Tested";
			this.txtDateTested.Location = new System.Drawing.Point(88, 16);
			this.txtDateTested.Name = "txtDateTested";
			this.txtDateTested.ReadOnly = true;
			this.txtDateTested.Size = new System.Drawing.Size(92, 20);
			this.txtDateTested.TabIndex = 1;
			this.txtDateTested.Text = "";
			// 
			// lblDateTested
			// 
			this.lblDateTested.Location = new System.Drawing.Point(8, 16);
			this.lblDateTested.Name = "lblDateTested";
			this.lblDateTested.Size = new System.Drawing.Size(80, 20);
			this.lblDateTested.TabIndex = 0;
			this.lblDateTested.Text = "Date Tested";
			this.lblDateTested.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtInstrumentName
			// 
			this.txtInstrumentName.AccessibleDescription = "automated instrument name";
			this.txtInstrumentName.AccessibleName = "automated instrument name";
			this.txtInstrumentName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtInstrumentName.Location = new System.Drawing.Point(156, 64);
			this.txtInstrumentName.Name = "txtInstrumentName";
			this.txtInstrumentName.ReadOnly = true;
			this.txtInstrumentName.Size = new System.Drawing.Size(176, 20);
			this.txtInstrumentName.TabIndex = 9;
			this.txtInstrumentName.Text = "";
			// 
			// lblInstrumentName
			// 
			this.lblInstrumentName.Location = new System.Drawing.Point(8, 64);
			this.lblInstrumentName.Name = "lblInstrumentName";
			this.lblInstrumentName.Size = new System.Drawing.Size(156, 20);
			this.lblInstrumentName.TabIndex = 8;
			this.lblInstrumentName.Text = "Automated Instrument Name";
			this.lblInstrumentName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pnlTest
			// 
			this.pnlTest.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlTest.Controls.Add(this.lvTest);
			this.pnlTest.Controls.Add(this.txtTestComment);
			this.pnlTest.Controls.Add(this.lblTestComment);
			this.pnlTest.Controls.Add(this.txtTestInterp);
			this.pnlTest.Controls.Add(this.lblTestInterp);
			this.pnlTest.Location = new System.Drawing.Point(4, 84);
			this.pnlTest.Name = "pnlTest";
			this.pnlTest.Size = new System.Drawing.Size(332, 200);
			this.pnlTest.TabIndex = 10;
			this.pnlTest.TabStop = true;
			// 
			// lvTest
			// 
			this.lvTest.AccessibleDescription = "Tests";
			this.lvTest.AccessibleName = "Tests";
			this.lvTest.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvTest.BackColor = System.Drawing.SystemColors.Control;
			this.lvTest.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					 this.columnHeader31,
																					 this.columnHeader34,
																					 this.columnHeader35});
			this.lvTest.FullRowSelect = true;
			this.lvTest.Location = new System.Drawing.Point(4, 4);
			this.lvTest.MultiSelect = false;
			this.lvTest.Name = "lvTest";
			this.lvTest.Size = new System.Drawing.Size(324, 142);
			this.lvTest.TabIndex = 11;
			this.lvTest.View = System.Windows.Forms.View.Details;
			this.lvTest.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.TestResultsListView_ColumnClick);
			// 
			// columnHeader31
			// 
			this.columnHeader31.Text = "Tested With";
			this.columnHeader31.Width = 140;
			// 
			// columnHeader34
			// 
			this.columnHeader34.Text = "Phase";
			// 
			// columnHeader35
			// 
			this.columnHeader35.Text = "Result";
			this.columnHeader35.Width = 150;
			// 
			// txtTestComment
			// 
			this.txtTestComment.AccessibleDescription = "comment";
			this.txtTestComment.AccessibleName = "comment";
			this.txtTestComment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTestComment.Location = new System.Drawing.Point(72, 176);
			this.txtTestComment.Name = "txtTestComment";
			this.txtTestComment.ReadOnly = true;
			this.txtTestComment.Size = new System.Drawing.Size(256, 20);
			this.txtTestComment.TabIndex = 13;
			this.txtTestComment.Text = "";
			// 
			// lblTestComment
			// 
			this.lblTestComment.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblTestComment.Location = new System.Drawing.Point(4, 176);
			this.lblTestComment.Name = "lblTestComment";
			this.lblTestComment.Size = new System.Drawing.Size(68, 20);
			this.lblTestComment.TabIndex = 37;
			this.lblTestComment.Text = "Comment";
			this.lblTestComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtTestInterp
			// 
			this.txtTestInterp.AccessibleDescription = "test interpretation";
			this.txtTestInterp.AccessibleName = "test interpretation";
			this.txtTestInterp.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTestInterp.Location = new System.Drawing.Point(72, 152);
			this.txtTestInterp.Name = "txtTestInterp";
			this.txtTestInterp.ReadOnly = true;
			this.txtTestInterp.Size = new System.Drawing.Size(256, 20);
			this.txtTestInterp.TabIndex = 12;
			this.txtTestInterp.Text = "";
			// 
			// lblTestInterp
			// 
			this.lblTestInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblTestInterp.Location = new System.Drawing.Point(4, 152);
			this.lblTestInterp.Name = "lblTestInterp";
			this.lblTestInterp.Size = new System.Drawing.Size(72, 20);
			this.lblTestInterp.TabIndex = 36;
			this.lblTestInterp.Text = "Interpretation";
			this.lblTestInterp.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pnlTRW
			// 
			this.pnlTRW.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlTRW.Controls.Add(this.lvTRWTests);
			this.pnlTRW.Controls.Add(this.lblTRWTests);
			this.pnlTRW.Controls.Add(this.lblImplicatedUnits);
			this.pnlTRW.Controls.Add(this.txtTRWPostSpecimen);
			this.pnlTRW.Controls.Add(this.lblTRWPostSpecimen);
			this.pnlTRW.Controls.Add(this.txtTRWPreSpecimen);
			this.pnlTRW.Controls.Add(this.lblTRWPreSpecimen);
			this.pnlTRW.Controls.Add(this.lvImplicatedUnits);
			this.pnlTRW.Location = new System.Drawing.Point(4, 84);
			this.pnlTRW.Name = "pnlTRW";
			this.pnlTRW.Size = new System.Drawing.Size(332, 200);
			this.pnlTRW.TabIndex = 10;
			this.pnlTRW.TabStop = true;
			// 
			// lvTRWTests
			// 
			this.lvTRWTests.AccessibleDescription = "serologic tests";
			this.lvTRWTests.AccessibleName = "serologic tests";
			this.lvTRWTests.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvTRWTests.BackColor = System.Drawing.SystemColors.Control;
			this.lvTRWTests.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader7,
																						 this.columnHeader10,
																						 this.columnHeader12});
			this.lvTRWTests.FullRowSelect = true;
			this.lvTRWTests.Location = new System.Drawing.Point(4, 140);
			this.lvTRWTests.MultiSelect = false;
			this.lvTRWTests.Name = "lvTRWTests";
			this.lvTRWTests.Size = new System.Drawing.Size(324, 56);
			this.lvTRWTests.TabIndex = 6;
			this.lvTRWTests.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader7
			// 
			this.columnHeader7.Text = "Test";
			this.columnHeader7.Width = 80;
			// 
			// columnHeader10
			// 
			this.columnHeader10.Text = "Unit ID/Specimen UID";
			this.columnHeader10.Width = 160;
			// 
			// columnHeader12
			// 
			this.columnHeader12.Text = "Interp.";
			this.columnHeader12.Width = 80;
			// 
			// lblTRWTests
			// 
			this.lblTRWTests.Location = new System.Drawing.Point(4, 124);
			this.lblTRWTests.Name = "lblTRWTests";
			this.lblTRWTests.Size = new System.Drawing.Size(88, 16);
			this.lblTRWTests.TabIndex = 4;
			this.lblTRWTests.Text = "Serologic Tests";
			this.lblTRWTests.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblImplicatedUnits
			// 
			this.lblImplicatedUnits.Location = new System.Drawing.Point(4, 52);
			this.lblImplicatedUnits.Name = "lblImplicatedUnits";
			this.lblImplicatedUnits.Size = new System.Drawing.Size(88, 16);
			this.lblImplicatedUnits.TabIndex = 2;
			this.lblImplicatedUnits.Text = "Implicated Units";
			this.lblImplicatedUnits.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtTRWPostSpecimen
			// 
			this.txtTRWPostSpecimen.AccessibleDescription = "post transfusion specimen U I D";
			this.txtTRWPostSpecimen.AccessibleName = "post transfusion specimen U I D";
			this.txtTRWPostSpecimen.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTRWPostSpecimen.Location = new System.Drawing.Point(164, 28);
			this.txtTRWPostSpecimen.Name = "txtTRWPostSpecimen";
			this.txtTRWPostSpecimen.ReadOnly = true;
			this.txtTRWPostSpecimen.Size = new System.Drawing.Size(164, 20);
			this.txtTRWPostSpecimen.TabIndex = 1;
			this.txtTRWPostSpecimen.Text = "";
			// 
			// lblTRWPostSpecimen
			// 
			this.lblTRWPostSpecimen.Location = new System.Drawing.Point(4, 28);
			this.lblTRWPostSpecimen.Name = "lblTRWPostSpecimen";
			this.lblTRWPostSpecimen.Size = new System.Drawing.Size(168, 20);
			this.lblTRWPostSpecimen.TabIndex = 1;
			this.lblTRWPostSpecimen.Text = "Post-Transfusion Specimen UID";
			this.lblTRWPostSpecimen.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtTRWPreSpecimen
			// 
			this.txtTRWPreSpecimen.AccessibleDescription = "pre transfusion specimen U I D";
			this.txtTRWPreSpecimen.AccessibleName = "pre transfusion specimen U I D";
			this.txtTRWPreSpecimen.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTRWPreSpecimen.Location = new System.Drawing.Point(164, 4);
			this.txtTRWPreSpecimen.Name = "txtTRWPreSpecimen";
			this.txtTRWPreSpecimen.ReadOnly = true;
			this.txtTRWPreSpecimen.Size = new System.Drawing.Size(164, 20);
			this.txtTRWPreSpecimen.TabIndex = 0;
			this.txtTRWPreSpecimen.Text = "";
			// 
			// lblTRWPreSpecimen
			// 
			this.lblTRWPreSpecimen.Location = new System.Drawing.Point(4, 4);
			this.lblTRWPreSpecimen.Name = "lblTRWPreSpecimen";
			this.lblTRWPreSpecimen.Size = new System.Drawing.Size(168, 20);
			this.lblTRWPreSpecimen.TabIndex = 0;
			this.lblTRWPreSpecimen.Text = "Pre-Transfusion Specimen UID";
			this.lblTRWPreSpecimen.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lvImplicatedUnits
			// 
			this.lvImplicatedUnits.AccessibleDescription = "implicated units";
			this.lvImplicatedUnits.AccessibleName = "implicated units";
			this.lvImplicatedUnits.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvImplicatedUnits.BackColor = System.Drawing.SystemColors.Control;
			this.lvImplicatedUnits.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																								this.columnHeader1,
																								this.columnHeader3,
																								this.columnHeader4,
																								this.columnHeader5});
			this.lvImplicatedUnits.FullRowSelect = true;
			this.lvImplicatedUnits.Location = new System.Drawing.Point(4, 68);
			this.lvImplicatedUnits.MultiSelect = false;
			this.lvImplicatedUnits.Name = "lvImplicatedUnits";
			this.lvImplicatedUnits.Size = new System.Drawing.Size(324, 56);
			this.lvImplicatedUnits.TabIndex = 3;
			this.lvImplicatedUnits.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Unit ID";
			this.columnHeader1.Width = 80;
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Product";
			this.columnHeader3.Width = 80;
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "ABO/Rh";
			this.columnHeader4.Width = 80;
			// 
			// columnHeader5
			// 
			this.columnHeader5.Text = "Expires";
			this.columnHeader5.Width = 80;
			// 
			// pnlXM
			// 
			this.pnlXM.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlXM.Controls.Add(this.txtProduct);
			this.pnlXM.Controls.Add(this.lblProduct);
			this.pnlXM.Controls.Add(this.txtUnitID);
			this.pnlXM.Controls.Add(this.lblUnitID);
			this.pnlXM.Controls.Add(this.txtXMComment);
			this.pnlXM.Controls.Add(this.lblXMComment);
			this.pnlXM.Controls.Add(this.txtXMInterp);
			this.pnlXM.Controls.Add(this.lvXM);
			this.pnlXM.Controls.Add(this.lblXMInterp);
			this.pnlXM.Location = new System.Drawing.Point(4, 84);
			this.pnlXM.Name = "pnlXM";
			this.pnlXM.Size = new System.Drawing.Size(332, 200);
			this.pnlXM.TabIndex = 38;
			// 
			// txtProduct
			// 
			this.txtProduct.AccessibleDescription = "product";
			this.txtProduct.AccessibleName = "product";
			this.txtProduct.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtProduct.Location = new System.Drawing.Point(84, 28);
			this.txtProduct.Name = "txtProduct";
			this.txtProduct.ReadOnly = true;
			this.txtProduct.Size = new System.Drawing.Size(244, 20);
			this.txtProduct.TabIndex = 1;
			this.txtProduct.Text = "";
			// 
			// lblProduct
			// 
			this.lblProduct.Location = new System.Drawing.Point(4, 28);
			this.lblProduct.Name = "lblProduct";
			this.lblProduct.Size = new System.Drawing.Size(84, 20);
			this.lblProduct.TabIndex = 81;
			this.lblProduct.Text = "Product";
			this.lblProduct.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtUnitID
			// 
			this.txtUnitID.AccessibleDescription = "unit I D";
			this.txtUnitID.AccessibleName = "unit I D";
			this.txtUnitID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtUnitID.Location = new System.Drawing.Point(84, 4);
			this.txtUnitID.Name = "txtUnitID";
			this.txtUnitID.ReadOnly = true;
			this.txtUnitID.Size = new System.Drawing.Size(244, 20);
			this.txtUnitID.TabIndex = 0;
			this.txtUnitID.Text = "";
			// 
			// lblUnitID
			// 
			this.lblUnitID.Location = new System.Drawing.Point(4, 4);
			this.lblUnitID.Name = "lblUnitID";
			this.lblUnitID.Size = new System.Drawing.Size(64, 20);
			this.lblUnitID.TabIndex = 79;
			this.lblUnitID.Text = "Unit ID";
			this.lblUnitID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtXMComment
			// 
			this.txtXMComment.AccessibleDescription = "comment";
			this.txtXMComment.AccessibleName = "comment";
			this.txtXMComment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtXMComment.Location = new System.Drawing.Point(72, 176);
			this.txtXMComment.Name = "txtXMComment";
			this.txtXMComment.ReadOnly = true;
			this.txtXMComment.Size = new System.Drawing.Size(256, 20);
			this.txtXMComment.TabIndex = 76;
			this.txtXMComment.Text = "";
			// 
			// lblXMComment
			// 
			this.lblXMComment.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblXMComment.Location = new System.Drawing.Point(4, 176);
			this.lblXMComment.Name = "lblXMComment";
			this.lblXMComment.Size = new System.Drawing.Size(76, 20);
			this.lblXMComment.TabIndex = 78;
			this.lblXMComment.Text = "Comment";
			this.lblXMComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtXMInterp
			// 
			this.txtXMInterp.AccessibleDescription = "crossmatch interpretation";
			this.txtXMInterp.AccessibleName = "crossmatch interpretation";
			this.txtXMInterp.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtXMInterp.Location = new System.Drawing.Point(72, 152);
			this.txtXMInterp.Name = "txtXMInterp";
			this.txtXMInterp.ReadOnly = true;
			this.txtXMInterp.Size = new System.Drawing.Size(256, 20);
			this.txtXMInterp.TabIndex = 75;
			this.txtXMInterp.Text = "";
			// 
			// lvXM
			// 
			this.lvXM.AccessibleDescription = "crossmatch tests";
			this.lvXM.AccessibleName = "crossmatch tests";
			this.lvXM.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvXM.BackColor = System.Drawing.SystemColors.Control;
			this.lvXM.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																				   this.columnHeader20,
																				   this.columnHeader21});
			this.lvXM.FullRowSelect = true;
			this.lvXM.Location = new System.Drawing.Point(4, 52);
			this.lvXM.MultiSelect = false;
			this.lvXM.Name = "lvXM";
			this.lvXM.Size = new System.Drawing.Size(324, 96);
			this.lvXM.TabIndex = 74;
			this.lvXM.View = System.Windows.Forms.View.Details;
			this.lvXM.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.TestResultsListView_ColumnClick);
			// 
			// columnHeader20
			// 
			this.columnHeader20.Text = "Phase";
			// 
			// columnHeader21
			// 
			this.columnHeader21.Text = "Result";
			this.columnHeader21.Width = 150;
			// 
			// lblXMInterp
			// 
			this.lblXMInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblXMInterp.Location = new System.Drawing.Point(4, 152);
			this.lblXMInterp.Name = "lblXMInterp";
			this.lblXMInterp.Size = new System.Drawing.Size(72, 20);
			this.lblXMInterp.TabIndex = 77;
			this.lblXMInterp.Text = "Interpretation";
			this.lblXMInterp.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pnlABORh
			// 
			this.pnlABORh.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlABORh.Controls.Add(this.lvABORh);
			this.pnlABORh.Controls.Add(this.txtRhComment);
			this.pnlABORh.Controls.Add(this.lblRhComment);
			this.pnlABORh.Controls.Add(this.txtRhInterp);
			this.pnlABORh.Controls.Add(this.lblRhInterp);
			this.pnlABORh.Controls.Add(this.txtABOComment);
			this.pnlABORh.Controls.Add(this.lblABOComment);
			this.pnlABORh.Controls.Add(this.txtABOInterp);
			this.pnlABORh.Controls.Add(this.lblABOInterp);
			this.pnlABORh.Location = new System.Drawing.Point(4, 84);
			this.pnlABORh.Name = "pnlABORh";
			this.pnlABORh.Size = new System.Drawing.Size(332, 200);
			this.pnlABORh.TabIndex = 10;
			this.pnlABORh.TabStop = true;
			// 
			// lvABORh
			// 
			this.lvABORh.AccessibleDescription = "A B O R H";
			this.lvABORh.AccessibleName = "A B O R H";
			this.lvABORh.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvABORh.BackColor = System.Drawing.SystemColors.Control;
			this.lvABORh.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					  this.columnHeader13,
																					  this.columnHeader14,
																					  this.columnHeader15});
			this.lvABORh.FullRowSelect = true;
			this.lvABORh.Location = new System.Drawing.Point(4, 4);
			this.lvABORh.MultiSelect = false;
			this.lvABORh.Name = "lvABORh";
			this.lvABORh.Size = new System.Drawing.Size(324, 142);
			this.lvABORh.TabIndex = 10;
			this.lvABORh.View = System.Windows.Forms.View.Details;
			this.lvABORh.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.TestResultsListView_ColumnClick);
			// 
			// columnHeader13
			// 
			this.columnHeader13.Text = "Tested With";
			this.columnHeader13.Width = 140;
			// 
			// columnHeader14
			// 
			this.columnHeader14.Text = "Phase";
			// 
			// columnHeader15
			// 
			this.columnHeader15.Text = "Result";
			this.columnHeader15.Width = 150;
			// 
			// txtRhComment
			// 
			this.txtRhComment.AccessibleDescription = "R H comment";
			this.txtRhComment.AccessibleName = "R H comment";
			this.txtRhComment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtRhComment.Location = new System.Drawing.Point(160, 176);
			this.txtRhComment.Name = "txtRhComment";
			this.txtRhComment.ReadOnly = true;
			this.txtRhComment.Size = new System.Drawing.Size(168, 20);
			this.txtRhComment.TabIndex = 14;
			this.txtRhComment.Text = "";
			// 
			// lblRhComment
			// 
			this.lblRhComment.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblRhComment.Location = new System.Drawing.Point(108, 176);
			this.lblRhComment.Name = "lblRhComment";
			this.lblRhComment.Size = new System.Drawing.Size(56, 20);
			this.lblRhComment.TabIndex = 34;
			this.lblRhComment.Text = "Comment";
			this.lblRhComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtRhInterp
			// 
			this.txtRhInterp.AccessibleDescription = "R H Interpretation";
			this.txtRhInterp.AccessibleName = "R H Interpretation";
			this.txtRhInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.txtRhInterp.Location = new System.Drawing.Point(52, 176);
			this.txtRhInterp.Name = "txtRhInterp";
			this.txtRhInterp.ReadOnly = true;
			this.txtRhInterp.Size = new System.Drawing.Size(48, 20);
			this.txtRhInterp.TabIndex = 13;
			this.txtRhInterp.Text = "";
			// 
			// lblRhInterp
			// 
			this.lblRhInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblRhInterp.Location = new System.Drawing.Point(4, 176);
			this.lblRhInterp.Name = "lblRhInterp";
			this.lblRhInterp.Size = new System.Drawing.Size(44, 20);
			this.lblRhInterp.TabIndex = 33;
			this.lblRhInterp.Text = "Rh";
			this.lblRhInterp.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtABOComment
			// 
			this.txtABOComment.AccessibleDescription = "comment";
			this.txtABOComment.AccessibleName = "comment";
			this.txtABOComment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtABOComment.Location = new System.Drawing.Point(160, 152);
			this.txtABOComment.Name = "txtABOComment";
			this.txtABOComment.ReadOnly = true;
			this.txtABOComment.Size = new System.Drawing.Size(168, 20);
			this.txtABOComment.TabIndex = 12;
			this.txtABOComment.Text = "";
			// 
			// lblABOComment
			// 
			this.lblABOComment.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblABOComment.Location = new System.Drawing.Point(108, 152);
			this.lblABOComment.Name = "lblABOComment";
			this.lblABOComment.Size = new System.Drawing.Size(56, 20);
			this.lblABOComment.TabIndex = 32;
			this.lblABOComment.Text = "Comment";
			this.lblABOComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtABOInterp
			// 
			this.txtABOInterp.AccessibleDescription = "A B O Interpretation";
			this.txtABOInterp.AccessibleName = "A B O Interpretation";
			this.txtABOInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.txtABOInterp.Location = new System.Drawing.Point(52, 152);
			this.txtABOInterp.Name = "txtABOInterp";
			this.txtABOInterp.ReadOnly = true;
			this.txtABOInterp.Size = new System.Drawing.Size(48, 20);
			this.txtABOInterp.TabIndex = 11;
			this.txtABOInterp.Text = "";
			// 
			// lblABOInterp
			// 
			this.lblABOInterp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblABOInterp.Location = new System.Drawing.Point(4, 152);
			this.lblABOInterp.Name = "lblABOInterp";
			this.lblABOInterp.Size = new System.Drawing.Size(44, 20);
			this.lblABOInterp.TabIndex = 31;
			this.lblABOInterp.Text = "ABO";
			this.lblABOInterp.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pnlAID
			// 
			this.pnlAID.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlAID.Controls.Add(this.lvAID);
			this.pnlAID.Controls.Add(this.txtIDComment);
			this.pnlAID.Controls.Add(this.lblAIDComment);
			this.pnlAID.Location = new System.Drawing.Point(4, 84);
			this.pnlAID.Name = "pnlAID";
			this.pnlAID.Size = new System.Drawing.Size(332, 200);
			this.pnlAID.TabIndex = 10;
			this.pnlAID.TabStop = true;
			// 
			// lvAID
			// 
			this.lvAID.AccessibleDescription = "Antibody I D";
			this.lvAID.AccessibleName = "Antibody I D";
			this.lvAID.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvAID.BackColor = System.Drawing.SystemColors.Control;
			this.lvAID.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					this.columnHeader32});
			this.lvAID.FullRowSelect = true;
			this.lvAID.Location = new System.Drawing.Point(4, 4);
			this.lvAID.MultiSelect = false;
			this.lvAID.Name = "lvAID";
			this.lvAID.Size = new System.Drawing.Size(324, 166);
			this.lvAID.TabIndex = 74;
			this.lvAID.View = System.Windows.Forms.View.Details;
			this.lvAID.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.TestResultsListView_ColumnClick);
			// 
			// columnHeader32
			// 
			this.columnHeader32.Text = "Antibody Identified";
			this.columnHeader32.Width = 320;
			// 
			// txtIDComment
			// 
			this.txtIDComment.AccessibleDescription = "comment";
			this.txtIDComment.AccessibleName = "comment";
			this.txtIDComment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtIDComment.Location = new System.Drawing.Point(72, 176);
			this.txtIDComment.Name = "txtIDComment";
			this.txtIDComment.ReadOnly = true;
			this.txtIDComment.Size = new System.Drawing.Size(256, 20);
			this.txtIDComment.TabIndex = 35;
			this.txtIDComment.Text = "";
			// 
			// lblAIDComment
			// 
			this.lblAIDComment.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblAIDComment.Location = new System.Drawing.Point(4, 176);
			this.lblAIDComment.Name = "lblAIDComment";
			this.lblAIDComment.Size = new System.Drawing.Size(68, 20);
			this.lblAIDComment.TabIndex = 37;
			this.lblAIDComment.Text = "Comment";
			this.lblAIDComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.CausesValidation = false;
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(666, 412);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "&Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// grpImage
			// 
			this.grpImage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.grpImage.Controls.Add(this.picImage);
			this.grpImage.Location = new System.Drawing.Point(4, 64);
			this.grpImage.Name = "grpImage";
			this.grpImage.Size = new System.Drawing.Size(40, 312);
			this.grpImage.TabIndex = 1;
			this.grpImage.TabStop = false;
			// 
			// picImage
			// 
			this.picImage.Image = ((System.Drawing.Image)(resources.GetObject("picImage.Image")));
			this.picImage.Location = new System.Drawing.Point(2, 12);
			this.picImage.Name = "picImage";
			this.picImage.Size = new System.Drawing.Size(30, 32);
			this.picImage.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.picImage.TabIndex = 1;
			this.picImage.TabStop = false;
			// 
			// patientSpecimenSelector1
			// 
			this.patientSpecimenSelector1.AcceptableOnlySpecimen = false;
			this.patientSpecimenSelector1.AccessibleDescription = "Patient Specimen Selector";
			this.patientSpecimenSelector1.AccessibleName = "Patient Specimen Selector";
			this.patientSpecimenSelector1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.patientSpecimenSelector1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.patientSpecimenSelector1.Location = new System.Drawing.Point(4, 0);
			this.patientSpecimenSelector1.Name = "patientSpecimenSelector1";
			this.patientSpecimenSelector1.Patient = null;
			this.patientSpecimenSelector1.Size = new System.Drawing.Size(734, 376);
			this.patientSpecimenSelector1.Specimen = null;
			this.patientSpecimenSelector1.TabIndex = 0;
			this.patientSpecimenSelector1.ItemSelected += new System.EventHandler(this.patientSpecimenSelector1_ItemSelected);
			this.patientSpecimenSelector1.ItemDeselected += new System.EventHandler(this.patientSpecimenSelector1_ItemDeselected);
			// 
			// pnlSpecimenSelect
			// 
			this.pnlSpecimenSelect.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlSpecimenSelect.Controls.Add(this.patientSpecimenSelector1);
			this.pnlSpecimenSelect.Location = new System.Drawing.Point(0, 32);
			this.pnlSpecimenSelect.Name = "pnlSpecimenSelect";
			this.pnlSpecimenSelect.Size = new System.Drawing.Size(742, 376);
			this.pnlSpecimenSelect.TabIndex = 10;
			this.pnlSpecimenSelect.TabStop = true;
			// 
			// btnOKSpecimen
			// 
			this.btnOKSpecimen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOKSpecimen.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnOKSpecimen.Image = null;
			this.btnOKSpecimen.Location = new System.Drawing.Point(586, 412);
			this.btnOKSpecimen.Name = "btnOKSpecimen";
			this.btnOKSpecimen.Size = new System.Drawing.Size(75, 23);
			this.btnOKSpecimen.TabIndex = 1;
			this.btnOKSpecimen.Click += new System.EventHandler(this.btnOKSpecimen_Click);
			// 
			// pnlTestResults
			// 
			this.pnlTestResults.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlTestResults.Controls.Add(this.grpImage);
			this.pnlTestResults.Controls.Add(this.pnlTests);
			this.pnlTestResults.Controls.Add(this.patientSpecimenDisplayPanel1);
			this.pnlTestResults.Location = new System.Drawing.Point(0, 32);
			this.pnlTestResults.Name = "pnlTestResults";
			this.pnlTestResults.Size = new System.Drawing.Size(742, 376);
			this.pnlTestResults.TabIndex = 10;
			this.pnlTestResults.TabStop = true;
			this.pnlTestResults.Visible = false;
			// 
			// pnlTests
			// 
			this.pnlTests.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlTests.Controls.Add(this.grpSelectedTest);
			this.pnlTests.Controls.Add(this.splitter1);
			this.pnlTests.Controls.Add(this.grpPatientTestResults);
			this.pnlTests.Location = new System.Drawing.Point(48, 64);
			this.pnlTests.Name = "pnlTests";
			this.pnlTests.Size = new System.Drawing.Size(688, 312);
			this.pnlTests.TabIndex = 10;
			this.pnlTests.TabStop = true;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(344, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(4, 312);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// patientSpecimenDisplayPanel1
			// 
			this.patientSpecimenDisplayPanel1.AboRh = "";
			this.patientSpecimenDisplayPanel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.patientSpecimenDisplayPanel1.EnabledBloodAvailButton = false;
			this.patientSpecimenDisplayPanel1.EnabledMedicationButton = false;
			this.patientSpecimenDisplayPanel1.EnabledRecentOrdersButton = false;
			this.patientSpecimenDisplayPanel1.EnabledRecentTransfusionsIssuesButton = false;
			this.patientSpecimenDisplayPanel1.EnabledSIAndTRButton = false;
			this.patientSpecimenDisplayPanel1.EnabledTransfusionReactionHistoryButton = false;
			this.patientSpecimenDisplayPanel1.Expires = "";
			this.patientSpecimenDisplayPanel1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.patientSpecimenDisplayPanel1.Location = new System.Drawing.Point(4, -4);
			this.patientSpecimenDisplayPanel1.Name = "patientSpecimenDisplayPanel1";
			this.patientSpecimenDisplayPanel1.Patient = null;
			this.patientSpecimenDisplayPanel1.PatientID = "";
			this.patientSpecimenDisplayPanel1.PatientName = "";
			this.patientSpecimenDisplayPanel1.Size = new System.Drawing.Size(734, 68);
			this.patientSpecimenDisplayPanel1.Specimen = null;
			this.patientSpecimenDisplayPanel1.SpecimenID = "";
			this.patientSpecimenDisplayPanel1.TabIndex = 0;
			// 
			// FrmInvalidatePatientTestResults
			// 
			this.AcceptButton = this.btnOKSpecimen;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(744, 444);
			this.Controls.Add(this.pnlSpecimenSelect);
			this.Controls.Add(this.pnlTestResults);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOKSpecimen);
			this.hlphelpChm.SetHelpKeyword(this, "Invalidate_Test_Results.htm");
			this.hlphelpChm.SetHelpNavigator(this, System.Windows.Forms.HelpNavigator.Topic);
			this.MinimumSize = new System.Drawing.Size(752, 471);
			this.Name = "FrmInvalidatePatientTestResults";
			this.RequiredFieldsLabel = true;
			this.hlphelpChm.SetShowHelp(this, true);
			this.Text = "VBECS - Invalidate Patient Test Results";
			this.KeyDownSpeakMessage += new gov.va.med.vbecs.GUI.VbecsBaseForm.KeyDownSpeakMessageEventHandler(this.FrmInvalidatePatientTestResults_KeyDownSpeakMessage);
			this.Controls.SetChildIndex(this.btnOKSpecimen, 0);
			this.Controls.SetChildIndex(this.btnCancel, 0);
			this.Controls.SetChildIndex(this.vbecsLogo1, 0);
			this.Controls.SetChildIndex(this.lblRequiredField, 0);
			this.Controls.SetChildIndex(this.pnlTestResults, 0);
			this.Controls.SetChildIndex(this.pnlSpecimenSelect, 0);
			this.grpPatientTestResults.ResumeLayout(false);
			this.grpSelectedTest.ResumeLayout(false);
			this.pnlTest.ResumeLayout(false);
			this.pnlTRW.ResumeLayout(false);
			this.pnlXM.ResumeLayout(false);
			this.pnlABORh.ResumeLayout(false);
			this.pnlAID.ResumeLayout(false);
			this.grpImage.ResumeLayout(false);
			this.pnlSpecimenSelect.ResumeLayout(false);
			this.pnlTestResults.ResumeLayout(false);
			this.pnlTests.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void SetComponentProperties()
		{
			this.vbecsLogo1.Title = this.Text.Replace("VBECS - ","");
			// CR 2693
			// hlpHelp
			// 
			this.hlpHelp.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
			// 
			// hlphelpChm
			// 
			this.hlphelpChm.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
			//
			this.SetThisHelpFile(this, Common.StrRes.HelpFiles.UC094.FrmInvalidatePatientTestResults());
			//
			//this.btnSearch.EnabledButton = false;
			//this.btnSearch.Text = "&Search";
			this.btnOKSpecimen.Text = "&OK";
			this.btnOKSpecimen.EnabledButton = false;
			//
			this.btnInvalidate.EnabledButton = false;
			this.btnInvalidate.Text = "&Invalidate Results";
			
			this.patientSpecimenSelector1.AcceptableOnlySpecimen = true;
			this.pnlSpecimenSelect.Visible = true;
			this.pnlTestResults.Visible = false;
			//
			this.ClearTestResults();
		}

		private bool LoadSpecimenTests(System.Data.DataTable specimenTests)
		{
			this._transfusedUnits = BOL.PatientTransfusion.GetTransfusionHistoryForPatientSpecimen(this._specimen.SpecimenGuid);
			//
			this.lvPatientTestResults.Items.Clear();
			foreach(System.Data.DataRow test in specimenTests.Rows)
			{
				ListViewItem lvi = new ListViewItem();
				lvi.Tag = test;
				lvi.Text = test[Common.VbecsTables.OrderableTest.OrderableTestText].ToString();
				if (((int)test[Common.VbecsTables.OrderableTest.OrderableTestId] == (int)Common.OrderableTest.ABID) ||
					((int)test[Common.VbecsTables.OrderableTest.OrderableTestId] == (int)Common.OrderableTest.RepeatABID))
				{
					if (test.IsNull(Common.VbecsTables.AntibodyType.AntibodyTypeName))
					{
						lvi.SubItems.Add("None identified");
					}
					else
					{
						lvi.SubItems.Add(test[Common.VbecsTables.AntibodyType.AntibodyTypeName].ToString());
					}
				}
				else
				{
					lvi.SubItems.Add(test["Interp"].ToString());
				}
				lvi.SubItems.Add(Common.VBECSDateTime.FormatDateTimeString(test[Common.VbecsTables.SpecimenTest.TestDate]));
				if (((int)test[Common.VbecsTables.OrderableTest.OrderableTestId] == (int)Common.OrderableTest.XM) ||
					((int)test[Common.VbecsTables.OrderableTest.OrderableTestId] == (int)Common.OrderableTest.RepeatXM))
				{
					lvi.SubItems.Add(test[Common.VbecsTables.BloodUnit.EyeReadableUnitId].ToString());
				}
				//
				this.lvPatientTestResults.Items.Add(lvi);
			}
			//
			controls.VbecsFunction.SetColumnWidths(this.lvPatientTestResults);
			return true;
		}

		private void LoadABORhTestResults(System.Data.DataRow aboRhTest)
		{
			this.pnlABORh.BringToFront();
			//
			if (aboRhTest.IsNull(Common.VbecsTables.BloodTestType.ReportableTestId))
			{
				this._selectedTests = BOL.OrderedTest.GetSpecimenTestResultsForOrderedTest((Guid)aboRhTest[Common.VbecsTables.SpecimenTest.OrderedTestGuid]);
			}
			else
			{
				this._selectedTests = BOL.OrderedTest.GetSpecimenTestResultsForOrderedTest((Guid)aboRhTest[Common.VbecsTables.OrderedTest.OrderedTestGuid], (int)aboRhTest[Common.VbecsTables.BloodTestType.ReportableTestId]);
			}
			//
			this.lvABORh.Items.Clear();
			//
			foreach(BOL.SpecimenTest test in this._selectedTests)
			{
				if (test.BloodTestType.BloodTestName.ToString().IndexOf("ABO Interp")>-1)
				{
					this.LoadTestDetails(test);
					this.txtABOInterp.Text = test.TestResult.TestResultText;
					this.txtABOComment.Text = test.TestComments;
					continue;
				}
				//
				if (test.BloodTestType.BloodTestName.ToString().IndexOf("Rh Interp")>-1)
				{
					this.txtRhInterp.Text = test.TestResult.TestResultText;
					this.txtRhComment.Text = test.TestComments;
					continue;
				}
				//
				ListViewItem lvi = new ListViewItem();
				//
				lvi.Text = test.BloodTestType.TestedWith;
				lvi.SubItems.Add(test.BloodTestType.Phase);
				if (test.TestResult != null)
				{
					lvi.SubItems.Add(test.TestResult.TestResultText);
				}
				else
				{
					lvi.SubItems.Add(string.Empty);
				}
				//
				this.lvABORh.Items.Add(lvi);
			}
			this._selectedUnit = null;
			//
			controls.VbecsFunction.SetColumnWidths(this.lvABORh);
			//
		}

		private void LoadCrossmatchTestResults(System.Data.DataRow xmTest)
		{
			this.pnlXM.BringToFront();
			//
			this._selectedTests = BOL.OrderedComponent.GetBloodUnitTestResultsForOrderedComponent((Guid)xmTest[Common.VbecsTables.BloodUnitTest.OrderedComponentGuid],(Guid)xmTest[Common.VbecsTables.BloodUnitTest.BloodUnitGuid]);
			//
			this.lvXM.Items.Clear();
			//
			foreach(BOL.BloodUnitTest test in this._selectedTests)
			{
				if (test.BloodTestTypeObj.BloodTestName.IndexOf(" Interp")>-1)
				{
					this.LoadTestDetails(test);
					this._selectedUnit = new BOL.BloodUnit(test.BloodUnitGuid);
					this.txtUnitID.Text = this._selectedUnit.EyeReadableUnitId;
					this.txtProduct.Text = this._selectedUnit.ProductShortName+", "+this._selectedUnit.FullProductCode;
					this.txtXMComment.Text = test.TestComments;
					this.txtXMInterp.Text = test.TestResult.TestResultText;
					continue;
				}
				//
				ListViewItem lvi = new ListViewItem();
				//
				lvi.Text = test.BloodTestTypeObj.Phase;
				if (test.TestResult != null)
				{
					lvi.SubItems.Add(test.TestResult.TestResultText);
				}
				else
				{
					lvi.SubItems.Add(string.Empty);
				}
				//
				this.lvXM.Items.Add(lvi);
			}
			//
			controls.VbecsFunction.SetColumnWidths(this.lvXM);
			//
		}

		private void LoadRepeatCrossmatchTestResults(System.Data.DataRow xmTest)
		{
			this.pnlXM.BringToFront();
			//
			this._selectedTests = BOL.OrderedTest.GetBloodUnitTestResultsForOrderedTest((Guid)xmTest[Common.VbecsTables.BloodUnitTest.OrderedTestGuid],(Guid)xmTest[Common.VbecsTables.BloodUnitTest.BloodUnitGuid]);
			//
			this.lvXM.Items.Clear();
			//
			foreach(BOL.BloodUnitTest test in this._selectedTests)
			{
				if (test.BloodTestTypeObj.BloodTestName.IndexOf(" Interp")>-1)
				{
					this.LoadTestDetails(test);
					this._selectedUnit = new BOL.BloodUnit(test.BloodUnitGuid);
					this.txtUnitID.Text = this._selectedUnit.EyeReadableUnitId;
					this.txtProduct.Text = this._selectedUnit.ProductShortName+", "+this._selectedUnit.FullProductCode;
					this.txtXMComment.Text = test.TestComments;
					this.txtXMInterp.Text = test.TestResult.TestResultText;
					continue;
				}
				//
				ListViewItem lvi = new ListViewItem();
				//
				lvi.Text = test.BloodTestTypeObj.Phase;
				lvi.SubItems.Add(test.TestResult.TestResultText);
				//
				this.lvXM.Items.Add(lvi);
			}
			//
			controls.VbecsFunction.SetColumnWidths(this.lvXM);
			//
		}

		private void LoadAntibodyIDTestResults(System.Data.DataRow abidTest)
		{
			this.pnlAID.BringToFront();
			//
			this._selectedTests = BOL.OrderedTest.GetSpecimenTestResultsForOrderedTest((Guid)abidTest[Common.VbecsTables.SpecimenTest.OrderedTestGuid]);
			//
			this.lvAID.Items.Clear();
			//
			foreach(BOL.SpecimenTest test in this._selectedTests)
			{
				this.LoadTestDetails(test);
				this.txtIDComment.Text = test.TestComments;
				//
				ListViewItem lvi = new ListViewItem();
				//
				if (test.AntibodyType != null)
				{
					lvi.Text = test.AntibodyType.AntibodyTypeName;
				}
				else
				{
					lvi.Text = "None identified";
				}
				//
				this.lvAID.Items.Add(lvi);
			}
			this._selectedUnit = null;
			//
			controls.VbecsFunction.SetColumnWidths(this.lvAID);
			//
		}

		private void LoadTransfusionReactionWorkup(System.Data.DataRow trw)
		{
			this.pnlTRW.BringToFront();
			//
			this._patientTransfusionReaction = new BOL.PatientTransfusionReaction((Guid)trw[Common.VbecsTables.OrderedTest.OrderedTestGuid]);
			BOL.OrderedTest orderedTest = new BOL.OrderedTest((Guid)trw[Common.VbecsTables.OrderedTest.OrderedTestGuid],(Guid)trw[Common.VbecsTables.PatientOrder.PatientOrderGuid]);
			BOL.Specimen preSpecimen = null;
			BOL.Specimen postSpecimen = null;
			if (this._patientTransfusionReaction.PreSpecimenNotAvailableIndicator)
			{
				this.txtTRWPreSpecimen.Text = "Not available";
			}
			else
			{
				if (this._patientTransfusionReaction.PreSpecimenGuid != Guid.Empty)
				{
					preSpecimen = new BOL.Specimen(this._patientTransfusionReaction.PreSpecimenGuid);
					this.txtTRWPreSpecimen.Text = preSpecimen.SpecimenUid;
				}
			}
			//
			if (this._patientTransfusionReaction.PostSpecimenNotAvailableIndicator)
			{
				this.txtTRWPostSpecimen.Text = "Not available";
			}
			else
			{
				if (this._patientTransfusionReaction.PostSpecimenGuid != Guid.Empty)
				{
					postSpecimen = new BOL.Specimen(this._patientTransfusionReaction.PostSpecimenGuid);
					this.txtTRWPostSpecimen.Text = postSpecimen.SpecimenUid;
				}
			}
			//
			this.lvImplicatedUnits.Items.Clear();
			ArrayList implicatedUnits = this._patientTransfusionReaction.GetImplicatedTransfusionRecords();
			//
			foreach(BOL.BloodUnit unit in implicatedUnits)
			{
				ListViewItem lvi = new ListViewItem();
				lvi.Text = unit.EyeReadableUnitId;
				lvi.SubItems.Add(unit.ProductShortName);
				lvi.SubItems.Add(unit.BloodUnitMedia.AboRh.AboRHText);
				lvi.SubItems.Add(Common.VBECSDateTime.FormatDateTimeString(unit.BloodUnitMedia.UnitExpirationDate));
				this.lvImplicatedUnits.Items.Add(lvi);
			}
			controls.VbecsFunction.SetColumnWidths(this.lvImplicatedUnits);
			//
			this.lvTRWTests.Items.Clear();
			_trwSpecimenTests = this._patientTransfusionReaction.GetSerologicSpecimenTests();
			_trwBloodUnitTests = this._patientTransfusionReaction.GetSerologicBloodUnitTests();
			//
			//
			if (_trwSpecimenTests.Count>0)
			{
				LoadTestDetails(new BOL.SpecimenTest((DataRow)_trwSpecimenTests[0]));
			}
			else if (_trwBloodUnitTests.Count>0)
			{
				foreach(DataRow dr in _trwBloodUnitTests)
				{
					if ((Guid)dr[Common.VbecsTables.PatientTransfusionReaction.PatientTransfusionReactionGuid] == this._patientTransfusionReaction.PatientTransfusionReactionGuid)
					{
						LoadTestDetails(new BOL.SpecimenTest((DataRow)_trwBloodUnitTests[0]));
						break;
					}
				}
			}
			//
			foreach(DataRow dr in _trwSpecimenTests)
			{
				ListViewItem lvi = new ListViewItem();
				lvi.Text = dr[Common.VbecsTables.BloodTestType.BloodTestName].ToString();
				if ((preSpecimen != null) && (this._patientTransfusionReaction.PreSpecimenGuid == (Guid)dr[Common.VbecsTables.PatientSpecimen.PatientSpecimenGuid]))
				{
					lvi.SubItems.Add("Pre ("+preSpecimen.SpecimenUid+")");
				}
				else if ((postSpecimen != null) && (this._patientTransfusionReaction.PostSpecimenGuid == (Guid)dr[Common.VbecsTables.PatientSpecimen.PatientSpecimenGuid]))
				{
					lvi.SubItems.Add("Post ("+postSpecimen.SpecimenUid+")");
				}
				else
				{
					lvi.SubItems.Add("Unknown Specimen");
				}
				lvi.SubItems.Add(dr[Common.VbecsTables.TestResult.TestResultText].ToString());
				this.lvTRWTests.Items.Add(lvi);
			}
			//
			foreach(DataRow dr in _trwBloodUnitTests)
			{
				if ((Guid)dr[Common.VbecsTables.PatientTransfusionReaction.PatientTransfusionReactionGuid] == this._patientTransfusionReaction.PatientTransfusionReactionGuid)
				{
					ListViewItem lvi = new ListViewItem();
					lvi.Text = dr[Common.VbecsTables.BloodTestType.BloodTestName].ToString();
					lvi.SubItems.Add(dr[Common.VbecsTables.BloodUnit.EyeReadableUnitId].ToString());
					lvi.SubItems.Add(dr[Common.VbecsTables.TestResult.TestResultText].ToString());
					this.lvTRWTests.Items.Add(lvi);
				}
			}
			controls.VbecsFunction.SetColumnWidths(this.lvTRWTests);
			//
			//this.txtTRWType.Text = this._patientTransfusionReaction.TransfusionReactionTypeText;
			//
			this._selectedUnit = null;
		}

		private void LoadPatientTestResults(System.Data.DataRow patientTest)
		{
			this.pnlTest.BringToFront();
			//
			if (patientTest.IsNull("ReportableTestId"))
			{
				this._selectedTests = BOL.OrderedTest.GetSpecimenTestResultsForOrderedTest((Guid)patientTest[Common.VbecsTables.SpecimenTest.OrderedTestGuid]);
			}
			else
			{
				this._selectedTests = BOL.OrderedTest.GetSpecimenTestResultsForOrderedTest((Guid)patientTest[Common.VbecsTables.SpecimenTest.OrderedTestGuid], (int)patientTest[Common.VbecsTables.BloodTestType.ReportableTestId]);
			}
			//
			this.lvTest.Items.Clear();
			//
			foreach(BOL.SpecimenTest test in this._selectedTests)
			{
				//Load interp into separate text box. 
				//There may be two interps (for ABS with DAT),
				//so check the orderable test ID first.
				if ((test.BloodTestType.BloodTestName.ToString().IndexOf(" Interp")>-1)&&
					(test.BloodTestType.OrderableTestId == (int)patientTest[Common.VbecsTables.OrderedTest.OrderableTestId]))
				{
					this.LoadTestDetails(test);
					this.txtTestInterp.Text = test.TestResult.TestResultText;
					this.txtTestComment.Text = test.TestComments;
					continue;
				}
				//
				ListViewItem lvi = new ListViewItem();
				//
				lvi.Text = test.BloodTestType.TestedWith;
				lvi.SubItems.Add(test.BloodTestType.Phase);
				if (test.TestResult != null)
				{
					lvi.SubItems.Add(test.TestResult.TestResultText);
				}
				else
				{
					lvi.SubItems.Add(string.Empty);
				}
				//
				this.lvTest.Items.Add(lvi);
			}
			this._selectedUnit = null;
			//
			controls.VbecsFunction.SetColumnWidths(this.lvTest);
			//
		}

		private void LoadTestDetails(BOL.SpecimenTest testDetails)
		{
			this.txtDateTested.Text = Common.VBECSDateTime.FormatDateTimeString(testDetails.TestDate);
			this.txtTestedBy.Text = testDetails.TestTechId;
			if (testDetails.Rack != null)
			{
				this.txtRack.Text = testDetails.Rack.RackName;
			}
			else
			{
				this.txtRack.Text = "";
			}
			if (testDetails.TestingMethod != null)
			{
				this.txtTestingMethod.Text = testDetails.TestingMethod.TestingMethodText;
			}
			else
			{
				this.txtTestingMethod.Text = "";
			}
			this.txtInstrumentName.Text = testDetails.AutoInstrumentName;
		}

		private void LoadTestDetails(BOL.BloodUnitTest testDetails)
		{
			this.txtDateTested.Text = Common.VBECSDateTime.FormatDateTimeString(testDetails.TestDate);
			this.txtTestedBy.Text = testDetails.TestTechId;
			if (testDetails.Rack != null)
			{
				this.txtRack.Text = testDetails.Rack.RackName;
			}
			else
			{
				this.txtRack.Text = "";
			}
			if (testDetails.TestingMethod != null)
			{
				this.txtTestingMethod.Text = testDetails.TestingMethod.TestingMethodText;
			}
			else
			{
				this.txtTestingMethod.Text = "";
			}
			this.txtInstrumentName.Text = "";
		}

		private void ClearTestResults()
		{
			this.txtDateTested.Text = "";
			this.txtTestedBy.Text = "";
			this.txtRack.Text = "";
			this.txtTestingMethod.Text = "";
			this.txtInstrumentName.Text = "";
			this.pnlTest.BringToFront();
			this.lvTest.Items.Clear();
			this.txtTestComment.Text = "";
			this.txtTestInterp.Text = "";
			this.btnInvalidate.EnabledButton = false;
			//this._orderableTestId = 0;
			this._orderedTest = null;
			this._selectedUnit = null;
		}

		private void patientSpecimenSelector1_ItemDeselected(object sender, System.EventArgs e)
		{
			this._specimen = null;
			btnOKSpecimen.EnabledButton = false;
		}

		private void patientSpecimenSelector1_ItemSelected(object sender, System.EventArgs e)
		{
			this._specimen = this.patientSpecimenSelector1.Specimen;
			this.btnOKSpecimen.EnabledButton = (this._specimen != null);
		}

		private void btnOKSpecimen_Click(object sender, System.EventArgs e)
		{
			DataTable specimenTests = BOL.OrderedTest.GetTestOrders(this._specimen.SpecimenGuid);

			if (specimenTests.Rows.Count > 0)
			{
				//Grab the patient lock first, since we know it
				if (!this.SetLocks(this._specimen.Patient.PatientGuid))
					return;

				this.LoadSpecimenTests(specimenTests);
				this.pnlSpecimenSelect.Visible = false;
				this.btnOKSpecimen.Visible = false;
				//
				this.patientSpecimenDisplayPanel1.Specimen = this._specimen;
				this.pnlTestResults.Visible = true;
				//
			}
			else
			{
				GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.NoCompletedTests());
			}
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void lvPatientTestResults_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//Since we're locking in the listview, we have to make sure we unlock any previous selections
			this.RemoveCurrentTestLocks();

			if (this.lvPatientTestResults.SelectedItems.Count>0)
			{
				System.Data.DataRow dr = (System.Data.DataRow)this.lvPatientTestResults.SelectedItems[0].Tag;
				//
				using (new WaitCursor())
				{
					if (!dr.IsNull(Common.VbecsTables.OrderedTest.OrderedTestGuid))
					{
						this._orderedTest = new BOL.OrderedTest((Guid)dr[Common.VbecsTables.OrderedTest.OrderedTestGuid],(Guid)dr[Common.VbecsTables.OrderedTest.PatientOrderGuid]);
					}
					else if (!dr.IsNull(Common.VbecsTables.OrderedComponent.OrderedComponentGuid))
					{
						//XM tests are not from ordered tests, but we can pretend they are for our purposes!
						this._orderedTest = new BOL.OrderedTest(dr);
						this._orderedTest.OrderedTestGuid = (Guid)dr[Common.VbecsTables.OrderedComponent.OrderedComponentGuid];
					}
					//
					if (dr.IsNull(Common.VbecsTables.BloodTestType.ReportableTestId))
					{
						this._reportableTestId = 0;
					}
					else
					{
						this._reportableTestId = (int)dr[Common.VbecsTables.BloodTestType.ReportableTestId];
					}
					//
					if ((this._orderedTest.OrderableTestId == (int)Common.OrderableTest.ABORh)||
						(this._orderedTest.OrderableTestId == (int)Common.OrderableTest.RepeatABORh)||
						((this._orderedTest.OrderableTestId == (int)Common.OrderableTest.TAS) && ((int)dr[Common.VbecsTables.BloodTestType.ReportableTestId] == (int)Common.OrderableTest.ABORh)))
					{
						LoadABORhTestResults(dr);
						this.pnlABORh.Enabled = true;
						this.pnlTest.Enabled = false;
						this.pnlAID.Enabled = false;
						this.pnlTRW.Enabled = false;
						this.pnlXM.Enabled = false;
					}
					else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.XM)
					{
						LoadCrossmatchTestResults(dr);
						this.pnlABORh.Enabled = false;
						this.pnlTest.Enabled = false;
						this.pnlAID.Enabled = false;
						this.pnlTRW.Enabled = false;
						this.pnlXM.Enabled = true;
					}
					else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.RepeatXM)
					{
						LoadRepeatCrossmatchTestResults(dr);
						this.pnlABORh.Enabled = false;
						this.pnlTest.Enabled = false;
						this.pnlAID.Enabled = false;
						this.pnlTRW.Enabled = false;
						this.pnlXM.Enabled = true;
					}

					else if ((this._orderedTest.OrderableTestId == (int)Common.OrderableTest.ABID)||
						(this._orderedTest.OrderableTestId == (int)Common.OrderableTest.RepeatABID))
					{
						LoadAntibodyIDTestResults(dr);
						this.pnlABORh.Enabled = false;
						this.pnlTest.Enabled = false;
						this.pnlAID.Enabled = true;
						this.pnlTRW.Enabled = false;
						this.pnlXM.Enabled = false;
					}
					else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.TRW)
					{
						LoadTransfusionReactionWorkup(dr);
						this.pnlABORh.Enabled = false;
						this.pnlTest.Enabled = false;
						this.pnlAID.Enabled = false;
						this.pnlTRW.Enabled = true;
						this.pnlXM.Enabled = false;
					}
					else
					{
						LoadPatientTestResults(dr);
						this.pnlABORh.Enabled = false;
						this.pnlTest.Enabled = true;
						this.pnlAID.Enabled = false;
						this.pnlTRW.Enabled = false;
						this.pnlXM.Enabled = false;
					}
				}
				//
				CheckInvalidationAllowed(dr);

				//They're going to do something, so grab the locks
				//For now if this fails, it's not going to look pretty since all the grids load, then unload on conflict
				//To be "tweaked" with more time..
				if (!this.SetLocks(this.GetLockingGuids()))
					this.ClearTestResults();
			}
			else
			{
				ClearTestResults();
			}
		}

		/// <summary>
		/// BR_94.03, BR_94.11, BR_94.12
		/// </summary>
		/// <param name="selectedTest"></param>
		private void CheckInvalidationAllowed(DataRow selectedTest)
		{
			//BR_94.11
			if (this._transfusedUnits.Count>0)
			{
				if (((Common.OrderableTest)this._orderedTest.OrderableTestId == Common.OrderableTest.XM)||
					(((Common.OrderableTest)this._orderedTest.OrderableTestId == Common.OrderableTest.TAS)&&
					(((Common.OrderableTest)this._reportableTestId == Common.OrderableTest.ABORh) ||
					((Common.OrderableTest)this._reportableTestId == Common.OrderableTest.ABS))))
				{
					GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.TransfusedUnitsOnSpecimen());
					this.btnInvalidate.EnabledButton = false;
					return;
				}
			}
			//
			//BR_94.03
			if ( ((Common.OrderableTest)this._orderedTest.OrderableTestId == Common.OrderableTest.XM)||
				((Common.OrderableTest)this._orderedTest.OrderableTestId == Common.OrderableTest.RepeatXM))
			{
				if ((this._selectedUnit.BloodUnitStatus.UnitStatusCode == Common.UnitStatusCode.Issued) ||
					(this._selectedUnit.BloodUnitStatus.UnitStatusCode == Common.UnitStatusCode.Transfused))
				{
					GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.IssuedUnitCrossmatchResults());
					this.btnInvalidate.EnabledButton = false;
					return;
				}
			}
			else
			{
				if (this._specimen.HasAssignedUnits)
				{
					GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.AssociatedUnitsOnSpecimen());
					this.btnInvalidate.EnabledButton = false;
					return;
				}
			}
			//
			//BR_94.12
			if (Convert.ToBoolean(selectedTest[Common.VbecsTables.SpecimenTest.AboRhChangeIndicator]))
			{
				if (!ThisUser.IsAuthorized(Common.UserRoleType.TraditionalSupervisor))
				{
					GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.JustifiedAboRh());
					this.btnInvalidate.EnabledButton = false;
					return;
				}
				else
				{
					//Create new patient to force the AboRHHistory property to go to the database, in case any
					//ABO/Rh test results have been entered/invalidated since the option was first opened.
					BOL.Patient patient = new BOL.Patient(this._specimen.Patient.PatientGuid);
					foreach(DataRow dr in patient.AboRHHistory.Rows)
					{
						if (Convert.ToDateTime(dr[Common.VbecsTables.SpecimenTest.TestDate]) > Convert.ToDateTime(selectedTest[Common.VbecsTables.SpecimenTest.TestDate]))
						{
							GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.NonCurrentJustifiedAboRh());
							this.btnInvalidate.EnabledButton = false;
							return;
						}
					}
				}
			}
			//
			this.SetThisToolTip(this.btnInvalidate,Common.StrRes.Tooltips.Common.OKToSave());
			this.btnInvalidate.EnabledButton = true;
		}

		private void lvPatientTestResults_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			if (e.Column == 2)
			{
				controls.ColumnClickSorter.ColumnClickHandler(sender,e,this.lvPatientTestResults.CheckBoxes,controls.ColumnClickSorter.ColumnSortType.DateTime);
			}
			else
			{
				controls.ColumnClickSorter.ColumnClickHandler(sender,e,this.lvPatientTestResults.CheckBoxes,controls.ColumnClickSorter.ColumnSortType.String);
			}
		}

		private void TestResultsListView_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			controls.ColumnClickSorter.ColumnClickHandler(sender,e,false,controls.ColumnClickSorter.ColumnSortType.String);
		}

		private void btnInvalidate_Click(object sender, System.EventArgs e)
		{
			bool disableCheckbox = false;
			ArrayList phases = new ArrayList();
			bool bMsgNeeded = false;
			System.Data.DataTable dt = null;

			if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.TAS)
			{
				//The Type & Screen is not complete, so it is on the PTL and must have its task status updated regardless...
				if (this._orderedTest.TaskStatusCode != Common.Utility.GetTaskStatusCodeFromEnum(Common.TaskStatus.Completed))
				{
					disableCheckbox = true;
				}
			}
			else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.XM)
			{
				disableCheckbox = true;
			}

			DlgInvalidatePatientTestConfirm dlg = new DlgInvalidatePatientTestConfirm((this._orderedTest.OrderableTestId == (int)Common.OrderableTest.ABID),disableCheckbox);
            dlg.ShowDialogFromLockedParent(this, false);
            if (dlg.DialogResult != DialogResult.OK)
			{
				return;
			}

			bool result = false;
			_alWorkloadProcessIds = new ArrayList();
			//
			int orderableTestId = this._orderedTest.OrderableTestId;
			//
			try
			{
				if ((orderableTestId == (int)Common.OrderableTest.XM) ||
					(orderableTestId == (int)Common.OrderableTest.RepeatXM))
				{
					if (orderableTestId == (int)Common.OrderableTest.XM)
					{
						phases.Clear();
						foreach(ListViewItem lvi in this.lvXM.Items)
						{
							phases.Add(lvi.SubItems[1].Text);
						}
						//CR 2674 and CR 2996 we need a separate section for AHG only and Transfusion Only crossmatches to avoid system crash
						if (phases.Count < 4)
						{
							dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
							if(dt!= null)
							{
								if(dt.Rows.Count == 0)
								{
									bMsgNeeded = true;
								}
							}

							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
						}
						else
						{
							if (phases[1].ToString().Trim() == "Not Tested" && phases[2].ToString().Trim() == "Not Tested" && phases[3].ToString().Trim() == "Not Tested")
							{
								dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.CrossmatchUnitSerologicImmediateSpin);
								if(dt!= null)
								{
									if(dt.Rows.Count == 0)
									{
										bMsgNeeded = true;
									}
								}

								this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.CrossmatchUnitSerologicImmediateSpin);
							}
							else
							{
								dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
								if(dt!= null)
								{
									if(dt.Rows.Count == 0)
									{
										bMsgNeeded = true;
									}
								}

								this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
							}
						}
					}
					else
					{
						dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.CrossmatchRepeatTest);
						if(dt!= null)
						{
							if(dt.Rows.Count == 0)
							{
								bMsgNeeded = true;
							}
						}

						this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.CrossmatchRepeatTest);
					}

					//
					Guid orderedUnitGuid = ((BOL.BloodUnitTest)this._selectedTests[0]).OrderedUnitGuid;
					BOL.OrderedUnit orderedUnit = new BOL.OrderedUnit(orderedUnitGuid, Common.LogonUser.LogonUserDivisionCode, false);
					//CR1441, 2173
					if (bMsgNeeded) GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC015.BR1502_NoWorkloadDefined());

					result = BOL.BloodUnitTest.InvalidateCrossmatchTestResults(orderableTestId, this._selectedTests, orderedUnit, dlg.Comment,dlg.ReplacementResultsRequired, this._specimen.Patient.PatientGuid, this._alWorkloadProcessIds, Common.UpdateFunction.UC094FrmInvalidatePatientTestResults);
				}
				else if (orderableTestId == (int)Common.OrderableTest.TRW)
				{
					int aboCount = 0;
					int datCount = 0;
					int absCount = 0;
					int xmCount = 0;

					for (int i=0; i<this._trwSpecimenTests.Count; i++)
					{
						if (((DataRow)this._trwSpecimenTests[i])[Common.VbecsTables.BloodTestType.BloodTestName].ToString().IndexOf("ABO") > -1)
							aboCount++;
						else if (((DataRow)this._trwSpecimenTests[i])[Common.VbecsTables.BloodTestType.BloodTestName].ToString().IndexOf("DAT") > -1)
							datCount++;
						else if (((DataRow)this._trwSpecimenTests[i])[Common.VbecsTables.BloodTestType.BloodTestName].ToString().IndexOf("Antibody") > -1)
							absCount++;
					}

					for (int i=0; i<this._trwBloodUnitTests.Count; i++)
					{
						if (((DataRow)this._trwBloodUnitTests[i])[Common.VbecsTables.BloodTestType.BloodTestName].ToString().IndexOf("Xmatch") > -1)
						{
							xmCount++;
						}
					}

					dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.TransfusionReactionInvestigation);
					if(dt!= null)
					{
						if(dt.Rows.Count == 0)
						{
							bMsgNeeded = true;
						}
					}
					this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.TransfusionReactionInvestigation);

					if (aboCount > 0)
					{
						dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.ABOForwardReverseTypingPatient);
						if(dt!= null)
						{
							if(dt.Rows.Count == 0)
							{
								bMsgNeeded = true;
							}
						}
					}

					if (absCount > 0)
					{
						dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.AntibodyScreenPatient);
						if(dt!= null)
						{
							if(dt.Rows.Count == 0)
							{
								bMsgNeeded = true;
							}
						}
					}

					if (datCount > 0)
					{
						dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.DirectAntiglobulinTestDAT);
						if(dt!= null)
						{
							if(dt.Rows.Count == 0)
							{
								bMsgNeeded = true;
							}
						}
					}

					if (xmCount > 0)
					{
						dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
						if(dt!= null)
						{
							if(dt.Rows.Count == 0)
							{
								bMsgNeeded = true;
							}
						}
					}

					for (int i=0; i<aboCount; i++)
						this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.ABOForwardReverseTypingPatient);
					for (int i=0; i<absCount; i++)
						this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.AntibodyScreenPatient);
					for (int i=0; i<datCount; i++)
						this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.DirectAntiglobulinTestDAT);
					for (int i=0; i<xmCount; i++)
						this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.CrossmatchUnitSerologicalCoombs);
					//CR 1441, 2173
					if (bMsgNeeded) GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC015.BR1502_NoWorkloadDefined());

					result = this._patientTransfusionReaction.Invalidate(this._orderedTest,_trwBloodUnitTests,_trwSpecimenTests,dlg.Comment,dlg.ReplacementResultsRequired, Common.UpdateFunction.UC094FrmInvalidatePatientTestResults, this._specimen.Patient.PatientGuid, this._alWorkloadProcessIds);
				}
				else
				{
					switch(orderableTestId)
					{
						case (int) Common.OrderableTest.TAS:
							if (this._selectedTests.Count > 0)
							{
								if (this._reportableTestId == (int) Common.OrderableTest.ABORh)
								{
									this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.ABOForwardReverseTypingPatient);
								}
								else if (this._reportableTestId == (int) Common.OrderableTest.ABS)
								{
									this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.AntibodyScreenPatient);
								}
								else if (this._reportableTestId == (int) Common.OrderableTest.DAT)
								{
									this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.DirectAntiglobulinTestDAT);
								}
							}
							break;
						case (int) Common.OrderableTest.ABORh:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.ABOForwardReverseTypingPatient);
							break;
						case (int) Common.OrderableTest.RepeatABORh:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.ABOForwardReverseTypingPatientRepeatTest);
							break;
						case (int) Common.OrderableTest.ABS:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.AntibodyScreenPatient);
							break;
						case (int) Common.OrderableTest.RepeatABS:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.AntibodyScreenPatientRepeatTest);
							break;
						case (int) Common.OrderableTest.DAT:
						case (int) Common.OrderableTest.DATComp:
						case (int) Common.OrderableTest.DATIgG:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.DirectAntiglobulinTestDAT);
							break;
						case (int) Common.OrderableTest.RepeatDAT: 
						case (int) Common.OrderableTest.RepeatDATComp:
						case (int) Common.OrderableTest.RepeatDATIgG:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.DirectAntiglobulinTestDATRepeatTest);
							break;
						case (int) Common.OrderableTest.ABID:
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.AntibodyIdentificationWorkUp);
							break;
					}
					//Check for patient antigen phenotype
					if((orderableTestId > (int) Common.OrderableTest.TRW) && (orderableTestId < (int) Common.OrderableTest.RepeatABORh))
					{
						phases.Clear();
						//now check for phase single or multiple
						//lvTest
						foreach(ListViewItem lvi in this.lvTest.Items)
						{
							phases.Add(lvi.SubItems[1].Text.Trim());
						}
						if(phases.IndexOf("37") > -1 || phases.IndexOf("RT") > -1)
						{
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.PatientAntigenPhenotypeMultiplePhases);
						}
						else if((phases.IndexOf("IS") > -1 && phases.IndexOf("37") == -1 && phases.IndexOf("RT") == -1) ||
							(phases.IndexOf("AHG") > -1))
						{	
							this._alWorkloadProcessIds.Add(Common.WorkloadProcessID.PatientAntigenPhenotypeSinglePhase);
						}
					}
					//
					if(this._alWorkloadProcessIds != null)
					{
						foreach(Common.WorkloadProcessID workloadPID in this._alWorkloadProcessIds)
						{
							//CR 1441, 2173
							dt  = BOL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) workloadPID);
							if(dt!= null && workloadPID != Common.WorkloadProcessID.Unknown)
							{
								if(dt.Rows.Count == 0)
								{
									bMsgNeeded = true;
								}
							}
						}
					}
					//CR 1441, 2173
					if (bMsgNeeded) GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC015.BR1502_NoWorkloadDefined());

					result = BOL.SpecimenTest.InvalidateSpecimenTestResults(this._selectedTests, dlg.Comment, dlg.ReplacementResultsRequired, Common.UpdateFunction.UC094FrmInvalidatePatientTestResults, this._alWorkloadProcessIds, this._specimen.Patient.PatientGuid, this._specimen.Patient.RowVersion);
				}
			}
			catch (Common.RowVersionException)
			{
				this.btnInvalidate.RowVersionException = true;			//CR2077
				GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.DataWasNotSavedBecauseOfRowversionViolation());
				return;
			}
		
			//
			if (!result)
			{
				GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.DataNotSaved("patient test data"));
				return;
			}
			//
			if (orderableTestId == (int)Common.OrderableTest.XM)
			{
				Common.UnitStatusCode selectedUnitStatus = this._selectedUnit.BloodUnitStatus.UnitStatusCode;
				if ((selectedUnitStatus == Common.UnitStatusCode.Assigned) || 
					(selectedUnitStatus == Common.UnitStatusCode.CrossmatchedAssigned))
				{
					GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC094.UnitAssignedAfterInvalidation(this._selectedUnit.EyeReadableUnitId)); 
				}
			}
			
			//Remove the current test locks - leaving patient/specimen - for the chance of unnacceptable being flagged if all tests are removed
			this.RemoveCurrentTestLocks();

			//Store the ordered test guid, cos when we remove the item from the list, it'll be gone!
			Guid keepOrderedTestGuid = this._orderedTest.OrderedTestGuid;
			//
			this.lvPatientTestResults.Items.Remove(this.lvPatientTestResults.SelectedItems[0]);
			//
			//All antibody id's are invalidated at the same time, so we need to
			//remove any stray items in the list view
			if ((orderableTestId == (int)Common.OrderableTest.ABID)||
				(orderableTestId == (int)Common.OrderableTest.RepeatABID))
			{
				foreach(ListViewItem lvi in this.lvPatientTestResults.Items)
				{
					System.Data.DataRow dr = (System.Data.DataRow)lvi.Tag;
					if (!dr.IsNull(Common.VbecsTables.OrderedTest.OrderedTestGuid) &&
						(Guid)dr[Common.VbecsTables.OrderedTest.OrderedTestGuid] == keepOrderedTestGuid)
					{
						this.lvPatientTestResults.Items.Remove(lvi);
					}
				}
			}
			if (this.lvPatientTestResults.Items.Count == 0)
			{
				//No Need for Locking here, because all the previous Invalidation Work is CompLETE
				//BUT -- do we need a lock on PatientSpecimen?
				//if the last test has been invalidated and the specimen is acceptable, 
				//ask if the specimen should be invalidated. (BR_94.05)
				if (!this._specimen.UnacceptableSpecimenIndicator)
				{
					DlgInvalidateSpecimen dlgComment = new DlgInvalidateSpecimen();
                    dlgComment.ShowDialogFromLockedParent(this, false);
					if (dlgComment.DialogResult  == DialogResult.OK)
					{
						try
						{
							//Putting the record lock here - since the user has clicked OK, and will know better
							//what data, a conflict could pertain to 
							if (this.SetLocks(this._specimen.SpecimenGuid))
							{
								this._specimen.UnacceptableSpecimenIndicator = true;
								this._specimen.UnacceptableSpecimenComment.CannedCommentGuid = dlgComment.CannedCommentGuid;
								this._specimen.UnacceptableSpecimenDetails = dlgComment.Details;
								int success = this._specimen.UpdateSpecimen(null,null,Common.UpdateFunction.UC094FrmInvalidatePatientTestResults);
								if (success != 0)
								{
									GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.DataNotSaved("specimen data"));
								}
							}
						}
						catch (Common.RowVersionException)
						{
							this.btnInvalidate.RowVersionException = true;		//CR2077
							GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.DataWasNotSavedBecauseOfRowversionViolation());
						}
					}
				}
				//If the last test has been invalidated, close the form.
				this.Close();
			}

		}

		/// <summary>
		/// Removes any currently locked test records -- either invalidate was clicked, or the 
		/// user moved from one test to the next in the listview
		/// </summary>
		private void RemoveCurrentTestLocks()
		{
			if (this._lockedRecords.Count == 0) return;

			this.ReleaseLocks((System.Guid[])this._lockedRecords.ToArray(typeof(System.Guid)));
		}

		/// <summary>
		/// Collects all the Guids needed for locking
		/// Using the same IF/Else logic from the btnInvalidate_Click event
		/// </summary>
		/// <returns></returns>
		private System.Guid[] GetLockingGuids()
		{
			System.Collections.ArrayList guidArray = new ArrayList();
			this._lockedRecords = new ArrayList();

			if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.RepeatXM)
			{
				foreach(BOL.BloodUnitTest tmpBUT in this._selectedTests)
				{
					guidArray.Add(tmpBUT.BloodUnitTestGuid);
					this._lockedRecords.Add(tmpBUT.BloodUnitTestGuid);
				}
			}
			else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.XM)
			{
				foreach(BOL.BloodUnitTest tmpBUT in this._selectedTests)
				{
					guidArray.Add(tmpBUT.BloodUnitTestGuid);
					this._lockedRecords.Add(tmpBUT.BloodUnitTestGuid);
				}

				BOL.OrderedUnit tmpOU = new BOL.OrderedUnit(this._selectedUnit.BloodUnitGuid, this._specimen.Patient.PatientGuid);
				guidArray.Add(tmpOU.OrderedUnitGuid);
				this._lockedRecords.Add(tmpOU.OrderedUnitGuid);
			}
			else if (this._orderedTest.OrderableTestId == (int)Common.OrderableTest.TRW)
			{
				foreach(System.Data.DataRow dr in this._trwBloodUnitTests)
				{
					guidArray.Add((System.Guid)dr[BLOODUNITTEST.BloodUnitTestGuid]);
					this._lockedRecords.Add((System.Guid)dr[BLOODUNITTEST.BloodUnitTestGuid]);
				}

				foreach(System.Data.DataRow dr in this._trwSpecimenTests)
				{
					guidArray.Add((System.Guid)dr[SPECIMENTEST.SpecimenTestGuid]);
					this._lockedRecords.Add((System.Guid)dr[SPECIMENTEST.SpecimenTestGuid]);
				}

				guidArray.Add(this._patientTransfusionReaction.PatientTransfusionReactionGuid);
				this._lockedRecords.Add(this._patientTransfusionReaction.PatientTransfusionReactionGuid);
			}
			else
			{
				foreach(BOL.SpecimenTest tmpST in this._selectedTests)
				{
					guidArray.Add(tmpST.SpecimenTestGuid);
					this._lockedRecords.Add(tmpST.SpecimenTestGuid);
				}
			}

			return(System.Guid[])guidArray.ToArray(typeof(System.Guid));

		}

		/// <summary>
		/// **** 508 Compliance ***
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void FrmInvalidatePatientTestResults_KeyDownSpeakMessage(object sender, System.EventArgs e)
		{
			if (this.pnlSpecimenSelect.Visible == true)
				this.patientSpecimenSelector1.Speak(sender, e);

			string textToSpeak = "";

			if (this.btnInvalidate.EnabledButton == false)
			{
				textToSpeak = this.btnInvalidate.GetToolTip();
			}
			if(this.patientSpecimenDisplayPanel1.Visible)
			{
				textToSpeak = string.Concat(textToSpeak, this.patientSpecimenDisplayPanel1.GetErrorMessagesFor508());
			}
			this.SpeakMessage( textToSpeak );		
		}
	}
}

