#if NUNIT
#region Directives
//-----------------------***
using System;
using System.Collections;
using System.Data;
using System.Text;
using NUnit.Framework;
using gov.va.med.vbecs.UnitTests;

using TABLES = gov.va.med.vbecs.Common.VbecsTables;
using SPROCS = gov.va.med.vbecs.Common.VbecsStoredProcs;
using ARTIFICIAL = gov.va.med.vbecs.Common.DatabaseConstants.ArtificialColumnNames;


using BOL = gov.va.med.vbecs.BOL;
using COMMON = gov.va.med.vbecs.Common;
using DAL = gov.va.med.vbecs.DAL;
using VAL = gov.va.med.vbecs.VAL;
using gov.va.med.vbecs.VAL.UnitTests;
//-----------------------***
#endregion

namespace gov.va.med.vbecs.DAL.UnitTests
{

	
	

	[TestFixture]
	public class DAL_DivisionAlerts : BaseTest 
	{
		[SetUp]
		protected void SetUp()
		{
			this.BaseSetUp();
		}


		[Test]
		public void GetOrderAlertTypes_Pass()
		{
			DataTable dtTest = DAL.DivisionAlerts.GetOrderAlertTypeList();

			Assert.AreEqual(true, dtTest.Rows.Count > 0, "Rows.Count");
			Assert.AreEqual(3, dtTest.Columns.Count, "Columns.Count");
			Assert.AreEqual(true, dtTest.Columns.Contains(TABLES.OrderAlertType.OrderAlertTypeCode), TABLES.OrderAlertType.OrderAlertTypeCode);
			Assert.AreEqual(true, dtTest.Columns.Contains(TABLES.OrderAlertType.OrderAlertTypeText), TABLES.OrderAlertType.OrderAlertTypeText);
			Assert.AreEqual(true, dtTest.Columns.Contains(TABLES.OrderAlertType.SortColumn), TABLES.OrderAlertType.SortColumn);

		}

		[Test]
		[Ignore(StandardIgnoreReasons.NoFailureConditions)]
		public void GetOrderAlertTypes_Fail()
		{
		}
	}
}

#endif
