using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using gov.va.med.vbecs.Common;

namespace gov.va.med.vbecs.admin.GUI
{
	/// <summary>
	/// Summary description for dlgAbout.
	/// </summary>
	public class dlgAbout : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox grpImage;
		private System.Windows.Forms.GroupBox grpVersion;
		private System.Windows.Forms.GroupBox grpMisuse;
		private System.Windows.Forms.GroupBox grpFDA;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Label lblDeveloped;
		private System.Windows.Forms.Label lblCompiled;
		private System.Windows.Forms.Label lblOS;
		private System.Windows.Forms.Label lblCLR;
		private System.Windows.Forms.Label lblMisuse;
		private System.Windows.Forms.Label lblFDA;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Constructor
		/// </summary>
		public dlgAbout()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.lblName.Text = Application.ProductName;
			// CR2465 Update - this form is no longer used. See Controls project - FrmAboutBox
			this.lblVersion.Text = "v " + BOL.VbecsVersion.CurrentVersion;		//CR2465 - Grabbing version from DB instead of config file.
			this.lblCompiled.Text = "Compiled: "+this.CompileDate();
			this.lblOS.Text = "OS Version: "+System.Environment.OSVersion.ToString();
			this.lblCLR.Text = "CLR Version: "+System.Environment.Version.ToString();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(dlgAbout));
			this.grpImage = new System.Windows.Forms.GroupBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.grpVersion = new System.Windows.Forms.GroupBox();
			this.lblCLR = new System.Windows.Forms.Label();
			this.lblOS = new System.Windows.Forms.Label();
			this.lblCompiled = new System.Windows.Forms.Label();
			this.lblDeveloped = new System.Windows.Forms.Label();
			this.lblVersion = new System.Windows.Forms.Label();
			this.lblName = new System.Windows.Forms.Label();
			this.grpMisuse = new System.Windows.Forms.GroupBox();
			this.lblMisuse = new System.Windows.Forms.Label();
			this.grpFDA = new System.Windows.Forms.GroupBox();
			this.lblFDA = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.grpImage.SuspendLayout();
			this.grpVersion.SuspendLayout();
			this.grpMisuse.SuspendLayout();
			this.grpFDA.SuspendLayout();
			this.SuspendLayout();
			// 
			// grpImage
			// 
			this.grpImage.Controls.Add(this.pictureBox1);
			this.grpImage.Location = new System.Drawing.Point(4, 4);
			this.grpImage.Name = "grpImage";
			this.grpImage.Size = new System.Drawing.Size(68, 162);
			this.grpImage.TabIndex = 0;
			this.grpImage.TabStop = false;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 12);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(52, 144);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// grpVersion
			// 
			this.grpVersion.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpVersion.Controls.Add(this.lblVersion);
			this.grpVersion.Controls.Add(this.lblCLR);
			this.grpVersion.Controls.Add(this.lblOS);
			this.grpVersion.Controls.Add(this.lblCompiled);
			this.grpVersion.Controls.Add(this.lblDeveloped);
			this.grpVersion.Controls.Add(this.lblName);
			this.grpVersion.Location = new System.Drawing.Point(76, 4);
			this.grpVersion.Name = "grpVersion";
			this.grpVersion.Size = new System.Drawing.Size(380, 162);
			this.grpVersion.TabIndex = 1;
			this.grpVersion.TabStop = false;
			// 
			// lblCLR
			// 
			this.lblCLR.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblCLR.Location = new System.Drawing.Point(8, 136);
			this.lblCLR.Name = "lblCLR";
			this.lblCLR.Size = new System.Drawing.Size(356, 20);
			this.lblCLR.TabIndex = 5;
			this.lblCLR.Text = "CLR Version";
			this.lblCLR.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblOS
			// 
			this.lblOS.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblOS.Location = new System.Drawing.Point(8, 116);
			this.lblOS.Name = "lblOS";
			this.lblOS.Size = new System.Drawing.Size(356, 20);
			this.lblOS.TabIndex = 4;
			this.lblOS.Text = "OS Version";
			this.lblOS.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblCompiled
			// 
			this.lblCompiled.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblCompiled.Location = new System.Drawing.Point(8, 96);
			this.lblCompiled.Name = "lblCompiled";
			this.lblCompiled.Size = new System.Drawing.Size(356, 20);
			this.lblCompiled.TabIndex = 3;
			this.lblCompiled.Text = "Compiled";
			this.lblCompiled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblDeveloped
			// 
			this.lblDeveloped.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblDeveloped.Location = new System.Drawing.Point(8, 64);
			this.lblDeveloped.Name = "lblDeveloped";
			this.lblDeveloped.Size = new System.Drawing.Size(356, 20);
			this.lblDeveloped.TabIndex = 2;
			this.lblDeveloped.Text = "Developed by the Department of Veterans Affairs";
			this.lblDeveloped.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblVersion
			// 
			this.lblVersion.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblVersion.Location = new System.Drawing.Point(272, 48);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(96, 23);
			this.lblVersion.TabIndex = 1;
			this.lblVersion.Text = "v1.0";
			this.lblVersion.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblName
			// 
			this.lblName.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblName.Location = new System.Drawing.Point(8, 12);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(364, 28);
			this.lblName.TabIndex = 0;
			this.lblName.Text = "VBECS Administrator";
			this.lblName.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// grpMisuse
			// 
			this.grpMisuse.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpMisuse.Controls.Add(this.lblMisuse);
			this.grpMisuse.Location = new System.Drawing.Point(4, 170);
			this.grpMisuse.Name = "grpMisuse";
			this.grpMisuse.Size = new System.Drawing.Size(452, 56);
			this.grpMisuse.TabIndex = 2;
			this.grpMisuse.TabStop = false;
			// 
			// lblMisuse
			// 
			this.lblMisuse.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblMisuse.Location = new System.Drawing.Point(8, 12);
			this.lblMisuse.Name = "lblMisuse";
			this.lblMisuse.Size = new System.Drawing.Size(432, 36);
			this.lblMisuse.TabIndex = 3;
			this.lblMisuse.Text = "Unauthorized access or misuse of this system and/or its data is a federal crime. " +
				"Use of all data shall be in accordance with VA policy on security and privacy.";
			this.lblMisuse.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// grpFDA
			// 
			this.grpFDA.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpFDA.Controls.Add(this.lblFDA);
			this.grpFDA.Location = new System.Drawing.Point(4, 230);
			this.grpFDA.Name = "grpFDA";
			this.grpFDA.Size = new System.Drawing.Size(452, 108);
			this.grpFDA.TabIndex = 3;
			this.grpFDA.TabStop = false;
			// 
			// lblFDA
			// 
			this.lblFDA.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblFDA.Location = new System.Drawing.Point(8, 12);
			this.lblFDA.Name = "lblFDA";
			this.lblFDA.Size = new System.Drawing.Size(432, 88);
			this.lblFDA.TabIndex = 3;
			this.lblFDA.Text = @"Note: The Food && Drug Administration classifies this software as a medical device. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes. Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations.";
			this.lblFDA.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(380, 344);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 4;
			this.btnOK.Text = "&OK";
			// 
			// dlgAbout
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnOK;
			this.ClientSize = new System.Drawing.Size(458, 370);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.grpFDA);
			this.Controls.Add(this.grpMisuse);
			this.Controls.Add(this.grpVersion);
			this.Controls.Add(this.grpImage);
			this.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "dlgAbout";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "About";
			this.grpImage.ResumeLayout(false);
			this.grpVersion.ResumeLayout(false);
			this.grpMisuse.ResumeLayout(false);
			this.grpFDA.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The date of the last compile
		/// </summary>
		private string CompileDate()
		{	
			try
			{
				FileInfo fo = new FileInfo(Assembly.GetEntryAssembly().CodeBase.Replace("file:///",""));
				return fo.LastWriteTime.ToString();
			}
			catch
			{
				return string.Empty;
			}
		}
	}
}
