﻿using System.Collections.Generic;
using gov.va.med.VBECS.Communication.Common;

namespace gov.va.med.VBECS.Communication.Protocols
{
    /// <summary>
    /// Interface for communication protocols.
    /// Protocols responsible for messages serialization/deserialization. 
    /// </summary>
    public interface IProtocol
    {
        byte[] GetBytes(IMessage theMsg);
        IEnumerable<IMessage> BuildMessages(byte[] theBytes);
        void Reset();
    }
}
