namespace gov.va.med.vbecs.Common 
{
	#region Header

	///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
	///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
	///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
	///<Developers>
	///	<Developer>Hines OIFO</Developer>
	///</Developers>
	///<SiteName>Hines OIFO</SiteName>
	///<CreationDate>11/14/2011</CreationDate>
	///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
	///<summary>
	///    VbecsStoredProcs class - used to get stored procedure and parameter names
	///
	///    The content in this file was generated by UpdateDBSchemaStoredProc macro.
	///    Please do not modify the file manually since it should only contain 
	///    throw-away code which can be re-created by the macro.
	///
	///    Last time generated by VHAMASTER\zzzzzzaskewd at 2:45:21 PM, Monday, November 14, 2011
	///
	///    WARNING: re-generate the file every time you change stored procedure's signature(s)!
	///</summary>

	#endregion

	public abstract class VbecsStoredProcs
	{
		/// <summary>
		/// spActivateDailyControlRack
		/// </summary>
		public abstract class ActivateDailyControlRack
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spActivateDailyControlRack",
				dailycontrolguid = "@dailycontrolguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				RackGuid = "@rackguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailycontrolguid", "RackGuid", "recordstatuscode", "rowversion"
			};
		}
        
		/// <summary>
		/// spBloodProductModificationPool
		/// </summary>
		public abstract class BloodProductModificationPool
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spBloodProductModificationPool",
				pFromBloodProductGuidList = "@pFromBloodProductGuidList",
				pMethodSelect = "@pMethodSelect",
				pProductModificationCode = "@pProductModificationCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"pFromBloodProductGuidList", "pProductModificationCode"
			};
		}

		/// <summary>
		/// spBloodProductSearch
		/// </summary>
		public abstract class BloodProductSearch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spBloodProductSearch",
				divisioncode = "@divisioncode",
				productname = "@productname",
				producttypecode = "@producttypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productname", "producttypecode"
			};
		}

		/// <summary>
		/// spBloodUnitExists
		/// </summary>
		public abstract class BloodUnitExists
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spBloodUnitExists",
				BloodUnitGuid = "@BloodUnitGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid"
			};
		}

		/// <summary>
		/// spCancelOrderedUnit
		/// </summary>
		public abstract class CancelOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spCancelOrderedUnit",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedunitguid = "@orderedunitguid",
				rowversion = "@rowversion",
				unitstatusrowversion = "@unitstatusrowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedunitguid", "rowversion", "unitstatusrowversion"
			};
		}

		/// <summary>
		/// spCheckIsAlreadyCrossMatched
		/// </summary>
		public abstract class CheckIsAlreadyCrossMatched
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spCheckIsAlreadyCrossMatched",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spClearCptCache
		/// </summary>
		public abstract class ClearCptCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spClearCptCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spClearHcpcsCache
		/// </summary>
		public abstract class ClearHcpcsCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spClearHcpcsCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spClearHospitalLocationCache
		/// </summary>
		public abstract class ClearHospitalLocationCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spClearHospitalLocationCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spClearWorkloadCache
		/// </summary>
		public abstract class ClearWorkloadCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spClearWorkloadCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spConfirmOutgoingShipment
		/// </summary>
		public abstract class ConfirmOutgoingShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spConfirmOutgoingShipment",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				shipmentdate = "@shipmentdate",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "rowversion", "shipmentdate", "shipmentguid"
			};
		}

		/// <summary>
		/// spConfirmOutgoingShipmentBloodUnit
		/// </summary>
		public abstract class ConfirmOutgoingShipmentBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spConfirmOutgoingShipmentBloodUnit",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				shipmentdate = "@shipmentdate",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"rowversion", "shipmentdate", "shipmentguid"
			};
		}

		/// <summary>
		/// spCreateOutgoingInvoice
		/// </summary>
		public abstract class CreateOutgoingInvoice
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spCreateOutgoingInvoice",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				shipmentguid = "@shipmentguid",
				shipmenttypecode = "@shipmenttypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber", "localsupplierguid", "shipmentguid", "shipmenttypecode"
			};
		}

		/// <summary>
		/// spCrossmatchResultCodesForPatient
		/// </summary>
		public abstract class CrossmatchResultCodesForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spCrossmatchResultCodesForPatient",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spDeactivateDailyControlRack
		/// </summary>
		public abstract class DeactivateDailyControlRack
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spDeactivateDailyControlRack",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				RackGuid = "@rackguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"RackGuid", "rowversion"
			};
		}

		/// <summary>
		/// spDeleteAllVbecsLocksForUser
		/// </summary>
		public abstract class DeleteAllVbecsLocksForUser
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spDeleteAllVbecsLocksForUser",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				sessionguid = "@sessionguid";
		}

		/// <summary>
		/// spDeleteLock
		/// </summary>
		public abstract class DeleteVbecsLock
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spDeleteVbecsLock",
                baselockedformid = "@baselockedformid",
				divisioncode = "@divisioncode",
				lockedformid = "@lockedformid",
				lockfunctionid = "@lockfunctionid",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				lockedrecordguid = "@recordguid",
				sessionguid = "@sessionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"lockedformid", "lockfunctionid"
			};
		}

		/// <summary>
		/// spFinalizePatientTransfusionReaction
		/// </summary>
		public abstract class FinalizePatientTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spFinalizePatientTransfusionReaction",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				medicaldirectorname = "@medicaldirectorname",
				partialsaveid = "@partialsaveid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				rowversion = "@rowversion",
				transfusionreactiontypecode = "@transfusionreactiontypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "medicaldirectorname", "partialsaveid", "patienttransfusionreactionguid", "rowversion", "transfusionreactiontypecode"
			};
		}

		/// <summary>
		/// spGetAboConfirmationLookup
		/// </summary>
		public abstract class GetAboConfirmationLookup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAboConfirmationLookup",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAboRHConfirmationTestsForUnit
		/// </summary>
		public abstract class GetAboRHConfirmationTestsForUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAboRHConfirmationTestsForUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAboRhForConsistencyCheck
		/// </summary>
		public abstract class GetAboRhForConsistencyCheck
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAboRhForConsistencyCheck",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAboRhTestHistory
		/// </summary>
		public abstract class GetAboRhTestHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAboRhTestHistory",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				testdate = "@testdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid", "testdate"
			};
		}

		/// <summary>
		/// spGetActiveOrLocalBloodProductsByCode
		/// </summary>
		public abstract class GetActiveOrLocalBloodProductsByCode
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetActiveOrLocalBloodProductsByCode",
				divisioncode = "@divisioncode",
				productcode = "@productcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productcode"
			};
		}

		/// <summary>
		/// spGetAddress
		/// </summary>
		public abstract class GetAddress
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAddress",
				facilityguid = "@facilityguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"facilityguid"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsDiscarded
		/// </summary>
		public abstract class GetAdminReportBloodUnitsDiscarded
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsDiscarded",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsModifiedPrepared
		/// </summary>
		public abstract class GetAdminReportBloodUnitsModifiedPrepared
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsModifiedPrepared",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsOutdated
		/// </summary>
		public abstract class GetAdminReportBloodUnitsOutdated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsOutdated",
				divisioncode = "@divisioncode",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsReceived
		/// </summary>
		public abstract class GetAdminReportBloodUnitsReceived
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsReceived",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsShipped
		/// </summary>
		public abstract class GetAdminReportBloodUnitsShipped
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsShipped",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAdminReportBloodUnitsTransfused
		/// </summary>
		public abstract class GetAdminReportBloodUnitsTransfused
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAdminReportBloodUnitsTransfused",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				ismultidivision = "@ismultidivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "ismultidivision", "startdate"
			};
		}

		/// <summary>
		/// spGetAllAboRH
		/// </summary>
		public abstract class GetAllAboRH
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAllAboRH",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAllAntigensForBloodUnit
		/// </summary>
		public abstract class GetAllAntigensForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAllAntigensForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAllBrokenRuleSets
		/// </summary>
		public abstract class GetAllBrokenRuleSets
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAllBrokenRuleSets",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAllVbecsProcesses
		/// </summary>
		public abstract class GetAllVbecsProcesses
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAllVbecsProcesses",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAllVbecsUsers
		/// </summary>
		public abstract class GetAllVbecsUsers
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAllVbecsUsers",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntibodiesForAntigenType
		/// </summary>
		public abstract class GetAntibodiesForAntigenType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodiesForAntigenType",
				antigentypeid = "@antigentypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antigentypeid"
			};
		}

		/// <summary>
		/// spGetAntibodiesWithoutAntigens
		/// </summary>
		public abstract class GetAntibodiesWithoutAntigens
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodiesWithoutAntigens",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetAntibodyParameterByID
		/// </summary>
		public abstract class GetAntibodyParameterByID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodyParameterByID",
				antibodytypeid = "@antibodytypeid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antibodytypeid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntibodyScreenDisplayList
		/// </summary>
		public abstract class GetAntibodyScreenDisplayList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodyScreenDisplayList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntibodyType
		/// </summary>
		public abstract class GetAntibodyType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodyType",
				antibodytypeid = "@antibodytypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antibodytypeid"
			};
		}

		/// <summary>
		/// spGetAntibodyTypeList
		/// </summary>
		public abstract class GetAntibodyTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodyTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntibodyTypeLookupList
		/// </summary>
		public abstract class GetAntibodyTypeLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntibodyTypeLookupList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiGenListForBloodUnit
		/// </summary>
		public abstract class GetAntiGenListForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiGenListForBloodUnit",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetAntigens
		/// </summary>
		public abstract class GetAntigens
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigens",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTest
		/// </summary>
		public abstract class GetAntigenTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTest",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTypeList
		/// </summary>
		public abstract class GetAntigenTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTypingForConsistencyCheck
		/// </summary>
		public abstract class GetAntigenTypingForConsistencyCheck
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingForConsistencyCheck",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntigenTypingQCReagentTypes
		/// </summary>
		public abstract class GetAntigenTypingQCReagentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingQCReagentTypes",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTypingReagentTypes
		/// </summary>
		public abstract class GetAntigenTypingReagentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingReagentTypes",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTypingTests
		/// </summary>
		public abstract class GetAntigenTypingTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingTests",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAntigenTypingTestsForInactivation
		/// </summary>
		public abstract class GetAntigenTypingTestsForInactivation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingTestsForInactivation",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid"
			};
		}

		/// <summary>
		/// spGetAntigenTypingTestsForUnit
		/// </summary>
		public abstract class GetAntigenTypingTestsForUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntigenTypingTestsForUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraOrderedTests
		/// </summary>
		public abstract class GetAntiseraOrderedTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraOrderedTests",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistByGuid
		/// </summary>
		public abstract class GetAntiseraWorklistByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistByGuid",
				antiseraworklistguid = "@antiseraworklistguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistDetails
		/// </summary>
		public abstract class GetAntiseraWorklistDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistDetails",
				antiseraworklistguid = "@antiseraworklistguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistQCControls
		/// </summary>
		public abstract class GetAntiseraWorklistQCControls
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistQCControls",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistQCResults
		/// </summary>
		public abstract class GetAntiseraWorklistQCResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistQCResults",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistsPartiallyCompleted
		/// </summary>
		public abstract class GetAntiseraWorklistsPartiallyCompleted
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistsPartiallyCompleted",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistTypingDetails
		/// </summary>
		public abstract class GetAntiseraWorklistTypingDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistTypingDetails",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAntiseraWorklistUnits
		/// </summary>
		public abstract class GetAntiseraWorklistUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAntiseraWorklistUnits",
				antiseraworklistguid = "@antiseraworklistguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetAssociatedInstitutionByDivision
		/// </summary>
		public abstract class GetAssociatedInstitutionByDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAssociatedInstitutionByDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetAssociatedInstitutions
		/// </summary>
		public abstract class GetAssociatedInstitutions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAssociatedInstitutions",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetAuditAntibody
		/// </summary>
		public abstract class GetAuditAntibody
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditAntibody",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditAssociatedInstitution
		/// </summary>
		public abstract class GetAuditAssociatedInstitution
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditAssociatedInstitution",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodProduct
		/// </summary>
		public abstract class GetAuditBloodProduct
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodProduct",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnit
		/// </summary>
		public abstract class GetAuditBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnit",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitAntigen
		/// </summary>
		public abstract class GetAuditBloodUnitAntigen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitAntigen",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitFinance
		/// </summary>
		public abstract class GetAuditBloodUnitFinance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitFinance",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitMedia
		/// </summary>
		public abstract class GetAuditBloodUnitMedia
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitMedia",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitModification
		/// </summary>
		public abstract class GetAuditBloodUnitModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitModification",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitStatus
		/// </summary>
		public abstract class GetAuditBloodUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitStatus",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditBloodUnitTest
		/// </summary>
		public abstract class GetAuditBloodUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditBloodUnitTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditComponentClass
		/// </summary>
		public abstract class GetAuditComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditComponentClass",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditConfigureTesting
		/// </summary>
		public abstract class GetAuditConfigureTesting
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditConfigureTesting",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditDailyControl
		/// </summary>
		public abstract class GetAuditDailyControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditDailyControl",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditDivision
		/// </summary>
		public abstract class GetAuditDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditDivision",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditHcpcs
		/// </summary>
		public abstract class GetAuditHcpcs
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditHcpcs",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditInappropriateRequestIndicators
		/// </summary>
		public abstract class GetAuditInappropriateRequestIndicators
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditInappropriateRequestIndicators",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditInterfaceControl
		/// </summary>
		public abstract class GetAuditInterfaceControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditInterfaceControl",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditLocalSupplier
		/// </summary>
		public abstract class GetAuditLocalSupplier
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditLocalSupplier",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditMsbos
		/// </summary>
		public abstract class GetAuditMsbos
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditMsbos",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditMsbosComponentClass
		/// </summary>
		public abstract class GetAuditMsbosComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditMsbosComponentClass",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditPatient
		/// </summary>
		public abstract class GetAuditPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditPatient",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditProductModificationParameter
		/// </summary>
		public abstract class GetAuditProductModificationParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditProductModificationParameter",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditProductShipper
		/// </summary>
		public abstract class GetAuditProductShipper
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditProductShipper",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditReagentTestParameter
		/// </summary>
		public abstract class GetAuditReagentTestParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditReagentTestParameter",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditReagentTypeParameter
		/// </summary>
		public abstract class GetAuditReagentTypeParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditReagentTypeParameter",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditSI
		/// </summary>
		public abstract class GetAuditSI
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditSI",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditSpecimenTest
		/// </summary>
		public abstract class GetAuditSpecimenTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditSpecimenTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditTR
		/// </summary>
		public abstract class GetAuditTR
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditTR",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditTransfusionComplications
		/// </summary>
		public abstract class GetAuditTransfusionComplications
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditTransfusionComplications",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditTransfusionEffectiveness
		/// </summary>
		public abstract class GetAuditTransfusionEffectiveness
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditTransfusionEffectiveness",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditUser
		/// </summary>
		public abstract class GetAuditUser
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditUser",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditUserAlerts
		/// </summary>
		public abstract class GetAuditUserAlerts
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditUserAlerts",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditUserRole
		/// </summary>
		public abstract class GetAuditUserRole
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditUserRole",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditVistALinkControl
		/// </summary>
		public abstract class GetAuditVistALinkControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditVistALinkControl",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetAuditWorkload
		/// </summary>
		public abstract class GetAuditWorkload
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetAuditWorkload",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetBloodAntigenByGuidAndID
		/// </summary>
		public abstract class GetBloodAntigenByGuidAndID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAntigenByGuidAndID",
				antigentypeid = "@antigentypeid",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antigentypeid", "bloodunitguid"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityAntigens
		/// </summary>
		public abstract class GetBloodAvailabilityAntigens
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityAntigens",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityAssignedPatients
		/// </summary>
		public abstract class GetBloodAvailabilityAssignedPatients
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityAssignedPatients",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityComments
		/// </summary>
		public abstract class GetBloodAvailabilityComments
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityComments",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityCount
		/// </summary>
		public abstract class GetBloodAvailabilityCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityCount",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityItems
		/// </summary>
		public abstract class GetBloodAvailabilityItems
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityItems",
				divisioncode = "@divisioncode",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityPatientCount
		/// </summary>
		public abstract class GetBloodAvailabilityPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityTargetUnits
		/// </summary>
		public abstract class GetBloodAvailabilityTargetUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityTargetUnits",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityTestComments
		/// </summary>
		public abstract class GetBloodAvailabilityTestComments
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityTestComments",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodAvailabilityTestResults
		/// </summary>
		public abstract class GetBloodAvailabilityTestResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodAvailabilityTestResults",
				WhereClause = "@WhereClause";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WhereClause"
			};
		}

		/// <summary>
		/// spGetBloodProductByCode
		/// </summary>
		public abstract class GetBloodProductByCode
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodProductByCode",
				divisioncode = "@divisioncode",
				productcode = "@productcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productcode"
			};
		}

		/// <summary>
		/// spGetBloodProductByGuid
		/// </summary>
		public abstract class GetBloodProductByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodProductByGuid",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodProductByType
		/// </summary>
		public abstract class GetBloodProductByType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodProductByType",
				divisioncode = "@divisioncode",
				productcodeindicator = "@productcodeindicator",
				producttypecode = "@producttypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productcodeindicator", "producttypecode"
			};
		}

		/// <summary>
		/// spGetBloodTestType
		/// </summary>
		public abstract class GetBloodTestType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodTestType",
				bloodtesttypeid = "@bloodtesttypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtesttypeid"
			};
		}

		/// <summary>
		/// spGetBloodTestTypes
		/// </summary>
		public abstract class GetBloodTestTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodTestTypes",
				orderabletestid = "@orderabletestid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderabletestid"
			};
		}

		/// <summary>
		/// spGetBloodTypeList
		/// </summary>
		public abstract class GetBloodTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetBloodTypeRHFactorFromBloodTypeCode
		/// </summary>
		public abstract class GetBloodTypeRHFactorFromBloodTypeCode
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodTypeRHFactorFromBloodTypeCode",
				bloodtypecode = "@bloodtypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode"
			};
		}

		/// <summary>
		/// spGetBloodUnitAndPatientData
		/// </summary>
		public abstract class GetBloodUnitAndPatientData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAndPatientData",
				bloodunitguid = "@bloodunitguid",
				orderedcomponentguid = "@orderedcomponentguid",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "orderedcomponentguid", "patientguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitAndPatientGuids
		/// </summary>
		public abstract class GetBloodUnitAndPatientGuids
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAndPatientGuids",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetBloodUnitAntigens
		/// </summary>
		public abstract class GetBloodUnitAntigens
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAntigens",
				bloodunitguidlist = "@bloodunitguidlist",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguidlist", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitAssignedPatientCount
		/// </summary>
		public abstract class GetBloodUnitAssignedPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAssignedPatientCount",
				BloodUnitGuid = "@BloodUnitGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid"
			};
		}

		/// <summary>
		/// spGetBloodUnitAssignedPatients
		/// </summary>
		public abstract class GetBloodUnitAssignedPatients
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAssignedPatients",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitAssignedPatientSpecimens
		/// </summary>
		public abstract class GetBloodUnitAssignedPatientSpecimens
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitAssignedPatientSpecimens",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitByGuid
		/// </summary>
		public abstract class GetBloodUnitByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitByGuid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitByUnitIdProduct
		/// </summary>
		public abstract class GetBloodUnitByUnitIdProduct
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitByUnitIdProduct",
				divisioncode = "@divisioncode",
				eyereadableunitid = "@eyereadableunitid",
				productguid = "@productguid",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "eyereadableunitid", "productguid", "unitproductcode"
			};
		}

		/// <summary>
		/// spGetBloodUnitDetailsFromBloodUnitShipment
		/// </summary>
		public abstract class GetBloodUnitDetailsFromBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitDetailsFromBloodUnitShipment",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode",
				fullproductcode = "@fullproductcode",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode", "unitid"
			};
		}

		/// <summary>
		/// spGetBloodUnitFinanceByUnitGuid
		/// </summary>
		public abstract class GetBloodUnitFinanceByUnitGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitFinanceByUnitGuid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitFinancialData
		/// </summary>
		public abstract class GetBloodUnitFinancialData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitFinancialData",
				divisioncode = "@divisioncode",
				productcode = "@productcode",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitGUID
		/// </summary>
		public abstract class GetBloodUnitGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitGUID",
				divisioncode = "@divisioncode",
				labelunitid = "@labelunitid",
				productcode = "@productcode",
				unitdivisionid = "@unitdivisionid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "labelunitid", "productcode"
			};
		}

		/// <summary>
		/// spGetBloodUnitIdAndProductCodeForBloodUnitGuid
		/// </summary>
		public abstract class GetBloodUnitIdAndProductCodeForBloodUnitGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitIdAndProductCodeForBloodUnitGuid",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitMediaByUnitGuid
		/// </summary>
		public abstract class GetBloodUnitMediaByUnitGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitMediaByUnitGuid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitModificationsByUnit
		/// </summary>
		public abstract class GetBloodUnitModificationsByUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitModificationsByUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitModificationsForChildUnit
		/// </summary>
		public abstract class GetBloodUnitModificationsForChildUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitModificationsForChildUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}
		//CR 3193
		//spGetBloodUnitOriginalShipper
		/// <summary>
		/// spGetBloodUnits
		/// </summary>
		public abstract class GetBloodUnitOriginalShipper
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitOriginalShipper",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";
				
			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid","divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnits
		/// </summary>
		public abstract class GetBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnits",
				divisioncode = "@divisioncode",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "shipmentguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitsByAntiBodyTypeId
		/// </summary>
		public abstract class GetBloodUnitsByAntiBodyTypeId
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsByAntiBodyTypeId",
				antibodytypeid = "@antibodytypeid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antibodytypeid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsByIdAndProduct
		/// </summary>
		public abstract class GetBloodUnitsByIdAndProduct
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsByIdAndProduct",
				divisioncode = "@divisioncode",
				donationtypecode = "@donationtypecode",
				labelunitid = "@labelunitid",
				productcode = "@productcode",
				searchcriteria = "@searchcriteria",
				unitdivisionid = "@unitdivisionid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "labelunitid", "productcode", "searchcriteria"
			};
		}

		/// <summary>
		/// spGetBloodUnitsByPatient
		/// </summary>
		public abstract class GetBloodUnitsByPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsByPatient",
				directedpatientguid = "@directedpatientguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"directedpatientguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsByPatientAndComponentClassID
		/// </summary>
		public abstract class GetBloodUnitsByPatientAndComponentClassID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsByPatientAndComponentClassID",
				componentclassid = "@componentclassid",
				directedpatientguid = "@directedpatientguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid", "directedpatientguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsEligibleForCrossover
		/// </summary>
		public abstract class GetBloodUnitsEligibleForCrossover
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsEligibleForCrossover",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsForEdit
		/// </summary>
		public abstract class GetBloodUnitsForEdit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsForEdit",
				divisioncode = "@divisioncode",
				previouslyassociatedunits = "@previouslyassociatedunits";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "previouslyassociatedunits"
			};
		}

		/// <summary>
		/// spGetBloodUnitsForHistoryReport
		/// </summary>
		public abstract class GetBloodUnitsForHistoryReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsForHistoryReport",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsFromBloodUnitShipment
		/// </summary>
		public abstract class GetBloodUnitsFromBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsFromBloodUnitShipment",
				incomingshipmentguid = "@incomingshipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"incomingshipmentguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitsInFinalStatus
		/// </summary>
		public abstract class GetBloodUnitsInFinalStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsInFinalStatus",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitsInPool
		/// </summary>
		public abstract class GetBloodUnitsInPool
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitsInPool",
				divisioncode = "@divisioncode",
				tobloodunitguid = "@tobloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "tobloodunitguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitStatusByGuid
		/// </summary>
		public abstract class GetBloodUnitStatusByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitStatusByGuid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestingWorklist
		/// </summary>
		public abstract class GetBloodUnitTestingWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestingWorklist",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestingWorklistCount
		/// </summary>
		public abstract class GetBloodUnitTestingWorklistCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestingWorklistCount",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestOrder
		/// </summary>
		public abstract class GetBloodUnitTestOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestOrder",
				bloodunittestguid = "@bloodunittestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResult
		/// </summary>
		public abstract class GetBloodUnitTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResult",
				bloodtesttypeid = "@bloodtesttypeid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtesttypeid", "bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResults
		/// </summary>
		public abstract class GetBloodUnitTestResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResults",
				bloodunitguidlist = "@bloodunitguidlist",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguidlist", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResultsForAntiseraWorklist
		/// </summary>
		public abstract class GetBloodUnitTestResultsForAntiseraWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResultsForAntiseraWorklist",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResultsForDivision
		/// </summary>
		public abstract class GetBloodUnitTestResultsForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResultsForDivision",
				bloodtesttypeid = "@bloodtesttypeid",
				divisioncode = "@divisioncode",
				testresultid = "@testresultid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResultsForOrderedComponent
		/// </summary>
		public abstract class GetBloodUnitTestResultsForOrderedComponent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResultsForOrderedComponent",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitTestResultsForOrderedTest
		/// </summary>
		public abstract class GetBloodUnitTestResultsForOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitTestResultsForOrderedTest",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetBloodUnitWrkLst
		/// </summary>
		public abstract class GetBloodUnitWrkLst
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBloodUnitWrkLst",
				divisioncode = "@divisioncode",
				productguid = "@productguid",
				unitid = "@unitid",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productguid", "unitid"
			};
		}

		/// <summary>
		/// spGetBoodUnitTestResultsForTransfusionReaction
		/// </summary>
		public abstract class GetBoodUnitTestResultsForTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBoodUnitTestResultsForTransfusionReaction",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetBrokenRulesValidationMessages
		/// </summary>
		public abstract class GetBrokenRulesValidationMessages
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetBrokenRulesValidationMessages",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetCacheLastUpdateDates
		/// </summary>
		public abstract class GetCacheLastUpdateDates
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCacheLastUpdateDates",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetCanChangeExpectedMinReactions
		/// </summary>
		public abstract class GetCanChangeExpectedMinReactions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCanChangeExpectedMinReactions",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetCannedComment
		/// </summary>
		public abstract class GetCannedComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCannedComment",
				cannedcommentguid = "@cannedcommentguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"cannedcommentguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetCannedCommentCategories
		/// </summary>
		public abstract class GetCannedCommentCategories
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCannedCommentCategories",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetCannedComments
		/// </summary>
		public abstract class GetCannedComments
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCannedComments",
				cannedcommentcategorycode = "@cannedcommentcategorycode",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetCompatibleCryoUnits
		/// </summary>
		public abstract class GetCompatibleCryoUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatibleCryoUnits",
				bloodtypecode = "@bloodtypecode",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode", "divisioncode"
			};
		}

		/// <summary>
		/// spGetCompatibleFFPUnits
		/// </summary>
		public abstract class GetCompatibleFFPUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatibleFFPUnits",
				bloodtypecode = "@bloodtypecode",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode", "divisioncode"
			};
		}

		/// <summary>
		/// spGetCompatibleNonWholeBloodNonPlasmaUnits
		/// </summary>
		public abstract class GetCompatibleNonWholeBloodNonPlasmaUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatibleNonWholeBloodNonPlasmaUnits",
				BloodTypeCode = "@BloodTypeCode",
				DivisionCode = "@DivisionCode",
				RhFactorCode = "@RhFactorCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodTypeCode", "DivisionCode", "RhFactorCode"
			};
		}

		/// <summary>
		/// spGetCompatibleOtherBloodUnits
		/// </summary>
		public abstract class GetCompatibleOtherBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatibleOtherBloodUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetCompatiblePlateletBloodUnits
		/// </summary>
		public abstract class GetCompatiblePlateletBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatiblePlateletBloodUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetCompatibleWholeBloodUnits
		/// </summary>
		public abstract class GetCompatibleWholeBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompatibleWholeBloodUnits",
				bloodtypecode = "@bloodtypecode",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				rhfactorcode = "@rhfactorcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode", "divisioncode", "patientguid", "rhfactorcode"
			};
		}

		/// <summary>
		/// spGetCompleteAntibodyTypeList
		/// </summary>
		public abstract class GetCompleteAntibodyTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompleteAntibodyTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetCompletedPatientTransfusionReactions
		/// </summary>
		public abstract class GetCompletedPatientTransfusionReactions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCompletedPatientTransfusionReactions",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetComponentClass
		/// </summary>
		public abstract class GetComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentClass",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetComponentClassFromId
		/// </summary>
		public abstract class GetComponentClassFromId
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentClassFromId",
				componentclassid = "@componentclassid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid"
			};
		}

		/// <summary>
		/// spGetComponentClassList
		/// </summary>
		public abstract class GetComponentClassList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentClassList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetComponentClassTypeLookupList
		/// </summary>
		public abstract class GetComponentClassTypeLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentClassTypeLookupList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetComponentRequirements
		/// </summary>
		public abstract class GetComponentRequirements
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentRequirements",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetComponentTaskList
		/// </summary>
		public abstract class GetComponentTaskList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetComponentTaskList",
				divisioncode = "@divisioncode",
				ordergroupnumber = "@ordergroupnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetConfigurableRackQC
		/// </summary>
		public abstract class GetConfigurableRackQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetConfigurableRackQC",
				dailycontrolguid = "@dailycontrolguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailycontrolguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetConfigureDailyQCByGUID
		/// </summary>
		public abstract class GetConfigureDailyQCByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetConfigureDailyQCByGUID",
				divisioncode = "@divisioncode",
				existingdailycontrolguid = "@existingdailycontrolguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "existingdailycontrolguid"
			};
		}

		/// <summary>
		/// spGetConfigureReagentQC
		/// </summary>
		public abstract class GetConfigureReagentQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetConfigureReagentQC",
				commercialindicator = "@commercialindicator",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commercialindicator", "divisioncode"
			};
		}

		/// <summary>
		/// spGetCprsOrderable
		/// </summary>
		public abstract class GetCprsOrderable
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCprsOrderable",
				orderabletestid = "@orderabletestid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderabletestid"
			};
		}

		/// <summary>
		/// spGetCrossmatchedUnitsInDateRange
		/// </summary>
		public abstract class GetCrossmatchedUnitsInDateRange
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCrossmatchedUnitsInDateRange",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				multidivisional = "@multidivisional",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetCrossmatchedUnitsInDateRangeCount
		/// </summary>
		public abstract class GetCrossmatchedUnitsInDateRangeCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCrossmatchedUnitsInDateRangeCount",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				multidivisional = "@multidivisional",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetCurrentCrossmatchResults
		/// </summary>
		public abstract class GetCurrentCrossmatchResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCurrentCrossmatchResults",
				divisioncode = "@divisioncode",
				orderedunitguid = "@orderedunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedunitguid"
			};
		}

		/// <summary>
		/// spGetCurrentPatientLocation
		/// </summary>
		public abstract class GetCurrentPatientLocation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetCurrentPatientLocation",
				PatientGuid = "@PatientGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientGuid"
			};
		}

		/// <summary>
		/// spGetDailyControl
		/// </summary>
		public abstract class GetDailyControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDailyControl",
				divisioncode = "@divisioncode",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordstatuscode"
			};
		}

		/// <summary>
		/// spGetDailyControlRack
		/// </summary>
		public abstract class GetDailyControlRack
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDailyControlRack",
				commercialtemplateindicator = "@commercialtemplateindicator",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commercialtemplateindicator", "divisioncode"
			};
		}

		/// <summary>
		/// spGetDailyQCRacks
		/// </summary>
		public abstract class GetDailyQCRacks
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDailyQCRacks",
				divisioncode = "@divisioncode",
				testdatetime = "@testdatetime";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "testdatetime"
			};
		}

		/// <summary>
		/// spGetDailyQCReagentTypes
		/// </summary>
		public abstract class GetDailyQCReagentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDailyQCReagentTypes",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}
        
		/// <summary>
		/// spGetDailyQCReagentTypesForPartiallyCompletedQc
		/// </summary>
		public abstract class GetDailyQCReagentTypesForPartiallyCompletedQc
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDailyQCReagentTypesForPartiallyCompletedQc",
				dailyqcworklistguid = "@dailyqcworklistguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid"
			};
		}

		/// <summary>
		/// spGetDiscardedUnits
		/// </summary>
		public abstract class GetDiscardedUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDiscardedUnits",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetDiscardOrQuarantineData
		/// </summary>
		public abstract class GetDiscardOrQuarantineData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDiscardOrQuarantineData",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetDiscardOrQuarantineUnits
		/// </summary>
		public abstract class GetDiscardOrQuarantineUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDiscardOrQuarantineUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetDivision
		/// </summary>
		public abstract class GetDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetDivisionCurrentDateTime
		/// </summary>
		public abstract class GetDivisionCurrentDateTime
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDivisionCurrentDateTime",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetDivisionTimeZone
		/// </summary>
		public abstract class GetDivisionTimeZone
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDivisionTimeZone",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetDivisionTimeZoneAbbreviation
		/// </summary>
		public abstract class GetDivisionTimeZoneAbbreviation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDivisionTimeZoneAbbreviation",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetDivisionWorkloadReport
		/// </summary>
		public abstract class GetDivisionWorkloadReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDivisionWorkloadReport",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				singledivision = "@singledivision",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "singledivision", "startdate"
			};
		}

		/// <summary>
		/// spGetDonationTypeByCode
		/// </summary>
		public abstract class GetDonationTypeByCode
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDonationTypeByCode",
				DonationTypeCode = "@DonationTypeCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DonationTypeCode"
			};
		}

		/// <summary>
		/// spGetDonationTypeByID
		/// </summary>
		public abstract class GetDonationTypeByID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDonationTypeByID",
				donationtypeid = "@donationtypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"donationtypeid"
			};
		}

		/// <summary>
		/// spGetDonationTypeLookupList
		/// </summary>
		public abstract class GetDonationTypeLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDonationTypeLookupList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetDssExtract
		/// </summary>
		public abstract class GetDssExtract
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetDssExtract",
				divisioncode = "@divisioncode",
				patienttransfusionguid = "@patienttransfusionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEligibleUnitsForDivision
		/// </summary>
		public abstract class GetEligibleUnitsForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEligibleUnitsForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEmergencyIssuedUnitsCountForOrderedTest
		/// </summary>
		public abstract class GetEmergencyIssuedUnitsCountForOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEmergencyIssuedUnitsCountForOrderedTest",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedtestguid"
			};
		}

		/// <summary>
		/// spGetEnhancementMedia
		/// </summary>
		public abstract class GetEnhancementMedia
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEnhancementMedia",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetEquipment
		/// </summary>
		public abstract class GetEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipment",
				divisioncode = "@divisioncode",
				equipmenttype = "@equipmenttype",
				includeall = "@includeall",
				manufacturername = "@manufacturername",
				serialnumber = "@serialnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEquipmentByGUID
		/// </summary>
		public abstract class GetEquipmentByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentByGUID",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentguid"
			};
		}

		/// <summary>
		/// spGetEquipmentBySerialNumberAndManufacturer
		/// </summary>
		public abstract class GetEquipmentBySerialNumberAndManufacturer
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentBySerialNumberAndManufacturer",
				divisioncode = "@divisioncode",
				manufacturername = "@manufacturername",
				serialnumber = "@serialnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "manufacturername", "serialnumber"
			};
		}

		/// <summary>
		/// spGetEquipmentDetails
		/// </summary>
		public abstract class GetEquipmentDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentDetails",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEquipmentMaintenance
		/// </summary>
		public abstract class GetEquipmentMaintenance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentMaintenance",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEquipmentMaintenanceByGuid
		/// </summary>
		public abstract class GetEquipmentMaintenanceByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentMaintenanceByGuid",
				divisioncode = "@divisioncode",
				equipmentmaintenanceguid = "@equipmentmaintenanceguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentmaintenanceguid"
			};
		}

		/// <summary>
		/// spGetEquipmentMaintenanceForEquipment
		/// </summary>
		public abstract class GetEquipmentMaintenanceForEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentMaintenanceForEquipment",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentguid"
			};
		}

		/// <summary>
		/// spGetEquipmentMaintenanceTypes
		/// </summary>
		public abstract class GetEquipmentMaintenanceTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentMaintenanceTypes",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEquipmentManufacturers
		/// </summary>
		public abstract class GetEquipmentManufacturers
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentManufacturers",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetEquipmentRecordForReport
		/// </summary>
		public abstract class GetEquipmentRecordForReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentRecordForReport",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentguid"
			};
		}

		/// <summary>
		/// spGetEquipmentTypes
		/// </summary>
		public abstract class GetEquipmentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetEquipmentTypes",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportAboIncompatibleTransfusion
		/// </summary>
		public abstract class GetExceptionReportAboIncompatibleTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportAboIncompatibleTransfusion",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportAboIncompatibleTransfusionForPatient
		/// </summary>
		public abstract class GetExceptionReportAboIncompatibleTransfusionForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportAboIncompatibleTransfusionForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportAntigenTestInvalidated
		/// </summary>
		public abstract class GetExceptionReportAntigenTestInvalidated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportAntigenTestInvalidated",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportAntigenTestInvalidatedForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportAntigenTestInvalidatedForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportAntigenTestInvalidatedForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportCautionTagBTRF
		/// </summary>
		public abstract class GetExceptionReportCautionTagBTRF
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportCautionTagBTRF",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportCautionTagBtrfForPatient
		/// </summary>
		public abstract class GetExceptionReportCautionTagBtrfForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportCautionTagBtrfForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportElectronicTransfusion
		/// </summary>
		public abstract class GetExceptionReportElectronicTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportElectronicTransfusion",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportEmergencyIssueOrder
		/// </summary>
		public abstract class GetExceptionReportEmergencyIssueOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportEmergencyIssueOrder",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportEmergencyIssueOrderForPatient
		/// </summary>
		public abstract class GetExceptionReportEmergencyIssueOrderForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportEmergencyIssueOrderForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportEmergencyIssueUnitTest
		/// </summary>
		public abstract class GetExceptionReportEmergencyIssueUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportEmergencyIssueUnitTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportEmergencyIssueUnitTestForPatient
		/// </summary>
		public abstract class GetExceptionReportEmergencyIssueUnitTestForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportEmergencyIssueUnitTestForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportExpiredTask
		/// </summary>
		public abstract class GetExceptionReportExpiredTask
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportExpiredTask",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportExpiredUnitReceived
		/// </summary>
		public abstract class GetExceptionReportExpiredUnitReceived
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportExpiredUnitReceived",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportExpiredUnitReceivedForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportExpiredUnitReceivedForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportExpiredUnitReceivedForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportInconclusiveCrossmatch
		/// </summary>
		public abstract class GetExceptionReportInconclusiveCrossmatch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportInconclusiveCrossmatch",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportLabelMismatch
		/// </summary>
		public abstract class GetExceptionReportLabelMismatch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportLabelMismatch",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportLabelMismatchForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportLabelMismatchForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportLabelMismatchForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAboRh
		/// </summary>
		public abstract class GetExceptionReportPatientAboRh
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAboRh",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAboRHDiscrepancy
		/// </summary>
		public abstract class GetExceptionReportPatientAboRHDiscrepancy
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAboRHDiscrepancy",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAboRHDiscrepancyForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientAboRHDiscrepancyForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAboRHDiscrepancyForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAboRhForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientAboRhForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAboRhForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAntigenDiscrepancy
		/// </summary>
		public abstract class GetExceptionReportPatientAntigenDiscrepancy
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAntigenDiscrepancy",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientAntigenDiscrepancyForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientAntigenDiscrepancyForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientAntigenDiscrepancyForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientRestriction
		/// </summary>
		public abstract class GetExceptionReportPatientRestriction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientRestriction",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientRestrictionForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientRestrictionForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientRestrictionForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientTest
		/// </summary>
		public abstract class GetExceptionReportPatientTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientTestForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientTestForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientTestForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientTestInactivated
		/// </summary>
		public abstract class GetExceptionReportPatientTestInactivated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientTestInactivated",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportPatientTestInactivatedForPatient
		/// </summary>
		public abstract class GetExceptionReportPatientTestInactivatedForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportPatientTestInactivatedForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportQC
		/// </summary>
		public abstract class GetExceptionReportQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQC",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportQcForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportQcForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQcForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportQcForPatient
		/// </summary>
		public abstract class GetExceptionReportQcForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQcForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportQCInactivated
		/// </summary>
		public abstract class GetExceptionReportQCInactivated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQCInactivated",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportQcNotPerformed
		/// </summary>
		public abstract class GetExceptionReportQcNotPerformed
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQcNotPerformed",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportQcNotPerformedForPatient
		/// </summary>
		public abstract class GetExceptionReportQcNotPerformedForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQcNotPerformedForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportQuarantine
		/// </summary>
		public abstract class GetExceptionReportQuarantine
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQuarantine",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportQuarantineForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportQuarantineForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQuarantineForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportQuarantineForPatient
		/// </summary>
		public abstract class GetExceptionReportQuarantineForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportQuarantineForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportReflexTest
		/// </summary>
		public abstract class GetExceptionReportReflexTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportReflexTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportReflexTestForPatient
		/// </summary>
		public abstract class GetExceptionReportReflexTestForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportReflexTestForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportRemoveFinalUnitStatus
		/// </summary>
		public abstract class GetExceptionReportRemoveFinalUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportRemoveFinalUnitStatus",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportRemoveFinalUnitStatusForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportRemoveFinalUnitStatusForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportRemoveFinalUnitStatusForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportReturnIssuedUnit
		/// </summary>
		public abstract class GetExceptionReportReturnIssuedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportReturnIssuedUnit",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportReturnIssuedUnitForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportReturnIssuedUnitForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportReturnIssuedUnitForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportReturnIssuedUnitForPatient
		/// </summary>
		public abstract class GetExceptionReportReturnIssuedUnitForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportReturnIssuedUnitForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportSpecimen
		/// </summary>
		public abstract class GetExceptionReportSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportSpecimen",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportSpecimenForPatient
		/// </summary>
		public abstract class GetExceptionReportSpecimenForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportSpecimenForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportTransfusion
		/// </summary>
		public abstract class GetExceptionReportTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTransfusion",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportTransfusionForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportTransfusionForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTransfusionForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportTransfusionForPatient
		/// </summary>
		public abstract class GetExceptionReportTransfusionForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTransfusionForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportTransfusionReactionWorkup
		/// </summary>
		public abstract class GetExceptionReportTransfusionReactionWorkup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTransfusionReactionWorkup",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportTransfusionReactionWorkupForPatient
		/// </summary>
		public abstract class GetExceptionReportTransfusionReactionWorkupForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTransfusionReactionWorkupForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportTrwSpecimen
		/// </summary>
		public abstract class GetExceptionReportTrwSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTrwSpecimen",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportTrwSpecimenForPatient
		/// </summary>
		public abstract class GetExceptionReportTrwSpecimenForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportTrwSpecimenForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitAboRh
		/// </summary>
		public abstract class GetExceptionReportUnitAboRh
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitAboRh",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitAboRhForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportUnitAboRhForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitAboRhForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitIssue
		/// </summary>
		public abstract class GetExceptionReportUnitIssue
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitIssue",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitIssueForPatient
		/// </summary>
		public abstract class GetExceptionReportUnitIssueForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitIssueForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitModification
		/// </summary>
		public abstract class GetExceptionReportUnitModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitModification",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitModificationForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportUnitModificationForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitModificationForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitSelection
		/// </summary>
		public abstract class GetExceptionReportUnitSelection
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitSelection",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitSelectionForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportUnitSelectionForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitSelectionForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitSelectionForPatient
		/// </summary>
		public abstract class GetExceptionReportUnitSelectionForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitSelectionForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitSupply
		/// </summary>
		public abstract class GetExceptionReportUnitSupply
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitSupply",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitSupplyForBloodUnit
		/// </summary>
		public abstract class GetExceptionReportUnitSupplyForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitSupplyForBloodUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetExceptionReportUnitTest
		/// </summary>
		public abstract class GetExceptionReportUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExceptionReportUnitTest",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetExistingReagentTypes
		/// </summary>
		public abstract class GetExistingReagentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetExistingReagentTypes",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetFacilityByFacilityGuid
		/// </summary>
		public abstract class GetFacilityByFacilityGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetFacilityByFacilityGuid",
				facilityguid = "@facilityguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"facilityguid"
			};
		}

		/// <summary>
		/// spGetFacilityNationalLookupList
		/// </summary>
		public abstract class GetFacilityNationalLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetFacilityNationalLookupList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetFinancialBloodUnits
		/// </summary>
		public abstract class GetFinancialBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetFinancialBloodUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetHcpcsAssignmentHistory
		/// </summary>
		public abstract class GetHcpcsAssignmentHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHcpcsAssignmentHistory",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetHcpcsCache
		/// </summary>
		public abstract class GetHcpcsCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHcpcsCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetHemolysisInspectionList
		/// </summary>
		public abstract class GetHemolysisInspectionList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHemolysisInspectionList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetHistoricalOrderedUnits
		/// </summary>
		public abstract class GetHistoricalOrderedUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHistoricalOrderedUnits",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetHistoricalResultsForOrderedTest
		/// </summary>
		public abstract class GetHistoricalResultsForOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHistoricalResultsForOrderedTest",
				OrderedTestGuid = "@OrderedTestGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderedTestGuid"
			};
		}

		/// <summary>
		/// spGetHospitalLocationCache
		/// </summary>
		public abstract class GetHospitalLocationCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetHospitalLocationCache",
				locationdivision = "@locationdivision";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"locationdivision"
			};
		}

		/// <summary>
		/// spGetImplicatedUnitsForPatientTransfusionReaction
		/// </summary>
		public abstract class GetImplicatedUnitsForPatientTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetImplicatedUnitsForPatientTransfusionReaction",
				divisioncode = "@divisioncode",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionreactionguid"
			};
		}

		/// <summary>
		/// spGetInactivatedUnitsList
		/// </summary>
		public abstract class GetInactivatedUnitsList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetInactivatedUnitsList",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetInappropriateTransfusionRequestReportCount
		/// </summary>
		public abstract class GetInappropriateTransfusionRequestReportCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetInappropriateTransfusionRequestReportCount",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				lastupdatedate = "@lastupdatedate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetInappropriateTransfusionRequests
		/// </summary>
		public abstract class GetInappropriateTransfusionRequests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetInappropriateTransfusionRequests",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetIncomingShipment
		/// </summary>
		public abstract class GetIncomingShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIncomingShipment",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				localsupplierguid = "@localsupplierguid",
				processingdate = "@processingdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetIncomingShipmentsList
		/// </summary>
		public abstract class GetIncomingShipmentsList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIncomingShipmentsList",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetInterfaceActiveIndicator
		/// </summary>
		public abstract class GetInterfaceActiveIndicator
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetInterfaceActiveIndicator",
				interfacename = "@interfacename";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"interfacename"
			};
		}

		/// <summary>
		/// spGetInvoiceText
		/// </summary>
		public abstract class GetInvoiceText
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetInvoiceText",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetIssuedAndTransfusedUnitsForPatient
		/// </summary>
		public abstract class GetIssuedAndTransfusedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssuedAndTransfusedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetIssuedUnit
		/// </summary>
		public abstract class GetIssuedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssuedUnit",
				divisioncode = "@divisioncode",
				issuedunitguid = "@issuedunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "issuedunitguid"
			};
		}

		/// <summary>
		/// spGetIssuedUnitFromGuid
		/// </summary>
		public abstract class GetIssuedUnitFromGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssuedUnitFromGuid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetIssuedUnitsForPatient
		/// </summary>
		public abstract class GetIssuedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssuedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetIssuedUnitsList
		/// </summary>
		public abstract class GetIssuedUnitsList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssuedUnitsList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetIssueToLocationList
		/// </summary>
		public abstract class GetIssueToLocationList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetIssueToLocationList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetLabTests
		/// </summary>
		public abstract class GetLabTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLabTests",
				divisioncode = "@divisioncode",
				reporttypeid = "@reporttypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reporttypeid"
			};
		}

		/// <summary>
		/// spGetLimitedBloodUnit
		/// </summary>
		public abstract class GetLimitedBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLimitedBloodUnit",
				allowallunitstati = "@allowallunitstati",
				allownegativerh = "@allownegativerh",
				divisioncode = "@divisioncode",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"allowallunitstati", "allownegativerh", "divisioncode"
			};
		}

		/// <summary>
		/// spGetLimitedBloodUnitsByDivision
		/// </summary>
		public abstract class GetLimitedBloodUnitsByDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLimitedBloodUnitsByDivision",
				allowallproducttypes = "@allowallproducttypes",
				allownegativerh = "@allownegativerh",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"allownegativerh", "divisioncode"
			};
		}

		/// <summary>
		/// spGetLocalSupplierByFdaRegistrationNumber
		/// </summary>
		public abstract class GetLocalSupplierByFdaRegistrationNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLocalSupplierByFdaRegistrationNumber",
				activeonly = "@activeonly",
				divisioncode = "@divisioncode",
				fdaregistrationnumber = "@fdaregistrationnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"fdaregistrationnumber"
			};
		}

		/// <summary>
		/// spGetLocalSupplierByGuid
		/// </summary>
		public abstract class GetLocalSupplierByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLocalSupplierByGuid",
				activeonly = "@activeonly",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"localsupplierguid"
			};
		}

		/// <summary>
		/// spGetLocalSupplierByICCBARegistrationNumber
		/// </summary>
		public abstract class GetLocalSupplierByICCBARegistrationNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLocalSupplierByICCBARegistrationNumber",
				activeonly = "@activeonly",
				divisioncode = "@divisioncode",
				iccbaregistrationnumber = "@iccbaregistrationnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"iccbaregistrationnumber"
			};
		}

		/// <summary>
		/// spGetLocalSupplierLookupList
		/// </summary>
		public abstract class GetLocalSupplierLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLocalSupplierLookupList",
				divisioncode = "@divisioncode",
				facilityname = "@facilityname",
				fdaregistrationnumber = "@fdaregistrationnumber";
		}

		/// <summary>
		/// spGetLocalSuppliersForDivision
		/// </summary>
		public abstract class GetLocalSuppliersForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLocalSuppliersForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetLock
		/// </summary>
		public abstract class GetVbecsLock
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsLock",
				divisioncode = "@divisioncode",
				recordguid = "@recordguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordguid"
			};
		}

		/// <summary>
		/// spGetLockFunctionList
		/// </summary>
		public abstract class GetLockFunctionList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetLockFunctionList",
				No_parameters = "No_parameters";
		}

		/// <summary>
        /// spGetLocksByLockedFormId
		/// </summary>
		public abstract class GetLocksByLockedFormId
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
                StoredProcName = "dbo.spGetLocksByLockedFormId",
				divisioncode = "@divisioncode",
				lockedformid = "@lockedformid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lockedformid"
			};
		}

		/// <summary>
		/// spGetManufacturerAddresses
		/// </summary>
		public abstract class GetManufacturerAddresses
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetManufacturerAddresses",
				manufacturername = "@manufacturername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"manufacturername"
			};
		}

		/// <summary>
		/// spGetManufacturerReagentNames
		/// </summary>
		public abstract class GetManufacturerReagentNames
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetManufacturerReagentNames",
				divisioncode = "@divisioncode",
				reagentmanufacturername = "@reagentmanufacturername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagentmanufacturername"
			};
		}

		/// <summary>
		/// spGetMedicalDirectors
		/// </summary>
		public abstract class GetMedicalDirectors
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetMedicalDirectors",
				DivisionCode = "@DivisionCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode"
			};
		}

		/// <summary>
		/// spGetMirrorBloodUnitMediaDirectedPatient
		/// </summary>
		public abstract class GetMirrorBloodUnitMediaDirectedPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetMirrorBloodUnitMediaDirectedPatient",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetModifiableBloodUnits
		/// </summary>
		public abstract class GetModifiableBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetModifiableBloodUnits",
				divisioncode = "@divisioncode",
				includeallstatus = "@includeallstatus",
				modificationmethod = "@modificationmethod",
				productmodificationcode = "@productmodificationcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "modificationmethod", "productmodificationcode"
			};
		}

		/// <summary>
		/// spGetModifiedBloodUnitChildren
		/// </summary>
		public abstract class GetModifiedBloodUnitChildren
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetModifiedBloodUnitChildren",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetModifiedBloodUnits
		/// </summary>
		public abstract class GetModifiedBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetModifiedBloodUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetModifiedUnitEquipment
		/// </summary>
		public abstract class GetModifiedUnitEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetModifiedUnitEquipment",
				bloodunitmodificationguid = "@bloodunitmodificationguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid"
			};
		}

		/// <summary>
		/// spGetModifiedUnitSupplies
		/// </summary>
		public abstract class GetModifiedUnitSupplies
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetModifiedUnitSupplies",
				bloodunitmodificationguid = "@bloodunitmodificationguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid"
			};
		}

		/// <summary>
		/// spGetMostRecentBloodUnitShipmentRecordForBloodUnit
		/// </summary>
		public abstract class GetMostRecentBloodUnitShipmentRecordForBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetMostRecentBloodUnitShipmentRecordForBloodUnit",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetMsbosComponents
		/// </summary>
		public abstract class GetMsbosComponents
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetMsbosComponents",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetNewOrderedComponents
		/// </summary>
		public abstract class GetNewOrderedComponents
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedComponents",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked"
			};
		}

		/// <summary>
		/// spGetNewOrderedComponentsForRequiredTimeFrame
		/// </summary>
		public abstract class GetNewOrderedComponentsForRequiredTimeFrame
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedComponentsForRequiredTimeFrame",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked",
				requiredhours = "@requiredhours";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked", "requiredhours"
			};
		}

		/// <summary>
		/// spGetNewOrderedComponentsWithNoRequiredSpecimenOrSpecimenOnFile
		/// </summary>
		public abstract class GetNewOrderedComponentsWithNoRequiredSpecimenOrSpecimenOnFile
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedComponentsWithNoRequiredSpecimenOrSpecimenOnFile",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked"
			};
		}

		/// <summary>
		/// spGetNewOrderedTests
		/// </summary>
		public abstract class GetNewOrderedTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedTests",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked"
			};
		}

		/// <summary>
		/// spGetNewOrderedTestsForRequiredTimeFrame
		/// </summary>
		public abstract class GetNewOrderedTestsForRequiredTimeFrame
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedTestsForRequiredTimeFrame",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked",
				requiredhours = "@requiredhours";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked", "requiredhours"
			};
		}

		/// <summary>
		/// spGetNewOrderedTestsWithNoRequiredSpecimenOrSpecimenOnFile
		/// </summary>
		public abstract class GetNewOrderedTestsWithNoRequiredSpecimenOrSpecimenOnFile
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrderedTestsWithNoRequiredSpecimenOrSpecimenOnFile",
				divisioncode = "@divisioncode",
				lastchecked = "@lastchecked";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lastchecked"
			};
		}

		/// <summary>
		/// spGetNewOrdersCount
		/// </summary>
		public abstract class GetNewOrdersCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNewOrdersCount",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetNextVbecsOrderNumber
		/// </summary>
		public abstract class GetNextVbecsOrderNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetNextVbecsOrderNumber",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";
		}

		/// <summary>
		/// spGetOffsiteABID
		/// </summary>
		public abstract class GetOffsiteABID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOffsiteABID",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetOrderableComponentClasses
		/// </summary>
		public abstract class GetOrderableComponentClasses
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderableComponentClasses",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetOrderableTestIDOrComponentClassIDFromCPRSOrderableItemID
		/// </summary>
		public abstract class GetOrderableTestIDOrComponentClassIDFromCPRSOrderableItemID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderableTestIDOrComponentClassIDFromCPRSOrderableItemID",
				CprsOrderableItemId = "@CprsOrderableItemID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"CprsOrderableItemId"
			};
		}

		/// <summary>
		/// spGetOrderableTestList
		/// </summary>
		public abstract class GetOrderableTestList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderableTestList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetOrderAlertType
		/// </summary>
		public abstract class GetOrderAlertType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderAlertType",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetOrderData
		/// </summary>
		public abstract class GetOrderData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderData",
				cprsordernumber = "@cprsordernumber",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"cprsordernumber", "divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderDataTests
		/// </summary>
		public abstract class GetOrderDataTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderDataTests",
				cprsordernumber = "@cprsordernumber",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"cprsordernumber", "divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderedComponent
		/// </summary>
		public abstract class GetOrderedComponent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedComponent",
				divisioncode = "@divisioncode",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetOrderedComponentbyCprsOrderNumber
		/// </summary>
		public abstract class GetOrderedComponentbyCprsOrderNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedComponentbyCprsOrderNumber",
				CprsOrderNumber = "@CprsOrderNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"CprsOrderNumber"
			};
		}

		/// <summary>
		/// spGetOrderedComponentQuantity
		/// </summary>
		public abstract class GetOrderedComponentQuantity
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedComponentQuantity",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetOrderedTest
		/// </summary>
		public abstract class GetOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedTest",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetOrderedTestbyCprsOrderNumber
		/// </summary>
		public abstract class GetOrderedTestbyCprsOrderNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedTestbyCprsOrderNumber",
				CprsOrderNumber = "@CprsOrderNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"CprsOrderNumber"
			};
		}

		/// <summary>
		/// spGetOrderedTests
		/// </summary>
		public abstract class GetOrderedTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedTests",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetOrderedTestsforSpecimen
		/// </summary>
		public abstract class GetOrderedTestsforSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedTestsforSpecimen",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnit
		/// </summary>
		public abstract class GetOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderedUnitByComponent
		/// </summary>
		public abstract class GetOrderedUnitByComponent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitByComponent",
				divisioncode = "@divisioncode",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitByGUID
		/// </summary>
		public abstract class GetOrderedUnitByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitByGUID",
				divisioncode = "@divisioncode",
				orderedunitguid = "@orderedunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedunitguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitByPatientAndUnit
		/// </summary>
		public abstract class GetOrderedUnitByPatientAndUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitByPatientAndUnit",
				bloodunitguidlist = "@bloodunitguidlist",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguidlist", "divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitCount
		/// </summary>
		public abstract class GetOrderedUnitCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitCount",
				divisioncode = "@divisioncode",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitRecordHistoryForPatient
		/// </summary>
		public abstract class GetOrderedUnitRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitsForDivision
		/// </summary>
		public abstract class GetOrderedUnitsForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitsForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderedUnitsForPatient
		/// </summary>
		public abstract class GetOrderedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitsForPatientSpecimen
		/// </summary>
		public abstract class GetOrderedUnitsForPatientSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitsForPatientSpecimen",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetOrderedUnitsForRepeatXM
		/// </summary>
		public abstract class GetOrderedUnitsForRepeatXM
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitsForRepeatXM",
				divisioncode = "@divisioncode",
				orderedcomponentguid = "@orderedcomponentguid",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderedUnitsForUnit
		/// </summary>
		public abstract class GetOrderedUnitsForUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderedUnitsForUnit",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetOrderSearchDetails
		/// </summary>
		public abstract class GetOrderSearchDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderSearchDetails",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				patientlastname = "@patientlastname",
				patientssn = "@patientssn",
				specimenuid = "@specimenuid",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetOrderStatus
		/// </summary>
		public abstract class GetOrderStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderStatus",
				orderstatuscode = "@orderstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderstatuscode"
			};
		}

		/// <summary>
		/// spGetOrderUrgencyList
		/// </summary>
		public abstract class GetOrderUrgencyList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOrderUrgencyList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetOutgoingBloodUnitShipment
		/// </summary>
		public abstract class GetOutgoingBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOutgoingBloodUnitShipment",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetOutgoingInvoice
		/// </summary>
		public abstract class GetOutgoingInvoice
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOutgoingInvoice",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				localsupplierguid = "@localsupplierguid",
				shipmentdate = "@shipmentdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber", "localsupplierguid", "shipmentdate"
			};
		}

		/// <summary>
		/// spGetOutgoingInvoiceByGuid
		/// </summary>
		public abstract class GetOutgoingInvoiceByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOutgoingInvoiceByGuid",
				divisioncode = "@divisioncode",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "shipmentguid"
			};
		}

		/// <summary>
		/// spGetOutgoingShipmentsList
		/// </summary>
		public abstract class GetOutgoingShipmentsList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetOutgoingShipmentsList",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetPartiallyCompletedQC
		/// </summary>
		public abstract class GetPartiallyCompletedQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPartiallyCompletedQC",
				divisioncode = "@divisioncode",
				testdatetime = "@testdatetime";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "testdatetime"
			};
		}

		/// <summary>
		/// spGetPatientAboHistory
		/// </summary>
		public abstract class GetPatientAboHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientAboHistory",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientAboRh
		/// </summary>
		public abstract class GetPatientAboRh
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientAboRh",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientguid"
			};
		}

		/// <summary>
		/// spGetPatientAboRHHistory
		/// </summary>
		public abstract class GetPatientAboRHHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientAboRHHistory",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientABORhJustificationReason
		/// </summary>
		public abstract class GetPatientAboRhJustificationReason
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientABORhJustificationReason",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientguid"
			};
		}

		/// <summary>
		/// spGetPatientComponentOrdersAll
		/// </summary>
		public abstract class GetPatientComponentOrdersAll
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientComponentOrdersAll",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPatientDemographicHistoryForPatient
		/// </summary>
		public abstract class GetPatientDemographicHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientDemographicHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientDetails
		/// </summary>
		public abstract class GetPatientDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientDetails",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				patienticn = "@patienticn",
				searchfield = "@searchfield",
				vistapatientid = "@vistapatientid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientDetailsByMergeGroup
		/// </summary>
		public abstract class GetPatientDetailsByMergeGroup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientDetailsByMergeGroup",
				detailed = "@detailed",
				mergefrompatient = "@mergefrompatient",
				mergetopatient = "@mergetopatient",
				patientmergegroup = "@patientmergegroup";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"detailed", "mergefrompatient", "mergetopatient", "patientmergegroup"
			};
		}

		/// <summary>
		/// spGetPatientForOrderedUnit
		/// </summary>
		public abstract class GetPatientForOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientForOrderedUnit",
				orderedunitguid = "@orderedunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedunitguid"
			};
		}

		/// <summary>
		/// spGetPatientGuidForPatient
		/// </summary>
		public abstract class GetPatientGuidForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientGuidForPatient",
				patientssn = "@patientssn",
				vistapatientid = "@vistapatientid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vistapatientid"
			};
		}

		/// <summary>
		/// spGetPatientOrder
		/// </summary>
		public abstract class GetPatientOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientOrder",
				divisioncode = "@divisioncode",
				patientorderguid = "@patientorderguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientorderguid"
			};
		}

		/// <summary>
		/// spGetPatientOrderbyOrderGroupNumber
		/// </summary>
		public abstract class GetPatientOrderbyOrderGroupNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientOrderbyOrderGroupNumber",
				OrderGroupNumber = "@OrderGroupNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderGroupNumber"
			};
		}

		/// <summary>
		/// spGetPatientRecordReportCount
		/// </summary>
		public abstract class GetPatientRecordReportCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientRecordReportCount",
				divisioncode = "@divisioncode",
				includedemographics = "@includedemographics",
				includeexceptions = "@includeexceptions",
				includepatienttests = "@includepatienttests",
				includespecialinstructions = "@includespecialinstructions",
				includespecimens = "@includespecimens",
				includetransfusionreactions = "@includetransfusionreactions",
				includetransfusionrequirements = "@includetransfusionrequirements",
				includetransfusions = "@includetransfusions",
				includeunitassignments = "@includeunitassignments",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "includedemographics", "includeexceptions", "includepatienttests", "includespecialinstructions", "includespecimens", "includetransfusionreactions", "includetransfusionrequirements", "includetransfusions", "includeunitassignments", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientSpecialInstructionRecordHistoryForPatient
		/// </summary>
		public abstract class GetPatientSpecialInstructionRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientSpecialInstructionRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientSpecimenRecordHistoryForPatient
		/// </summary>
		public abstract class GetPatientSpecimenRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientSpecimenRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientSymptomList
		/// </summary>
		public abstract class GetPatientSymptomList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientSymptomList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetPatientTestingWorklist
		/// </summary>
		public abstract class GetPatientTestingWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTestingWorklist",
				DivisionCode = "@DivisionCode",
				PatientGuid = "@PatientGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "PatientGuid"
			};
		}

		/// <summary>
		/// spGetPatientTestingWorklistByDates
		/// </summary>
		public abstract class GetPatientTestingWorklistByDates
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTestingWorklistByDates",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetPatientTestingWorklistCount
		/// </summary>
		public abstract class GetPatientTestingWorklistCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTestingWorklistCount",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetPatientTestOrdersAll
		/// </summary>
		public abstract class GetPatientTestOrdersAll
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTestOrdersAll",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionComment
		/// </summary>
		public abstract class GetPatientTransfusionComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionComment",
				patienttransfusionguid = "@patienttransfusionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patienttransfusionguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionGuidsForDssExtract
		/// </summary>
		public abstract class GetPatientTransfusionGuidsForDssExtract
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionGuidsForDssExtract",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionReaction
		/// </summary>
		public abstract class GetPatientTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionReaction",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionReactionComment
		/// </summary>
		public abstract class GetPatientTransfusionReactionComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionReactionComment",
				divisioncode = "@divisioncode",
				patienttransfusionguid = "@patienttransfusionguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionReactionRecordHistoryForPatient
		/// </summary>
		public abstract class GetPatientTransfusionReactionRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionReactionRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionReactionSymptoms
		/// </summary>
		public abstract class GetPatientTransfusionReactionSymptoms
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionReactionSymptoms",
				divisioncode = "@divisioncode",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionreactionguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionRecord
		/// </summary>
		public abstract class GetPatientTransfusionRecord
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionRecord",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionRecordHistoryForPatient
		/// </summary>
		public abstract class GetPatientTransfusionRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionRecords
		/// </summary>
		public abstract class GetPatientTransfusionRecords
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionRecords",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionRequirementRecordHistoryForPatient
		/// </summary>
		public abstract class GetPatientTransfusionRequirementRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionRequirementRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPatientTransfusionRequirements
		/// </summary>
		public abstract class GetPatientTransfusionRequirements
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPatientTransfusionRequirements",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetPendingPatientMerges
		/// </summary>
		public abstract class GetPendingPatientMerges
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPendingPatientMerges",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPendingPatientMergesDetails
		/// </summary>
		public abstract class GetPendingPatientMergesDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPendingPatientMergesDetails",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPhenotypeUnits
		/// </summary>
		public abstract class GetPhenotypeUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPhenotypeUnits",
				divisioncode = "@divisioncode",
				weakdtesting = "@weakdtesting";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPhysicianList
		/// </summary>
		public abstract class GetPhysicianList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPhysicianList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPoolCounter
		/// </summary>
		public abstract class GetPoolCounter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPoolCounter",
				checkedvalue = "@checkedvalue",
				counteryear = "@counteryear",
				divisioncode = "@divisioncode",
				poolcounterguid = "@poolcounterguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"counteryear", "divisioncode", "recordstatuscode"
			};
		}

		/// <summary>
		/// spGetPooledBloodUnits
		/// </summary>
		public abstract class GetPooledBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPooledBloodUnits",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetPreviousRackTestResult
		/// </summary>
		public abstract class GetPreviousRackTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPreviousRackTestResult",
				divisioncode = "@divisioncode",
				RackGuid = "@rackguid",
				racktestresulttypecode = "@racktestresulttypecode",
				reagentguid = "@reagentguid",
				testdate = "@testdate",
				testwithid = "@testwithid",
				testwithname = "@testwithname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "RackGuid", "racktestresulttypecode", "reagentguid", "testdate", "testwithid", "testwithname"
			};
		}

		/// <summary>
		/// spGetPreviousUnitStatus
		/// </summary>
		public abstract class GetPreviousUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetPreviousUnitStatus",
				bloodunitguid = "@bloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid"
			};
		}

		/// <summary>
		/// spGetProductModificationList
		/// </summary>
		public abstract class GetProductModificationList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductModificationList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetProductModifications
		/// </summary>
		public abstract class GetProductModifications
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductModifications",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetProducts
		/// </summary>
		public abstract class GetProducts
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProducts",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetProductShipperByGuid
		/// </summary>
		public abstract class GetProductShipperByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductShipperByGuid",
				productshipperguid = "@productshipperguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"productshipperguid"
			};
		}

		/// <summary>
		/// spGetProductShipperByLocalSupplierDivision
		/// </summary>
		public abstract class GetProductShipperByLocalSupplierDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductShipperByLocalSupplierDivision",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode", "localsupplierguid"
			};
		}

		/// <summary>
		/// spGetProductShipperFacilityDetails
		/// </summary>
		public abstract class GetProductShipperFacilityDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductShipperFacilityDetails",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"localsupplierguid"
			};
		}

		/// <summary>
		/// spGetProductShippersByDivision
		/// </summary>
		public abstract class GetProductShippersByDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductShippersByDivision",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetProductShippersByDivisionLookUpList
		/// </summary>
		public abstract class GetProductShippersByDivisionLookUpList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductShippersByDivisionLookUpList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetProductTypeList
		/// </summary>
		public abstract class GetProductTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetProductTypeLookupList
		/// </summary>
		public abstract class GetProductTypeLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProductTypeLookupList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetProlongedTransfusionTimeReport
		/// </summary>
		public abstract class GetProlongedTransfusionTimeReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProlongedTransfusionTimeReport",
				delayedtransfusiontimethresholdminutes = "@delayedtransfusiontimethresholdminutes",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				lastupdatedate = "@lastupdatedate",
				sortorder = "@sortorder",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"delayedtransfusiontimethresholdminutes", "divisioncode", "enddate", "sortorder", "startdate"
			};
		}

		/// <summary>
		/// spGetProlongedTransfusionTimeReportCount
		/// </summary>
		public abstract class GetProlongedTransfusionTimeReportCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetProlongedTransfusionTimeReportCount",
				delayedtransfusiontimethresholdminutes = "@delayedtransfusiontimethresholdminutes",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				lastupdatedate = "@lastupdatedate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"delayedtransfusiontimethresholdminutes", "divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetQCResultsForOrderedTest
		/// </summary>
		public abstract class GetQCResultsForOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetQCResultsForOrderedTest",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetRack
		/// </summary>
		public abstract class GetRack
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRack",
				divisioncode = "@divisioncode",
				RackGuid = "@rackguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "RackGuid"
			};
		}

		/// <summary>
		/// spGetRackInfoByDailyQcWorklistGuid
		/// </summary>
		public abstract class GetRackInfoByDailyQcWorklistGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRackInfoByDailyQcWorklistGuid",
				dailyqcworklistguid = "@dailyqcworklistguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid"
			};
		}

		/// <summary>
		/// spGetRackQCTestingWorklist
		/// </summary>
		public abstract class GetRackQCTestingWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRackQCTestingWorklist",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetRackQCTestingWorklistCount
		/// </summary>
		public abstract class GetRackQCTestingWorklistCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRackQCTestingWorklistCount",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetRacks
		/// </summary>
		public abstract class GetRacks
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRacks",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRackTestDate
		/// </summary>
		public abstract class GetRackTestDate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRackTestDate",
				dailyqcworklistguid = "@dailyqcworklistguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetRackTestResult
		/// </summary>
		public abstract class GetRackTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRackTestResult",
				dailyqcworklistguid = "@dailyqcworklistguid",
				divisioncode = "@divisioncode",
				RackGuid = "@rackguid",
				reagentguid = "@reagentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "RackGuid", "reagentguid"
			};
		}

		/// <summary>
		/// spGetReactivityPhaseList
		/// </summary>
		public abstract class GetReactivityPhaseList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReactivityPhaseList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetReagentByGuid
		/// </summary>
		public abstract class GetReagentByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentByGuid",
				divisioncode = "@divisioncode",
				reagentguid = "@reagentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagentguid"
			};
		}

		/// <summary>
		/// spGetReagentChangeDetails
		/// </summary>
		public abstract class GetReagentChangeDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentChangeDetails",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetReagentFromRack
		/// </summary>
		public abstract class GetReagentFromRack
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentFromRack",
				divisioncode = "@divisioncode",
				RackGuid = "@rackguid",
				reagenttypeid = "@reagenttypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "RackGuid", "reagenttypeid"
			};
		}

		/// <summary>
		/// spGetReagentLotsForRetest
		/// </summary>
		public abstract class GetReagentLotsForRetest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentLotsForRetest",
				divisioncode = "@divisioncode",
				RackGuid = "@rackguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "RackGuid"
			};
		}

		/// <summary>
		/// spGetReagentLotsFromPreviousTest
		/// </summary>
		public abstract class GetReagentLotsFromPreviousTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentLotsFromPreviousTest",
				divisioncode = "@divisioncode",
				rackname = "@rackname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "rackname"
			};
		}

		/// <summary>
		/// spGetReagentManufacturers
		/// </summary>
		public abstract class GetReagentManufacturers
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentManufacturers",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetReagentPreviousAntigenTypingPhases
		/// </summary>
		public abstract class GetReagentPreviousAntigenTypingPhases
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentPreviousAntigenTypingPhases",
				divisioncode = "@divisioncode",
				reagentguid = "@reagentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagentguid"
			};
		}

		/// <summary>
		/// spGetReagentQC
		/// </summary>
		public abstract class GetReagentQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentQC",
				CommercialIndicator = "@CommercialIndicator",
				DivisionCode = "@DivisionCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"CommercialIndicator", "DivisionCode"
			};
		}

		/// <summary>
		/// spGetReagentQCTestingWorklist
		/// </summary>
		public abstract class GetReagentQCTestingWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentQCTestingWorklist",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetReagentQCTestingWorklistCount
		/// </summary>
		public abstract class GetReagentQCTestingWorklistCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentQCTestingWorklistCount",
				DivisionCode = "@DivisionCode",
				EndDate = "@EndDate",
				StartDate = "@StartDate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "EndDate", "StartDate"
			};
		}

		/// <summary>
		/// spGetReagents
		/// </summary>
		public abstract class GetReagents
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagents",
				divisioncode = "@divisioncode",
				expirationdateafter = "@expirationdateafter",
				expirationdatebefore = "@expirationdatebefore",
				receiveddateafter = "@receiveddateafter",
				receiveddatebefore = "@receiveddatebefore";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "expirationdateafter", "expirationdatebefore", "receiveddateafter", "receiveddatebefore"
			};
		}

		/// <summary>
		/// spGetReagentsByType
		/// </summary>
		public abstract class GetReagentsByType
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentsByType",
				divisioncode = "@divisioncode",
				reagenttypeid = "@reagenttypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagenttypeid"
			};
		}

		/// <summary>
		/// spGetReagentsForInvoice
		/// </summary>
		public abstract class GetReagentsForInvoice
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentsForInvoice",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber"
			};
		}

		/// <summary>
		/// spGetReagentTestResult
		/// </summary>
		public abstract class GetReagentTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentTestResult",
				divisioncode = "@divisioncode",
				reactivityphasecode = "@reactivityphasecode",
				reagentguid = "@reagentguid",
				testdate = "@testdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagentguid"
			};
		}

		/// <summary>
		/// spGetReagentTypeForOrderableTest
		/// </summary>
		public abstract class GetReagentTypeForOrderableTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentTypeForOrderableTest",
				OrderableTestId = "@OrderableTestID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderableTestId"
			};
		}

		/// <summary>
		/// spGetReagentTypes
		/// </summary>
		public abstract class GetReagentTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentTypes",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetReagentTypeStockLevel
		/// </summary>
		public abstract class GetReagentTypeStockLevel
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReagentTypeStockLevel",
				divisioncode = "@divisioncode",
				reagenttypeid = "@reagenttypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "reagenttypeid"
			};
		}

		/// <summary>
		/// spGetRecentComponentOrdersForPatient
		/// </summary>
		public abstract class GetRecentComponentOrdersForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentComponentOrdersForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentComponentOrdersForPatientCount
		/// </summary>
		public abstract class GetRecentComponentOrdersForPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentComponentOrdersForPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentInvoicesForDivision
		/// </summary>
		public abstract class GetRecentInvoicesForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentInvoicesForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRecentlyDeceasedPatientDetails
		/// </summary>
		public abstract class GetRecentlyDeceasedPatientDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyDeceasedPatientDetails",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRecentlyDeceasedPatients
		/// </summary>
		public abstract class GetRecentlyDeceasedPatients
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyDeceasedPatients",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRecentlyIssuedAndTransfusedUnitsForPatient
		/// </summary>
		public abstract class GetRecentlyIssuedAndTransfusedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyIssuedAndTransfusedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentlyIssuedAndTransfusedUnitsForPatientCount
		/// </summary>
		public abstract class GetRecentlyIssuedAndTransfusedUnitsForPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyIssuedAndTransfusedUnitsForPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentlyUpdatedPatientDetails
		/// </summary>
		public abstract class GetRecentlyUpdatedPatientDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyUpdatedPatientDetails",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRecentlyUpdatedPatients
		/// </summary>
		public abstract class GetRecentlyUpdatedPatients
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentlyUpdatedPatients",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetRecentPatientAboRhHistory
		/// </summary>
		public abstract class GetRecentPatientAboRhHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentPatientAboRhHistory",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentTestOrdersForPatient
		/// </summary>
		public abstract class GetRecentTestOrdersForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentTestOrdersForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetRecentTestOrdersForPatientCount
		/// </summary>
		public abstract class GetRecentTestOrdersForPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRecentTestOrdersForPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid",
				timespan = "@timespan";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetReflexTestsForOrder
		/// </summary>
		public abstract class GetReflexTestsForOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReflexTestsForOrder",
				DivisionCode = "@DivisionCode",
				OrderGuid = "@OrderGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "OrderGuid"
			};
		}

		/// <summary>
		/// spGetReimbursementPercentage
		/// </summary>
		public abstract class GetReimbursementPercentage
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReimbursementPercentage",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				localsupplierguid = "@localsupplierguid",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "localsupplierguid"
			};
		}

		/// <summary>
		/// spGetRemoteStorageLocations
		/// </summary>
		public abstract class GetRemoteStorageLocations
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRemoteStorageLocations",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetReorderableTestList
		/// </summary>
		public abstract class GetReorderableTestList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReorderableTestList",
				orderabletestid = "@orderabletestid";
		}

		/// <summary>
		/// spGetReportBloodUnitAnitgenTypingHistory
		/// </summary>
		public abstract class GetReportBloodUnitAnitgenTypingHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitAnitgenTypingHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitCrossmatchTestingHistory
		/// </summary>
		public abstract class GetReportBloodUnitCrossmatchTestingHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitCrossmatchTestingHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitDirectedPatientHistory
		/// </summary>
		public abstract class GetReportBloodUnitDirectedPatientHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitDirectedPatientHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitFinanceHistory
		/// </summary>
		public abstract class GetReportBloodUnitFinanceHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitFinanceHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitHistoryRecordCount
		/// </summary>
		public abstract class GetReportBloodUnitHistoryRecordCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitHistoryRecordCount",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				includeantigentypingreport = "@includeantigentypingreport",
				includebloodunittestingreport = "@includebloodunittestingreport",
				includecrossmatchtestingreport = "@includecrossmatchtestingreport",
				includeexceptionreport = "@includeexceptionreport",
				includefinancereport = "@includefinancereport",
				includeincomingshipmentreport = "@includeincomingshipmentreport",
				includeissuereport = "@includeissuereport",
				includemodificationreport = "@includemodificationreport",
				includeoutgoingshipmentreport = "@includeoutgoingshipmentreport",
				includepatientassociationreport = "@includepatientassociationreport",
				includerestrictedpatientreport = "@includerestrictedpatientreport",
				includestatusreport = "@includestatusreport",
				includetransfusionreport = "@includetransfusionreport";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "includeantigentypingreport", "includebloodunittestingreport", "includecrossmatchtestingreport", "includeexceptionreport", "includefinancereport", "includeincomingshipmentreport", "includeissuereport", "includemodificationreport", "includeoutgoingshipmentreport", "includepatientassociationreport", "includerestrictedpatientreport", "includestatusreport", "includetransfusionreport"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitHistorySummary
		/// </summary>
		public abstract class GetReportBloodUnitHistorySummary
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitHistorySummary",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitIncomingShipmentHistory
		/// </summary>
		public abstract class GetReportBloodUnitIncomingShipmentHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitIncomingShipmentHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitIssueHistory
		/// </summary>
		public abstract class GetReportBloodUnitIssueHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitIssueHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitModificationHistory
		/// </summary>
		public abstract class GetReportBloodUnitModificationHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitModificationHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitModificationSummary
		/// </summary>
		public abstract class GetReportBloodUnitModificationSummary
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitModificationSummary",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitOutgoingShipmentHistory
		/// </summary>
		public abstract class GetReportBloodUnitOutgoingShipmentHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitOutgoingShipmentHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitPatientAssociationHistory
		/// </summary>
		public abstract class GetReportBloodUnitPatientAssociationHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitPatientAssociationHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitPoolModificationHistory
		/// </summary>
		public abstract class GetReportBloodUnitPoolModificationHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitPoolModificationHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitSourceModificationSummary
		/// </summary>
		public abstract class GetReportBloodUnitSourceModificationSummary
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitSourceModificationSummary",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitStatusHistory
		/// </summary>
		public abstract class GetReportBloodUnitStatusHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitStatusHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitTargetModificationSummary
		/// </summary>
		public abstract class GetReportBloodUnitTargetModificationSummary
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitTargetModificationSummary",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitTestingHistory
		/// </summary>
		public abstract class GetReportBloodUnitTestingHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitTestingHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportBloodUnitTransfusionHistory
		/// </summary>
		public abstract class GetReportBloodUnitTransfusionHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportBloodUnitTransfusionHistory",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetReportIssuedReturnedUnit
		/// </summary>
		public abstract class GetReportIssuedReturnedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportIssuedReturnedUnit",
				divisionCode = "@divisionCode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportIssuedReturnedUnitCount
		/// </summary>
		public abstract class GetReportIssuedReturnedUnitCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportIssuedReturnedUnitCount",
				divisionCode = "@divisionCode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportMultiOrderHistory
		/// </summary>
		public abstract class GetReportMultiOrderHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportMultiOrderHistory",
				divisionCode = "@divisionCode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportMultiOrderHistoryCount
		/// </summary>
		public abstract class GetReportMultiOrderHistoryCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportMultiOrderHistoryCount",
				divisionCode = "@divisionCode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportPatientTransfusionReaction
		/// </summary>
		public abstract class GetReportPatientTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportPatientTransfusionReaction",
				divisioncode = "@divisioncode",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionreactionguid"
			};
		}

		/// <summary>
		/// spGetReportSingleOrderComponentHistory
		/// </summary>
		public abstract class GetReportSingleOrderComponentHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportSingleOrderComponentHistory",
				divisionCode = "@divisionCode",
				orderedcomponentguid = "@orderedcomponentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "orderedcomponentguid"
			};
		}

		/// <summary>
		/// spGetReportSingleOrderTestHistory
		/// </summary>
		public abstract class GetReportSingleOrderTestHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportSingleOrderTestHistory",
				divisionCode = "@divisionCode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetReportTransfusionReactionCountDetails
		/// </summary>
		public abstract class GetReportTransfusionReactionCountDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportTransfusionReactionCountDetails",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportTransfusionReactionCountDetailsMultidivisional
		/// </summary>
		public abstract class GetReportTransfusionReactionCountDetailsMultidivisional
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportTransfusionReactionCountDetailsMultidivisional",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportTransfusionReactionCountSummary
		/// </summary>
		public abstract class GetReportTransfusionReactionCountSummary
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportTransfusionReactionCountSummary",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetReportTransfusionReactionCountSummaryMultidivisional
		/// </summary>
		public abstract class GetReportTransfusionReactionCountSummaryMultidivisional
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetReportTransfusionReactionCountSummaryMultidivisional",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetRHConfirmationLookup
		/// </summary>
		public abstract class GetRHConfirmationLookup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetRHConfirmationLookup",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetScheduledReportByGuid
		/// </summary>
		public abstract class GetScheduledReportByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetScheduledReportByGuid",
				scheduledreportguid = "@scheduledreportguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"scheduledreportguid"
			};
		}

		/// <summary>
		/// spGetScheduledReports
		/// </summary>
		public abstract class GetScheduledReports
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetScheduledReports",
				reportprintdate = "@reportprintdate",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"reportprintdate", "taskstatuscode"
			};
		}

		/// <summary>
		/// spGetShipment
		/// </summary>
		public abstract class GetShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetShipment",
				divisioncode = "@divisioncode",
				functionid = "@functionid",
				readonly_Parameter = "@readonly",
				shipmentguid = "@shipmentguid",
				user = "@user";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "shipmentguid"
			};
		}

		/// <summary>
		/// spGetShipmentByUnit
		/// </summary>
		public abstract class GetShipmentByUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetShipmentByUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spGetShipmentInvoiceCount
		/// </summary>
		public abstract class GetShipmentInvoiceCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetShipmentInvoiceCount",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber", "localsupplierguid"
			};
		}

		/// <summary>
		/// spGetShipmentsWithAvailableUnitsFromPastFiveDays
		/// </summary>
		public abstract class GetShipmentsWithAvailableUnitsFromPastFiveDays
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetShipmentsWithAvailableUnitsFromPastFiveDays",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetSpecialInstructionsForPatient
		/// </summary>
		public abstract class GetSpecialInstructionsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecialInstructionsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetSpecimen
		/// </summary>
		public abstract class GetSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimen",
				divisioncode = "@divisioncode",
				specimenuid = "@specimenuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "specimenuid"
			};
		}

		/// <summary>
		/// spGetSpecimenByGUID
		/// </summary>
		public abstract class GetSpecimenByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenByGUID",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetSpecimenHistory
		/// </summary>
		public abstract class GetSpecimenHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenHistory",
				DivisionCode = "@DivisionCode",
				PatientSpecimenGuid = "@PatientSpecimenGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "PatientSpecimenGuid"
			};
		}

		/// <summary>
		/// spGetSpecimenList
		/// </summary>
		public abstract class GetSpecimenList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenList",
				divisioncode = "@divisioncode",
				patientlastname = "@patientlastname",
				patientssn = "@patientssn",
				specimenexpirationdate = "@specimenexpirationdate",
				specimenuid = "@specimenuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "specimenexpirationdate"
			};
		}

		/// <summary>
		/// spGetSpecimenSearchDetails
		/// </summary>
		public abstract class GetSpecimenSearchDetails
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenSearchDetails",
				divisioncode = "@divisioncode",
				patientlastname = "@patientlastname",
				patientssn = "@patientssn",
				specimenuid = "@specimenuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetSpecimensForPatient
		/// </summary>
		public abstract class GetSpecimensForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimensForPatient",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				patientguid = "@patientguid",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "patientguid", "startdate"
			};
		}

		/// <summary>
		/// spGetSpecimensForPatientCount
		/// </summary>
		public abstract class GetSpecimensForPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimensForPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetSpecimenStatusList
		/// </summary>
		public abstract class GetSpecimenStatusList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenStatusList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetSpecimenTestRecordHistoryForPatient
		/// </summary>
		public abstract class GetSpecimenTestRecordHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenTestRecordHistoryForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetSpecimenTestResultsForOrderedTest
		/// </summary>
		public abstract class GetSpecimenTestResultsForOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenTestResultsForOrderedTest",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid",
				reportabletestid = "@reportabletestid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetSpecimenTestResultsForTransfusionReaction
		/// </summary>
		public abstract class GetSpecimenTestResultsForTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenTestResultsForTransfusionReaction",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetSpecimenTestThresholds
		/// </summary>
		public abstract class GetSpecimenTestThresholds
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSpecimenTestThresholds",
				componentclassid = "@componentclassid",
				divisioncode = "@divisioncode",
				labtestid = "@labtestid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid", "divisioncode", "labtestid"
			};
		}

		/// <summary>
		/// spGetStateList
		/// </summary>
		public abstract class GetStateList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetStateList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetStatusDetailsList
		/// </summary>
		public abstract class GetStatusDetailsList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetStatusDetailsList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetStorageTypeList
		/// </summary>
		public abstract class GetStorageTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetStorageTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetSupplies
		/// </summary>
		public abstract class GetSupplies
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplies",
				divisioncode = "@divisioncode",
				includeall = "@includeall",
				lotnumber = "@lotnumber",
				manufacturername = "@manufacturername",
				supplytypeid = "@supplytypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetSupplyByGuid
		/// </summary>
		public abstract class GetSupplyByGuid
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyByGuid",
				divisioncode = "@divisioncode",
				supplyguid = "@supplyguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "supplyguid"
			};
		}

		/// <summary>
		/// spGetSupplyByInvoiceLotNumber
		/// </summary>
		public abstract class GetSupplyByInvoiceLotNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyByInvoiceLotNumber",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				lotnumber = "@lotnumber",
				supplytypeid = "@supplytypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber", "lotnumber", "supplytypeid"
			};
		}

		/// <summary>
		/// spGetSupplyInventoryReportData
		/// </summary>
		public abstract class GetSupplyInventoryReportData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyInventoryReportData",
				divisioncode = "@divisioncode",
				expirationenddate = "@expirationenddate",
				expirationstartdate = "@expirationstartdate",
				includeunsatisfactory = "@includeunsatisfactory",
				receiptenddate = "@receiptenddate",
				receiptstartdate = "@receiptstartdate",
				supplytypeid = "@supplytypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "supplytypeid"
			};
		}

		/// <summary>
		/// spGetSupplyManufacturerList
		/// </summary>
		public abstract class GetSupplyManufacturerList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyManufacturerList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetSupplyNameList
		/// </summary>
		public abstract class GetSupplyNameList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyNameList",
				divisioncode = "@divisioncode",
				manufacturername = "@manufacturername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetSupplyTypeList
		/// </summary>
		public abstract class GetSupplyTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetSupplyTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTargetProducts
		/// </summary>
		public abstract class GetTargetProducts
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTargetProducts",
				DivisionCode = "@DivisionCode",
				FromBloodProductGuidList = "@FromBloodProductGuidList",
				ModificationMethod = "@ModificationMethod",
				ProductModificationCode = "@ProductModificationCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "FromBloodProductGuidList", "ModificationMethod", "ProductModificationCode"
			};
		}

		/// <summary>
		/// spGetTaskStatusList
		/// </summary>
		public abstract class GetTaskStatusList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTaskStatusList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTestingMethodList
		/// </summary>
		public abstract class GetTestingMethodList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestingMethodList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTestingStatusLookupList
		/// </summary>
		public abstract class GetTestingStatusLookupList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestingStatusLookupList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTestingStatusTextFromID
		/// </summary>
		public abstract class GetTestingStatusTextFromID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestingStatusTextFromID",
				TestingStatusId = "@TestingStatusID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"TestingStatusId"
			};
		}

		/// <summary>
		/// spGetTestingTaskList
		/// </summary>
		public abstract class GetTestingTaskList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestingTaskList",
				divisioncode = "@divisioncode",
				ordergroupnumber = "@ordergroupnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetTestOrders
		/// </summary>
		public abstract class GetTestOrders
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestOrders",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetTestResult
		/// </summary>
		public abstract class GetTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResult",
				divisioncode = "@divisioncode",
				testresultid = "@testresultid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "testresultid"
			};
		}

		/// <summary>
		/// spGetTestResultList
		/// </summary>
		public abstract class GetTestResultList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTestResults
		/// </summary>
		public abstract class GetTestResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResults",
				divisioncode = "@divisioncode",
				patientorderguid = "@patientorderguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientorderguid"
			};
		}

		/// <summary>
		/// spGetTestResultsForRepeatXM
		/// </summary>
		public abstract class GetTestResultsForRepeatXM
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultsForRepeatXM",
				OrderedTestGuid = "@OrderedTestGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderedTestGuid"
			};
		}

		/// <summary>
		/// spGetTestResultsForSpecimen
		/// </summary>
		public abstract class GetTestResultsForSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultsForSpecimen",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetTestResultsForTask
		/// </summary>
		public abstract class GetTestResultsForTask
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultsForTask",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetTestResultsForXM
		/// </summary>
		public abstract class GetTestResultsForXM
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultsForXM",
				OrderedComponentGuid = "@OrderedComponentGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderedComponentGuid"
			};
		}

		/// <summary>
		/// spGetTestResultsWithErrorForTask
		/// </summary>
		public abstract class GetTestResultsWithErrorForTask
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTestResultsWithErrorForTask",
				divisioncode = "@divisioncode",
				orderedtestguid = "@orderedtestguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedtestguid"
			};
		}

		/// <summary>
		/// spGetTimeZoneList
		/// </summary>
		public abstract class GetTimeZoneList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTimeZoneList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTransfusedPatient
		/// </summary>
		public abstract class GetTransfusedPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusedPatient",
				BloodUnitGuid = "@BloodUnitGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid"
			};
		}

		/// <summary>
		/// spGetTransfusedUnitsForPatient
		/// </summary>
		public abstract class GetTransfusedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetTransfusedUnitsInDateRange
		/// </summary>
		public abstract class GetTransfusedUnitsInDateRange
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusedUnitsInDateRange",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				patientguid = "@patientguid",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetTransfusedUnitsInDateRangeCount
		/// </summary>
		public abstract class GetTransfusedUnitsInDateRangeCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusedUnitsInDateRangeCount",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				patientguid = "@patientguid",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetTransfusionHistoryForPatient
		/// </summary>
		public abstract class GetTransfusionHistoryForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionHistoryForPatient",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				patientguid = "@patientguid",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "patientguid", "startdate"
			};
		}

		/// <summary>
		/// spGetTransfusionHistoryForPatientSpecimen
		/// </summary>
		public abstract class GetTransfusionHistoryForPatientSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionHistoryForPatientSpecimen",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReactionImplicatedUnitsForPatient
		/// </summary>
		public abstract class GetTransfusionReactionImplicatedUnitsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReactionImplicatedUnitsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReactionRecords
		/// </summary>
		public abstract class GetTransfusionReactionRecords
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReactionRecords",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patienttransfusionreactionguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReactionsForPatient
		/// </summary>
		public abstract class GetTransfusionReactionsForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReactionsForPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReactionsForPatientCount
		/// </summary>
		public abstract class GetTransfusionReactionsForPatientCount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReactionsForPatientCount",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReactionTypeList
		/// </summary>
		public abstract class GetTransfusionReactionTypeList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReactionTypeList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTransfusionRelatedInformation
		/// </summary>
		public abstract class GetTransfusionRelatedInformation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionRelatedInformation",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spGetTransfusionReport
		/// </summary>
		public abstract class GetTransfusionReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionReport",
				delimiter = "@delimiter",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				reporttype = "@reporttype",
				searchstring = "@searchstring",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"delimiter", "divisioncode", "enddate", "reporttype", "searchstring", "startdate"
			};
		}

		/// <summary>
		/// spGetTransfusionRequirementCategoryList
		/// </summary>
		public abstract class GetTransfusionRequirementCategoryList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionRequirementCategoryList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetTransfusionRequirementsReport
		/// </summary>
		public abstract class GetTransfusionRequirementsReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTransfusionRequirementsReport",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetTreatingSpecialtyList
		/// </summary>
		public abstract class GetTreatingSpecialtyList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetTreatingSpecialtyList",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetUnitModifications
		/// </summary>
		public abstract class GetUnitModifications
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetUnitModifications",
				divisioncode = "@divisioncode",
				enddate = "@enddate",
				startdate = "@startdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "enddate", "startdate"
			};
		}

		/// <summary>
		/// spGetUnitsInInvoice
		/// </summary>
		public abstract class GetUnitsInInvoice
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetUnitsInInvoice",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"shipmentguid"
			};
		}

		/// <summary>
		/// spGetUnitStatusList
		/// </summary>
		public abstract class GetUnitStatusList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetUnitStatusList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetUserRoleList
		/// </summary>
		public abstract class GetUserRoleList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetUserRoleList",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetUserRolesList
		/// </summary>
		public abstract class GetUserRolesList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetUserRolesList",
				userroleid = "@userroleid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"userroleid"
			};
		}

		/// <summary>
		/// spGetVbecsAssociatedInstitution
		/// </summary>
		public abstract class GetVbecsAssociatedInstitution
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsAssociatedInstitution",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetVbecsDivisions
		/// </summary>
		public abstract class GetVbecsDivisions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsDivisions",
				activeonly = "@activeonly";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"activeonly"
			};
		}

		/// <summary>
		/// spGetVbecsUser
		/// </summary>
		public abstract class GetVbecsUser
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsUser",
				searchallusers = "@searchallusers",
				vbecsuserid = "@vbecsuserid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vbecsuserid"
			};
		}

		/// <summary>
		/// spGetVbecsUserDivisionsAndRoles
		/// </summary>
		public abstract class GetVbecsUserDivisionsAndRoles
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsUserDivisionsAndRoles",
				vbecsuserid = "@vbecsuserid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vbecsuserid"
			};
		}

		/// <summary>
		/// spGetVbecsUsersActiveForDivision
		/// </summary>
		public abstract class GetVbecsUsersActiveForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsUsersActiveForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetVbecsUsersWithRoleInGivenDivision
		/// </summary>
		public abstract class GetVbecsUsersWithRoleInGivenDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsUsersWithRoleInGivenDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetVbecsVersion
		/// </summary>
		public abstract class GetVbecsVersion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsVersion",
				No_parameters = "No_parameters";
		}

        /// <summary>
        /// spGetVbecsRevision CR 3453
		/// </summary>
		public abstract class GetVbecsRevision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsDBRevision",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetVbecsWorkLoadForDivision
		/// </summary>
		public abstract class GetVbecsWorkLoadForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVbecsWorkLoadForDivision",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spGetVistaCache
		/// </summary>
		public abstract class GetVistaCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVistaCache",
				vistadatasetname = "@vistadatasetname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vistadatasetname"
			};
		}

		/// <summary>
		/// spGetVistALinkConfig
		/// </summary>
		public abstract class GetVistALinkConfig
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetVistALinkConfig",
				serverapphandle = "@serverapphandle";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"serverapphandle"
			};
		}

		/// <summary>
		/// spGetWorkloadCache
		/// </summary>
		public abstract class GetWorkloadCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetWorkloadCache",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spGetWorkloadProcessGuidByVbecsProcessID
		/// </summary>
		public abstract class GetWorkloadProcessGuidByVbecsProcessID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spGetWorkloadProcessGuidByVbecsProcessID",
				divisioncode = "@divisioncode",
				vbecsprocessid = "@vbecsprocessid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "vbecsprocessid"
			};
		}

		/// <summary>
		/// spHL7GetInterfaceControlParameters
		/// </summary>
		public abstract class HL7GetInterfaceControlParameters
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetInterfaceControlParameters",
				InterfaceApplicationId = "@InterfaceApplicationId",
				InterfaceName = "@InterfaceName",
				VbecsApplicationId = "@VbecsApplicationId",
				InterfaceControlId = "@InterfaceControlId";
		}

		/// <summary>
		/// spHL7GetMessagesReadyForPurge
		/// </summary>
		public abstract class HL7GetMessagesReadyForPurge
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetMessagesReadyForPurge",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spHL7GetMessageTypesByInterfaceControlID
		/// </summary>
		public abstract class HL7GetMessageTypesByInterfaceControlID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetMessageTypesByInterfaceControlID",
				InterfaceControlId = "@InterfaceControlID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"InterfaceControlId"
			};
		}

		/// <summary>
		/// spHL7GetNextVbecsOrderNumber
		/// </summary>
		public abstract class HL7GetNextVbecsOrderNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetNextVbecsOrderNumber",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser";
		}

		/// <summary>
		/// spHL7GetPatient
		/// </summary>
		public abstract class HL7GetPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetPatient",
				PatientICN = "@PatientICN",
				VistaPatientId = "@VistaPatientID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistaPatientId"
			};
		}

		/// <summary>
		/// spHL7GetPatientLocation
		/// </summary>
		public abstract class HL7GetPatientLocation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetPatientLocation",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientguid"
			};
		}

		/// <summary>
		/// spHL7GetPatientOrderbyOrderGroupNumber
		/// </summary>
		public abstract class HL7GetPatientOrderbyOrderGroupNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetPatientOrderbyOrderGroupNumber",
				OrderGroupNumber = "@OrderGroupNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"OrderGroupNumber"
			};
		}

		/// <summary>
		/// spHL7GetPatientTreatment
		/// </summary>
		public abstract class HL7GetPatientTreatment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetPatientTreatment",
				InPatientIndicator = "@InPatientIndicator",
				PatientAdmittingDiagnosis = "@PatientAdmittingDiagnosis",
				PatientGuid = "@PatientGUID",
				PatientLocation = "@PatientLocation",
				PatientRoomBed = "@PatientRoomBed",
				PatientTreatingFacility = "@PatientTreatingFacility";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientGuid"
			};
		}

		/// <summary>
		/// spHL7GetPendingTransmissionMessages
		/// </summary>
		public abstract class HL7GetPendingTransmissionMessages
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetPendingTransmissionMessages",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spHL7GetTransmitCountForMessage
		/// </summary>
		public abstract class HL7GetTransmitCountForMessage
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7GetTransmitCountForMessage",
				MessageControlId = "@MessageControlId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"MessageControlId"
			};
		}

		/// <summary>
		/// spHL7InsertMessageLog
		/// </summary>
		public abstract class HL7InsertMessageLog
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7InsertMessageLog",
				DateTimeOfMessage = "@DateTimeOfMessage",
				ErrorText = "@ErrorText",
				InterfaceControlId = "@InterfaceControlID",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				MessageControlID = "@MessageControlID",
				MessageStatusCode = "@MessageStatusCode",
				MessageStream = "@MessageStream",
				MessageType = "@MessageType",
				ReceivingApplication = "@ReceivingApplication",
				SendingApplication = "@SendingApplication";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DateTimeOfMessage", "InterfaceControlId", "MessageControlID", "MessageStatusCode", "MessageStream", "MessageType", "ReceivingApplication", "SendingApplication"
			};
		}

		/// <summary>
		/// spHL7InsertPatient
		/// </summary>
		public abstract class HL7InsertPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7InsertPatient",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				PatientDeathDate = "@PatientDeathDate",
				PatientDob = "@PatientDOB",
				PatientDobCode = "@PatientDOBCode",
				PatientFirstName = "@PatientFirstName",
				PatientGuid = "@PatientGUID",
				PatientICN = "@PatientICN",
				PatientLastName = "@PatientLastName",
				PatientMiddleName = "@PatientMiddleName",
				PatientSexCode = "@PatientSexCode",
				PatientSsn = "@PatientSSN",
				SsnPrefix = "@SsnPrefix",
				SsnPseudoIndicator = "@SsnPseudoIndicator",
				VistaPatientId = "@VistaPatientID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientDobCode", "PatientFirstName", "PatientGuid", "PatientLastName", "VistaPatientId"
			};
		}

		/// <summary>
		/// spHL7InsertPatientChange
		/// </summary>
		public abstract class HL7InsertPatientChange
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7InsertPatientChange",
				FromPatientDeathDate = "@FromPatientDeathDate",
				FromPatientDob = "@FromPatientDob",
				FromPatientFirstName = "@FromPatientFirstName",
				FromPatientGuid = "@FromPatientGuid",
				FromPatientIcn = "@FromPatientIcn",
				FromPatientLastName = "@FromPatientLastName",
				FromPatientMiddleName = "@FromPatientMiddleName",
				FromPatientSexCode = "@FromPatientSexCode",
				FromPatientSsn = "@FromPatientSsn",
				FromSsnPseudoIndicator = "@FromSsnPseudoIndicator",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				MergeFromVistaPatientId = "@MergeFromVistaPatientId",
				MergeToVistaPatientId = "@MergeToVistaPatientId",
				PatientChangeGuid = "@PatientChangeGuid",
				PatientChangeStatusCode = "@PatientChangeStatusCode",
				ToPatientDeathDate = "@ToPatientDeathDate",
				ToPatientDob = "@ToPatientDob",
				ToPatientFirstName = "@ToPatientFirstName",
				ToPatientGuid = "@ToPatientGuid",
				ToPatientIcn = "@ToPatientIcn",
				ToPatientLastName = "@ToPatientLastName",
				ToPatientMiddleName = "@ToPatientMiddleName",
				ToPatientSexCode = "@ToPatientSexCode",
				ToPatientSsn = "@ToPatientSsn",
				ToSsnPseudoIndicator = "@ToSsnPseudoIndicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientChangeGuid", "PatientChangeStatusCode"
			};
		}

		/// <summary>
		/// spHL7InsertPatientLocation
		/// </summary>
		public abstract class HL7InsertPatientLocation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7InsertPatientLocation",
				DivisionCode = "@DivisionCode",
				InPatientIndicator = "@InPatientIndicator",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				LocationName = "@LocationName",
				LocationRoomBed = "@LocationRoomBed",
				PatientGuid = "@PatientGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"InPatientIndicator", "PatientGuid"
			};
		}

		/// <summary>
		/// spHL7InsertPatientTreatment
		/// </summary>
		public abstract class HL7InsertPatientTreatment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7InsertPatientTreatment",
				InPatientIndicator = "@InPatientIndicator",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				PatientAdmittingDiagnosis = "@PatientAdmittingDiagnosis",
				PatientGuid = "@PatientGUID",
				PatientLocation = "@PatientLocation",
				PatientRoomBed = "@PatientRoomBed",
				PatientTreatingFacility = "@PatientTreatingFacility",
				PatientTreatmentGuid = "@PatientTreatmentGUID",
				TreatingSpecialtyCode = "@TreatingSpecialtyCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientGuid", "PatientTreatmentGuid"
			};
		}

		/// <summary>
		/// spHL7IsVbecsPatient
		/// </summary>
		public abstract class HL7IsVbecsPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7IsVbecsPatient",
				vistapatientid = "@vistapatientid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vistapatientid"
			};
		}

		/// <summary>
		/// spHL7PurgeMessageLog
		/// </summary>
		public abstract class HL7PurgeMessageLog
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7PurgeMessageLog",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spHL7UpdateAckMessageControlID
		/// </summary>
		public abstract class HL7UpdateAckMessageControlID
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateAckMessageControlID",
				AckMessageControlID = "@AckMessageControlID",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				MessageControlID = "@MessageControlID",
				MessageStatusCode = "@MessageStatusCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"AckMessageControlID", "MessageControlID", "MessageStatusCode"
			};
		}

		/// <summary>
		/// spHL7UpdateInterfaceControlParameters
		/// </summary>
		public abstract class HL7UpdateInterfaceControlParameters
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateInterfaceControlParameters",
				AckTimeout = "@AckTimeout",
				InterfaceAdministratorName = "@InterfaceAdministratorName",
				InterfaceControlId = "@InterfaceControlID",
				InterfaceDomainName = "@InterfaceDomainName",
				InterfaceFacilityId = "@InterfaceFacilityID",
				InterfaceIPAddress = "@InterfaceIPAddress",
				InterfacePortNumber = "@InterfacePortNumber",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateUser = "@LastUpdateUser",
				LogEventsIndicator = "@LogEventsIndicator",
				PurgeSuccessfulMessage = "@PurgeSuccessfulMessage",
				PurgeUnSuccessfulMessage = "@PurgeUnSuccessfulMessage",
				ReTransmitAttempts = "@ReTransmitAttempts",
				VbecsFacilityID = "@VbecsFacilityID",
				VbecsIPAddress = "@VbecsIPAddress",
				VbecsPortNumber = "@VbecsPortNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"AckTimeout", "InterfaceAdministratorName", "InterfaceControlId", "InterfaceDomainName", "InterfaceFacilityId", "InterfaceIPAddress", "InterfacePortNumber", "LogEventsIndicator", "PurgeSuccessfulMessage", "PurgeUnSuccessfulMessage", "ReTransmitAttempts", "VbecsFacilityID", "VbecsIPAddress", "VbecsPortNumber"
			};
		}

		/// <summary>
		/// spHL7UpdateInterfaceControlStatus
		/// </summary>
		public abstract class HL7UpdateInterfaceControlStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateInterfaceControlStatus",
				InterfaceActiveIndicator = "@InterfaceActiveIndicator",
				InterfaceControlId = "@InterfaceControlID",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateUser = "@LastUpdateUser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"InterfaceActiveIndicator", "InterfaceControlId"
			};
		}

		/// <summary>
		/// spHL7UpdateMessageStatus
		/// </summary>
		public abstract class HL7UpdateMessageStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateMessageStatus",
				ErrorText = "@ErrorText",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				MessageControlID = "@MessageControlID",
				MessageStatusCode = "@MessageStatusCode",
				TransmitCount = "@TransmitCount";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"MessageControlID", "MessageStatusCode"
			};
		}

		/// <summary>
		/// spHL7UpdateOrderedComponent
		/// </summary>
		public abstract class HL7UpdateOrderedComponent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateOrderedComponent",
				CancellationText = "@CancellationText",
				ComponentClassId = "@ComponentClassID",
				CprsOrderNumber = "@CprsOrderNumber",
				DivisionCode = "@DivisionCode",
				ImmediateTransfusionIndicator = "@ImmediateTransfusionIndicator",
				LabOrderNumber = "@LabOrderNumber",
				LabTestId = "@LabTestId",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				OrderedComponentComments = "@OrderedComponentComments",
				OrderedComponentGuid = "@OrderedComponentGUID",
				OrderSpecialInstructions = "@OrderSpecialInstructions",
				OrderStatusCode = "@OrderStatusCode",
				OrderUrgencyCode = "@OrderUrgencyCode",
				PatientOrderGuid = "@PatientOrderGUID",
				PreOpIndicator = "@PreOpIndicator",
				RequiredDatetime = "@RequiredDatetime",
				RequiredUnitQuantity = "@RequiredUnitQuantity",
				SpecimenStatusCode = "@SpecimenStatusCode",
				Specimenuid = "@Specimenuid",
				VbecsOrderNumber = "@VbecsOrderNumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"ComponentClassId", "CprsOrderNumber", "DivisionCode", "LabOrderNumber", "OrderedComponentGuid", "OrderUrgencyCode", "PatientOrderGuid", "PreOpIndicator", "RequiredDatetime", "RequiredUnitQuantity", "SpecimenStatusCode", "VbecsOrderNumber"
			};
		}

		/// <summary>
		/// spHL7UpdateOrderedTest
		/// </summary>
		public abstract class HL7UpdateOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdateOrderedTest",
				autoinstrumentname = "@autoinstrumentname",
				cancellationcannedcommentguid = "@cancellationcannedcommentguid",
				cancellationtext = "@cancellationtext",
				cprsordernumber = "@cprsordernumber",
				divisioncode = "@divisioncode",
				labordernumber = "@labordernumber",
				labtestid = "@labtestid",
				lastupdatedate = "@lastupdatedate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				orderabletestid = "@orderabletestid",
				orderedtestcomments = "@orderedtestcomments",
				orderedtestguid = "@orderedtestguid",
				orderstatuscode = "@orderstatuscode",
				orderurgencycode = "@orderurgencycode",
				patientorderguid = "@patientorderguid",
				patientspecimenguid = "@patientspecimenguid",
				relatedcomponentguid = "@relatedcomponentguid",
				relatedtestguid = "@relatedtestguid",
				requiredresultsdate = "@requiredresultsdate",
				specimenrequiredindicator = "@specimenrequiredindicator",
				taskstatuscode = "@taskstatuscode",
				testinterpretation = "@testinterpretation",
				testinterpretationcomments = "@testinterpretationcomments",
				vbecsordernumber = "@vbecsordernumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedtestguid", "patientorderguid", "vbecsordernumber"
			};
		}

		/// <summary>
		/// spHL7UpdatePatient
		/// </summary>
		public abstract class HL7UpdatePatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdatePatient",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				PatientDeathDate = "@PatientDeathDate",
				PatientDob = "@PatientDOB",
				PatientDobCode = "@PatientDOBCode",
				PatientFirstName = "@PatientFirstName",
				PatientGuid = "@PatientGUID",
				PatientICN = "@PatientICN",
				PatientLastName = "@PatientLastName",
				PatientMiddleName = "@PatientMiddleName",
				PatientSexCode = "@PatientSexCode",
				PatientSsn = "@PatientSSN",
				SsnPseudoIndicator = "@SsnPseudoIndicator",
				VistaPatientId = "@VistaPatientID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientDobCode", "PatientFirstName", "PatientGuid", "PatientLastName", "VistaPatientId"
			};
		}

		/// <summary>
		/// spHL7UpdatePatientLocation
		/// </summary>
		public abstract class HL7UpdatePatientLocation
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdatePatientLocation",
				DivisionCode = "@DivisionCode",
				InPatientIndicator = "@InPatientIndicator",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				LocationName = "@LocationName",
				LocationRoomBed = "@LocationRoomBed",
				PatientGuid = "@PatientGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"InPatientIndicator", "PatientGuid"
			};
		}

		/// <summary>
		/// spHL7UpdatePatientOrder
		/// </summary>
		public abstract class HL7UpdatePatientOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdatePatientOrder",
				DivisionCode = "@DivisionCode",
				InformedConsentIndicator = "@InformedConsentIndicator",
				InstitutionDivisionCode = "@InstitutionDivisionCode",
				LabOrderNumber = "@LabOrderNumber",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				OrderComments = "@OrderComments",
				OrderEnteredByFirstName = "@OrderEnteredByFirstName",
				OrderEnteredByID = "@OrderEnteredByID",
				OrderEnteredByLastName = "@OrderEnteredByLastName",
				OrderEnteredByMiddleInitial = "@OrderEnteredByMiddleInitial",
				OrderGroupNumber = "@OrderGroupNumber",
				OrderingHospitalLocation = "@OrderingHospitalLocation",
				OrderingProviderFirstName = "@OrderingProviderFirstName",
				OrderingProviderID = "@OrderingProviderID",
				OrderingProviderLastName = "@OrderingProviderLastName",
				OrderingProviderMiddleInitial = "@OrderingProviderMiddleInitial",
				OrderPlacedDatetime = "@OrderPlacedDatetime",
				OrderReceivedDatetime = "@OrderReceivedDatetime",
				PatientOrderGuid = "@PatientOrderGUID",
				PatientTreatmentGuid = "@PatientTreatmentGUID",
				RequestReason = "@RequestReason",
				SpecimenRequiredIndicator = "@SpecimenRequiredIndicator",
				SurgeryName = "@SurgeryName";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientOrderGuid", "PatientTreatmentGuid"
			};
		}

		/// <summary>
		/// spHL7UpdatePatientTest
		/// </summary>
		public abstract class HL7UpdatePatientTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spHL7UpdatePatientTest",
				DivisionCode = "@DivisionCode",
				LabTestId = "@LabTestID",
				LabTestNormalRange = "@LabTestNormalRange",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				OrderableTestId = "@OrderableTestID",
				PatientGuid = "@PatientGUID",
				PatientOrderGuid = "@PatientOrderGUID",
				RecordStatusCode = "@RecordStatusCode",
				ResultDateTime = "@ResultDateTime",
				TestComments = "@TestComments",
				TestDate = "@TestDate",
				TestResult = "@TestResult";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"RecordStatusCode"
			};
		}

		/// <summary>
		/// spInactivateAboRHConfirmationTests
		/// </summary>
		public abstract class InactivateAboRHConfirmationTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInactivateAboRHConfirmationTests",
				bloodunitguid = "@bloodunitguid",
				comments = "@comments",
				confirmationworklistunitguid = "@confirmationworklistunitguid",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "comments", "confirmationworklistunitguid", "divisioncode", "rowversion"
			};
		}

		/// <summary>
		/// spInactivateAntigenTypingTests
		/// </summary>
		public abstract class InactivateAntigenTypingTests
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInactivateAntigenTypingTests",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				bloodunitguid = "@bloodunitguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderabletestid = "@orderabletestid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "bloodunitguid", "comments", "divisioncode", "orderabletestid"
			};
		}

		/// <summary>
		/// spInactivateBloodUnitAntigen
		/// </summary>
		public abstract class InactivateBloodUnitAntigen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInactivateBloodUnitAntigen",
				antigentypeid = "@antigentypeid",
				bloodunitguid = "@bloodunitguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode"
			};
		}

		/// <summary>
		/// spInactivateBloodUnitShipment
		/// </summary>
		public abstract class InactivateBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInactivateBloodUnitShipment",
				bloodunitshipmentguid = "@bloodunitshipmentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitshipmentguid", "rowversion"
			};
		}

		/// <summary>
		/// spInactivateOrderedTestResults
		/// </summary>
		public abstract class InactivateOrderedTestResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInactivateOrderedTestResults",
				antiseraorderedtestrowversion = "@antiseraorderedtestrowversion",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderabletestid = "@orderabletestid",
				orderedtestguid = "@orderedtestguid",
				orderedtestrowversion = "@orderedtestrowversion",
				racklotrowversion = "@racklotrowversion",
				racktestrowversion = "@racktestrowversion",
				specimentestrowversion = "@specimentestrowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "inactivatedate", "inactivateuser", "orderedtestguid"
			};
		}

		/// <summary>
		/// spIncompatibleCrossmatchResultsExist
		/// </summary>
		public abstract class IncompatibleCrossmatchResultsExist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIncompatibleCrossmatchResultsExist",
				BloodUnitGuid = "@BloodUnitGUID",
				lastupdatedate = "@lastupdatedate",
				PatientGuid = "@PatientGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid", "PatientGuid"
			};
		}

		/// <summary>
		/// spInsertAddress
		/// </summary>
		public abstract class InsertAddress
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAddress",
				addresscity = "@addresscity",
				addressguid = "@addressguid",
				addressline1 = "@addressline1",
				addressline2 = "@addressline2",
				addressline3 = "@addressline3",
				addresszipcode = "@addresszipcode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				statecode = "@statecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"addressguid"
			};
		}

		/// <summary>
		/// spInsertAntiseraOrderedTest
		/// </summary>
		public abstract class InsertAntiseraOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAntiseraOrderedTest",
				antiseraorderedtestguid = "@antiseraorderedtestguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedtestguid = "@orderedtestguid",
				racklotguid = "@racklotguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraorderedtestguid", "orderedtestguid", "racklotguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertAntiseraUnitTest
		/// </summary>
		public abstract class InsertAntiseraUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAntiseraUnitTest",
				antiseraunittestguid = "@antiseraunittestguid",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racklotguid = "@racklotguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraunittestguid", "antiseraworklisttypingguid", "racklotguid"
			};
		}

		/// <summary>
		/// spInsertAntiseraWorklist
		/// </summary>
		public abstract class InsertAntiseraWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAntiseraWorklist",
				antiseraworklistguid = "@antiseraworklistguid",
				autoinstrumentname = "@autoinstrumentname",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				testingmethodcode = "@testingmethodcode",
				worklistcreatedate = "@worklistcreatedate",
				worklistname = "@worklistname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "autoinstrumentname", "divisioncode", "recordstatuscode", "testingmethodcode", "worklistcreatedate", "worklistname"
			};
		}

		/// <summary>
		/// spInsertAntiseraWorklistTyping
		/// </summary>
		public abstract class InsertAntiseraWorklistTyping
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAntiseraWorklistTyping",
				antiseraworklistguid = "@antiseraworklistguid",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderabletestid = "@orderabletestid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "antiseraworklisttypingguid", "orderabletestid"
			};
		}

		/// <summary>
		/// spInsertAssociatedInstitution
		/// </summary>
		public abstract class InsertAssociatedInstitution
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertAssociatedInstitution",
				associatedinstitutionguid = "@associatedinstitutionguid",
				divisioncode = "@divisioncode",
				institutiondivisioncode = "@institutiondivisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"associatedinstitutionguid", "divisioncode", "institutiondivisioncode", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertBloodUnit
		/// </summary>
		public abstract class InsertBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnit",
				bloodproductguid = "@bloodproductguid",
				bloodunitguid = "@bloodunitguid",
				discardedplasmavolume = "@discardedplasmavolume",
				divisioncode = "@divisioncode",
				donationtypeid = "@donationtypeid",
				entrymethodcode = "@entrymethodcode",
				eyereadableunitid = "@eyereadableunitid",
				labeltypecode = "@labeltypecode",
				labelunitid = "@labelunitid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				originalvolume = "@originalvolume",
				processingtechid = "@processingtechid",
				recordstatuscode = "@recordstatuscode",
				unitcontainerlotnumber = "@unitcontainerlotnumber",
				unitdivisionid = "@unitdivisionid",
				unitfdaregistrationnumber = "@unitfdaregistrationnumber",
				unitindate = "@unitindate",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "bloodunitguid", "divisioncode", "donationtypeid", "eyereadableunitid", "labeltypecode", "labelunitid", "originalvolume", "recordstatuscode", "unitindate", "unitproductcode"
			};
		}

		/// <summary>
		/// spInsertBloodUnitAntigen
		/// </summary>
		public abstract class InsertBloodUnitAntigen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitAntigen",
				antigentypeid = "@antigentypeid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				positive = "@positive",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antigentypeid", "bloodunitguid", "divisioncode", "positive", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertBloodUnitFinance
		/// </summary>
		public abstract class InsertBloodUnitFinance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitFinance",
				bloodunitfinanceguid = "@bloodunitfinanceguid",
				bloodunitguid = "@bloodunitguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				returncreditamount = "@returncreditamount",
				specialtestingcost = "@specialtestingcost",
				unitcost = "@unitcost";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitfinanceguid", "bloodunitguid"
			};
		}

		/// <summary>
		/// spInsertBloodUnitMedia
		/// </summary>
		public abstract class InsertBloodUnitMedia
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitMedia",
				bloodtypecode = "@bloodtypecode",
				bloodunitguid = "@bloodunitguid",
				bloodunitmediaguid = "@bloodunitmediaguid",
				comments = "@comments",
				directedpatientguid = "@directedpatientguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rhfactorcode = "@rhfactorcode",
				testingstatusid = "@testingstatusid",
				unitexpirationdate = "@unitexpirationdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode", "bloodunitguid", "bloodunitmediaguid", "divisioncode", "rhfactorcode", "unitexpirationdate"
			};
		}

		/// <summary>
		/// spInsertBloodUnitModification
		/// </summary>
		public abstract class InsertBloodUnitModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitModification",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				frombloodproductguid = "@frombloodproductguid",
				frombloodunitguid = "@frombloodunitguid",
				fromoriginalvolume = "@fromoriginalvolume",
				fromunitexpirationdate = "@fromunitexpirationdate",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationcost = "@modificationcost",
				modificationdate = "@modificationdate",
				modificationmethodcode = "@modificationmethodcode",
				modificationtechid = "@modificationtechid",
				newcontainerweldindicator = "@newcontainerweldindicator",
				newlabelverificationdatetime = "@newlabelverificationdatetime",
				originalunitindicator = "@originalunitindicator",
				pooleditedindicator = "@pooleditedindicator",
				productmodificationcode = "@productmodificationcode",
				recordstatuscode = "@recordstatuscode",
				tobloodunitguid = "@tobloodunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "divisioncode", "frombloodproductguid", "frombloodunitguid", "fromoriginalvolume", "fromunitexpirationdate", "modificationcost", "modificationdate", "modificationmethodcode", "modificationtechid", "productmodificationcode", "tobloodunitguid"
			};
		}

		/// <summary>
		/// spInsertBloodUnitShipment
		/// </summary>
		public abstract class InsertBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitShipment",
				bloodunitguid = "@bloodunitguid",
				bloodunitshipmentguid = "@bloodunitshipmentguid",
				incomingshipmentguid = "@incomingshipmentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				loginbloodproductguid = "@loginbloodproductguid",
				loginfullproductcode = "@loginfullproductcode",
				loginvalues = "@loginvalues",
				outgoingshipmentguid = "@outgoingshipmentguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "bloodunitshipmentguid"
			};
		}

		/// <summary>
		/// spInsertBloodUnitStatus
		/// </summary>
		public abstract class InsertBloodUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitStatus",
				biohazardouswarningindicator = "@biohazardouswarningindicator",
				bloodunitguid = "@bloodunitguid",
				bloodunitstatusguid = "@bloodunitstatusguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				quarantineindicator = "@quarantineindicator",
				unitstatuscomments = "@unitstatuscomments";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"biohazardouswarningindicator", "bloodunitguid", "bloodunitstatusguid", "divisioncode"
			};
		}

		/// <summary>
		/// spInsertBloodUnitTest
		/// </summary>
		public abstract class InsertBloodUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertBloodUnitTest",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				autoinstrumentname = "@autoinstrumentname",
				bloodtesttypeid = "@bloodtesttypeid",
				bloodunitguid = "@bloodunitguid",
				bloodunittestguid = "@bloodunittestguid",
				confirmationworklistunitguid = "@confirmationworklistunitguid",
				correctedresultindicator = "@correctedresultindicator",
				divisioncode = "@divisioncode",
				entrymethodcode = "@entrymethodcode",
				entrytechid = "@entrytechid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedcomponentguid = "@orderedcomponentguid",
				orderedtestguid = "@orderedtestguid",
				orderedunitguid = "@orderedunitguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				RackGuid = "@rackguid",
				reactivityphasecode = "@reactivityphasecode",
				recordstatuscode = "@recordstatuscode",
				testcomments = "@testcomments",
				testdate = "@testdate",
				testingmethodcode = "@testingmethodcode",
				testresultid = "@testresultid",
				testtechid = "@testtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtesttypeid", "bloodunitguid", "bloodunittestguid", "divisioncode", "entrymethodcode", "testdate"
			};
		}

		/// <summary>
		/// spInsertCannedComment
		/// </summary>
		public abstract class InsertCannedComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertCannedComment",
				cannedcommentcategorycode = "@cannedcommentcategorycode",
				cannedcommentguid = "@cannedcommentguid",
				cannedcommenttext = "@cannedcommenttext",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				sortcolumn = "@sortcolumn";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"cannedcommentcategorycode", "cannedcommentguid", "cannedcommenttext", "divisioncode", "recordstatuscode", "sortcolumn"
			};
		}

		/// <summary>
		/// spInsertComponentClassParameter
		/// </summary>
		public abstract class InsertComponentClassParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertComponentClassParameter",
				componentclassid = "@componentclassid",
				componentclassparameterguid = "@componentclassparameterguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maximumtransfusiontime = "@maximumtransfusiontime",
				orderableindicator = "@orderableindicator",
				specimenrequiredindicator = "@specimenrequiredindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid", "componentclassparameterguid", "divisioncode", "maximumtransfusiontime", "orderableindicator", "specimenrequiredindicator"
			};
		}

		/// <summary>
		/// spInsertConfirmationWorklistUnit
		/// </summary>
		public abstract class InsertConfirmationWorklistUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertConfirmationWorklistUnit",
				autoinstrumentname = "@autoinstrumentname",
				autoinstrumentqcindicator = "@autoinstrumentqcindicator",
				bloodunitguid = "@bloodunitguid",
				confirmationworklistunitguid = "@confirmationworklistunitguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				RackGuid = "@rackguid",
				sortcolumn = "@sortcolumn";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"autoinstrumentname", "autoinstrumentqcindicator", "bloodunitguid", "confirmationworklistunitguid", "RackGuid", "sortcolumn"
			};
		}

		/// <summary>
		/// spInsertCptCache
		/// </summary>
		public abstract class InsertCptCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertCptCache",
				code_id = "@code_id",
				cptcode_text = "@cptcode_text",
				lastupdatedate = "@lastupdatedate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"code_id", "cptcode_text"
			};
		}

		/// <summary>
		/// spInsertDailyControl
		/// </summary>
		public abstract class InsertDailyControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertDailyControl",
				comments = "@comments",
				commercialtemplateindicator = "@commercialtemplateindicator",
				dailyalerttime = "@dailyalerttime",
				dailycontrolguid = "@dailycontrolguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				numberofracks = "@numberofracks",
				primaryenhancementmediaid = "@primaryenhancementmediaid",
				racknamesindicator = "@racknamesindicator",
				recordstatuscode = "@recordstatuscode",
				secondaryenhancementmediaid = "@secondaryenhancementmediaid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commercialtemplateindicator", "dailyalerttime", "dailycontrolguid", "divisioncode", "numberofracks", "primaryenhancementmediaid", "racknamesindicator", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertDailyQcWorklist
		/// </summary>
		public abstract class InsertDailyQcWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertDailyQcWorklist",
				dailyqcexpirationdate = "@dailyqcexpirationdate",
				dailyqcworklistguid = "@dailyqcworklistguid",
				dailyuseindicator = "@dailyuseindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				partiallytestedindicator = "@partiallytestedindicator",
				qcofflineindicator = "@qcofflineindicator",
				RackGuid = "@rackguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid", "dailyuseindicator", "divisioncode", "partiallytestedindicator"
			};
		}

		/// <summary>
		/// spInsertEquipment
		/// </summary>
		public abstract class InsertEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertEquipment",
				addressguid = "@addressguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid",
				equipmentname = "@equipmentname",
				equipmenttype = "@equipmenttype",
				inspectionindicator = "@inspectionindicator",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localidentifier = "@localidentifier",
				maintenancecontractdate = "@maintenancecontractdate",
				maintenancecontractnumber = "@maintenancecontractnumber",
				manufacturername = "@manufacturername",
				manufacturerphonenumber = "@manufacturerphonenumber",
				nextmaintenancetext = "@nextmaintenancetext",
				outofserviceindicator = "@outofserviceindicator",
				receiptdate = "@receiptdate",
				receipttechid = "@receipttechid",
				serialnumber = "@serialnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"addressguid", "divisioncode", "equipmentguid", "equipmentname", "localidentifier", "manufacturername", "receiptdate", "serialnumber"
			};
		}

		/// <summary>
		/// spInsertEquipmentMaintenance
		/// </summary>
		public abstract class InsertEquipmentMaintenance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertEquipmentMaintenance",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid",
				equipmentmaintenanceguid = "@equipmentmaintenanceguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maintenancedate = "@maintenancedate",
				maintenanceresults = "@maintenanceresults",
				maintenancetype = "@maintenancetype",
				pendingissues = "@pendingissues";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentguid", "equipmentmaintenanceguid", "maintenancedate", "maintenanceresults", "maintenancetype"
			};
		}

		/// <summary>
		/// spInsertExceptionAboIncompatibleTransfusion
		/// </summary>
		public abstract class InsertExceptionAboIncompatibleTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionAboIncompatibleTransfusion",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontransfusionguid = "@exceptiontransfusionguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				transfusedpatientaborh = "@transfusedpatientaborh",
				transfusedpatientguid = "@transfusedpatientguid",
				transfusedpatientid = "@transfusedpatientid",
				transfusedpatientname = "@transfusedpatientname",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptiontransfusionguid", "exceptiontypeid", "exceptionuser", "transfusedpatientaborh", "transfusedpatientguid", "transfusedpatientid", "transfusedpatientname", "unitaborh", "unitexpirationdate", "unitguid", "unitid", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertExceptionAntigenTest
		/// </summary>
		public abstract class InsertExceptionAntigenTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionAntigenTest",
				currenttestingtechname = "@currenttestingtechname",
				divisioncode = "@divisioncode",
				exceptionantigentestguid = "@exceptionantigentestguid",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				invalidateddate = "@invalidateddate",
				invalidatedresult = "@invalidatedresult",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				previoustestingtechname = "@previoustestingtechname",
				productshortname = "@productshortname",
				testperformed = "@testperformed",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currenttestingtechname", "divisioncode", "exceptionantigentestguid", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionuser", "invalidateddate", "invalidatedresult", "previoustestingtechname", "productshortname", "testperformed", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionCautionTagBTRF
		/// </summary>
		public abstract class InsertExceptionCautionTagBTRF
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionCautionTagBTRF",
				divisioncode = "@divisioncode",
				exceptioncautiontagguid = "@exceptioncautiontagguid",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientaborh = "@patientaborh",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				productcode = "@productcode",
				specimenuid = "@specimenuid",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncautiontagguid", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionuser", "patientaborh", "patientguid", "patientid", "patientname", "productcode", "unitaborh", "unitexpirationdate", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionElectronicTransfusion
		/// </summary>
		public abstract class InsertExceptionElectronicTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionElectronicTransfusion",
				bedsideverificationdate = "@bedsideverificationdate",
				bedsideverificationunitmanualentryreason = "@bedsideverificationunitmanualentryreason",
				divisioncode = "@divisioncode",
				exceptiondate = "@exceptiondate",
				exceptionelectronictransfusionguid = "@exceptionelectronictransfusionguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				interruptionindicator = "@interruptionindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientid = "@patientid",
				patientname = "@patientname",
				patienttransfusioncomment = "@patienttransfusioncomment",
				patienttransfusionguid = "@patienttransfusionguid",
				reactionindicator = "@reactionindicator",
				reactionsymptoms = "@reactionsymptoms",
				transfusedvolume = "@transfusedvolume",
				transfusionenddatetime = "@transfusionenddatetime",
				transfusionist1id = "@transfusionist1id",
				transfusionist2id = "@transfusionist2id",
				transfusionlocation = "@transfusionlocation",
				transfusionstartdatetime = "@transfusionstartdatetime",
				unitid = "@unitid",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptiondate", "exceptionelectronictransfusionguid", "exceptiontypeid", "exceptionuser"
			};
		}

		/// <summary>
		/// spInsertExceptionEmergencyIssueOrder
		/// </summary>
		public abstract class InsertExceptionEmergencyIssueOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionEmergencyIssueOrder",
				componentclassordered = "@componentclassordered",
				cprsordernumber = "@cprsordernumber",
				dateacknowledged = "@dateacknowledged",
				datewanted = "@datewanted",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionemergencyissueorderguid = "@exceptionemergencyissueorderguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				processingtechname = "@processingtechname",
				urgencyindicator = "@urgencyindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassordered", "cprsordernumber", "dateacknowledged", "datewanted", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionemergencyissueorderguid", "exceptiontypeid", "exceptionuser", "patientid", "patientname", "processingtechname", "urgencyindicator"
			};
		}

		/// <summary>
		/// spInsertExceptionEmergencyIssueUnitTest
		/// </summary>
		public abstract class InsertExceptionEmergencyIssueUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionEmergencyIssueUnitTest",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionemergencyissueunittestguid = "@exceptionemergencyissueunittestguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientaborh = "@patientaborh",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				testingtechname = "@testingtechname",
				testinterp = "@testinterp",
				testperformed = "@testperformed",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionemergencyissueunittestguid", "exceptiontypeid", "exceptionuser", "patientaborh", "patientid", "patientname", "testingtechname", "testinterp", "testperformed", "unitaborh", "unitexpirationdate", "unitid", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertExceptionExpiredTask
		/// </summary>
		public abstract class InsertExceptionExpiredTask
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionExpiredTask",
				componentclassordered = "@componentclassordered",
				cprsordernumber = "@cprsordernumber",
				datewanted = "@datewanted",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionexpiredtaskguid = "@exceptionexpiredtaskguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				logintechname = "@logintechname",
				patientid = "@patientid",
				patientname = "@patientname",
				quantity = "@quantity",
				specimenuid = "@specimenuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassordered", "cprsordernumber", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionexpiredtaskguid", "exceptiontypeid", "exceptionuser", "logintechname", "patientid", "patientname", "quantity", "specimenuid"
			};
		}

		/// <summary>
		/// spInsertExceptionExpiredUnitReceived
		/// </summary>
		public abstract class InsertExceptionExpiredUnitReceived
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionExpiredUnitReceived",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionexpiredunitreceivedguid = "@exceptionexpiredunitreceivedguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				expirationdate = "@expirationdate",
				incomingshipmentdate = "@incomingshipmentdate",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				processingtechid = "@processingtechid",
				productcode = "@productcode",
				producttype = "@producttype",
				unitaborh = "@unitaborh",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionexpiredunitreceivedguid", "exceptiontypeid", "exceptionuser", "expirationdate", "incomingshipmentdate", "processingtechid", "productcode", "producttype", "unitaborh", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionInconclusiveCrossmatch
		/// </summary>
		public abstract class InsertExceptionInconclusiveCrossmatch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionInconclusiveCrossmatch",
				bloodunitguid = "@bloodunitguid",
				bloodunitid = "@bloodunitid",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptioninconclusivecrossmatchguid = "@exceptioninconclusivecrossmatchguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				specimenuid = "@specimenuid",
				systeminterp = "@systeminterp",
				techinterp = "@techinterp",
				testingtechname = "@testingtechname",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitid", "divisioncode", "exceptioncomment", "exceptiondate", "exceptioninconclusivecrossmatchguid", "exceptiontypeid", "exceptionuser", "patientid", "patientname", "specimenuid", "systeminterp", "techinterp", "testingtechname", "unitproductcode"
			};
		}

		/// <summary>
		/// spInsertExceptionLabelMismatch
		/// </summary>
		public abstract class InsertExceptionLabelMismatch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionLabelMismatch",
				correctedvalue = "@correctedvalue",
				discrepantfield = "@discrepantfield",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionlabelmismatchguid = "@exceptionlabelmismatchguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				modificationdate = "@modificationdate",
				modificationtype = "@modificationtype",
				targetproductcode = "@targetproductcode",
				targetproducttype = "@targetproducttype",
				targetunitaborh = "@targetunitaborh",
				targetunitexpirationdate = "@targetunitexpirationdate",
				targetunitguid = "@targetunitguid",
				targetunitid = "@targetunitid",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"correctedvalue", "discrepantfield", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionlabelmismatchguid", "exceptiontypeid", "exceptionuser", "modificationdate", "modificationtype", "targetproductcode", "targetproducttype", "targetunitaborh", "targetunitexpirationdate", "targetunitguid", "targetunitid", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientAboRH
		/// </summary>
		public abstract class InsertExceptionPatientAboRH
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientAboRH",
				currentsystemaborh = "@currentsystemaborh",
				currenttechaborh = "@currenttechaborh",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatientaborhguid = "@exceptionpatientaborhguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				pretestingaborh = "@pretestingaborh",
				specimenuid = "@specimenuid",
				testdate = "@testdate",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currentsystemaborh", "currenttechaborh", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionpatientaborhguid", "exceptiontypeid", "exceptionuser", "patientguid", "patientid", "patientname", "pretestingaborh", "specimenuid", "testdate", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientAboRHDiscrepancy
		/// </summary>
		public abstract class InsertExceptionPatientAboRHDiscrepancy
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientAboRHDiscrepancy",
				currententrytechname = "@currententrytechname",
				currentspecimenaborh = "@currentspecimenaborh",
				currentspecimenuid = "@currentspecimenuid",
				currenttestingdate = "@currenttestingdate",
				currenttestingdivision = "@currenttestingdivision",
				currenttestingtechname = "@currenttestingtechname",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatientaborhdiscrepancyguid = "@exceptionpatientaborhdiscrepancyguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				previousentrytechname = "@previousentrytechname",
				previousSpecimenaborh = "@previousSpecimenaborh",
				previousspecimenuid = "@previousspecimenuid",
				previoustestingdate = "@previoustestingdate",
				previoustestingdivision = "@previoustestingdivision",
				previoustestingtechname = "@previoustestingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currententrytechname", "currentspecimenaborh", "currentspecimenuid", "currenttestingdate", "currenttestingdivision", "currenttestingtechname", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionpatientaborhdiscrepancyguid", "exceptiontypeid", "exceptionuser", "patientguid", "patientid", "patientname", "previousentrytechname", "previousSpecimenaborh", "previousspecimenuid", "previoustestingdivision", "previoustestingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientAntigenDiscrepancy
		/// </summary>
		public abstract class InsertExceptionPatientAntigenDiscrepancy
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientAntigenDiscrepancy",
				currentspecimentestresults = "@currentspecimentestresults",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatientantigendiscrepancyguid = "@exceptionpatientantigendiscrepancyguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				historicspecimentestresults = "@historicspecimentestresults",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				lotexpirationdate = "@lotexpirationdate",
				lotnumber = "@lotnumber",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				reagentmanufacturername = "@reagentmanufacturername",
				reagentname = "@reagentname",
				reagenttypename = "@reagenttypename",
				specimenuid = "@specimenuid",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currentspecimentestresults", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionpatientantigendiscrepancyguid", "exceptiontypeid", "exceptionuser", "historicspecimentestresults", "lotexpirationdate", "lotnumber", "patientguid", "patientid", "patientname", "reagentmanufacturername", "reagentname", "reagenttypename", "specimenuid", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientRestriction
		/// </summary>
		public abstract class InsertExceptionPatientRestriction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientRestriction",
				divisioncode = "@divisioncode",
				donationtype = "@donationtype",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatientrestrictionguid = "@exceptionpatientrestrictionguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				productcode = "@productcode",
				productshortname = "@productshortname",
				restrictedpatientguid = "@restrictedpatientguid",
				restrictedpatientid = "@restrictedpatientid",
				restrictedpatientname = "@restrictedpatientname",
				specialtesting = "@specialtesting",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "donationtype", "exceptioncomment", "exceptiondate", "exceptionpatientrestrictionguid", "exceptiontypeid", "exceptionuser", "productcode", "productshortname", "restrictedpatientguid", "restrictedpatientid", "restrictedpatientname", "specialtesting", "unitaborh", "unitexpirationdate", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientTest
		/// </summary>
		public abstract class InsertExceptionPatientTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientTest",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatienttestguid = "@exceptionpatienttestguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				reactivityphase = "@reactivityphase",
				specimenuid = "@specimenuid",
				testdate = "@testdate",
				testingtechname = "@testingtechname",
				testinterp = "@testinterp",
				testname = "@testname",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionpatienttestguid", "exceptiontypeid", "exceptionuser", "patientid", "patientname", "specimenuid", "testdate", "testingtechname", "testinterp", "testname"
			};
		}

		/// <summary>
		/// spInsertExceptionPatientTestInactivated
		/// </summary>
		public abstract class InsertExceptionPatientTestInactivated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionPatientTestInactivated",
				currenttechname = "@currenttechname",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionpatienttestinactivatedguid = "@exceptionpatienttestinactivatedguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				inactivationdate = "@inactivationdate",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				specimenuid = "@specimenuid",
				testingtechname = "@testingtechname",
				testname = "@testname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currenttechname", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionpatienttestinactivatedguid", "exceptiontypeid", "exceptionuser", "inactivationdate", "patientguid", "patientid", "patientname", "specimenuid", "testingtechname", "testname"
			};
		}

		/// <summary>
		/// spInsertExceptionQC
		/// </summary>
		public abstract class InsertExceptionQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionQC",
				bloodunitguid = "@bloodunitguid",
				currentresult = "@currentresult",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionqcguid = "@exceptionqcguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				lotexpirationdate = "@lotexpirationdate",
				lotnumber = "@lotnumber",
				patientguid = "@patientguid",
				previousresult = "@previousresult",
				rackname = "@rackname",
				reactivityphase = "@reactivityphase",
				reagentmanufacturername = "@reagentmanufacturername",
				reagentname = "@reagentname",
				reagenttypename = "@reagenttypename",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currentresult", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionqcguid", "exceptiontypeid", "exceptionuser", "lotexpirationdate", "lotnumber", "previousresult", "rackname", "reactivityphase", "reagentmanufacturername", "reagentname", "reagenttypename", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionQCInactivated
		/// </summary>
		public abstract class InsertExceptionQCInactivated
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionQCInactivated",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionqcinactivationguid = "@exceptionqcinactivationguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				reagentrack = "@reagentrack",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionqcinactivationguid", "exceptiontypeid", "exceptionuser", "reagentrack", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionQCInactivatedReagents
		/// </summary>
		public abstract class InsertExceptionQCInactivatedReagents
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionQCInactivatedReagents",
				ccresult = "@ccresult",
				exceptionqcinactivationguid = "@exceptionqcinactivationguid",
				exceptionqcinactivationreagentguid = "@exceptionqcinactivationreagentguid",
				iatresult = "@iatresult",
				isresult = "@isresult",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				reagenttypename = "@reagenttypename",
				testwithname = "@testwithname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"ccresult", "exceptionqcinactivationguid", "exceptionqcinactivationreagentguid", "iatresult", "isresult", "reagenttypename", "testwithname"
			};
		}

		/// <summary>
		/// spInsertExceptionQCNotPerformed
		/// </summary>
		public abstract class InsertExceptionQCNotPerformed
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionQCNotPerformed",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionqcnotperformedguid = "@exceptionqcnotperformedguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				productcode = "@productcode",
				rackname = "@rackname",
				specimenuid = "@specimenuid",
				testingtechname = "@testingtechname",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionqcnotperformedguid", "exceptiontypeid", "exceptionuser", "rackname", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionQuarantine
		/// </summary>
		public abstract class InsertExceptionQuarantine
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionQuarantine",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionquarantineguid = "@exceptionquarantineguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				testingtechname = "@testingtechname",
				unitaborh = "@unitaborh",
				unitantigentypingresult = "@unitantigentypingresult",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproductcode = "@unitproductcode",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionquarantineguid", "exceptiontypeid", "exceptionuser", "testingtechname", "unitaborh", "unitantigentypingresult", "unitexpirationdate", "unitguid", "unitid", "unitproductcode", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertExceptionReflexTest
		/// </summary>
		public abstract class InsertExceptionReflexTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionReflexTest",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionreflextestguid = "@exceptionreflextestguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				specimenexpirationdate = "@specimenexpirationdate",
				specimenuid = "@specimenuid",
				testingtechname = "@testingtechname",
				testordered = "@testordered";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionreflextestguid", "exceptiontypeid", "exceptionuser", "patientguid", "patientid", "patientname", "specimenexpirationdate", "specimenuid", "testingtechname", "testordered"
			};
		}

		/// <summary>
		/// spInsertExceptionRemoveFinalUnitStatus
		/// </summary>
		public abstract class InsertExceptionRemoveFinalUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionRemoveFinalUnitStatus",
				currentunitexpirationdate = "@currentunitexpirationdate",
				currentunitproducttype = "@currentunitproducttype",
				currentunitstatus = "@currentunitstatus",
				currentunitvolume = "@currentunitvolume",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionremovefinalunitstatusguid = "@exceptionremovefinalunitstatusguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				previousunitexpirationdate = "@previousunitexpirationdate",
				previousunitproducttype = "@previousunitproducttype",
				previousunitstatus = "@previousunitstatus",
				previousunitvolume = "@previousunitvolume",
				unitaborh = "@unitaborh",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"currentunitexpirationdate", "currentunitproducttype", "currentunitstatus", "currentunitvolume", "divisioncode", "exceptioncomment", "exceptiondate", "exceptionremovefinalunitstatusguid", "exceptiontypeid", "exceptionuser", "previousunitexpirationdate", "previousunitproducttype", "previousunitstatus", "previousunitvolume", "unitaborh", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionReturnIssuedUnit
		/// </summary>
		public abstract class InsertExceptionReturnIssuedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionReturnIssuedUnit",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionreturnedunitguid = "@exceptionreturnedunitguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				issuetolocation = "@issuetolocation",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientaborh = "@patientaborh",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				processingtechname = "@processingtechname",
				returnedunitaborh = "@returnedunitaborh",
				returnedunitexpirationdate = "@returnedunitexpirationdate",
				returnedunitguid = "@returnedunitguid",
				returnedunitid = "@returnedunitid",
				returnedunitproductshortname = "@returnedunitproductshortname",
				visualinspectionindicator = "@visualinspectionindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionreturnedunitguid", "exceptiontypeid", "exceptionuser", "issuetolocation", "patientaborh", "patientguid", "patientid", "patientname", "processingtechname", "returnedunitaborh", "returnedunitexpirationdate", "returnedunitguid", "returnedunitid", "returnedunitproductshortname", "visualinspectionindicator"
			};
		}

		/// <summary>
		/// spInsertExceptionSpecimen
		/// </summary>
		public abstract class InsertExceptionSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionSpecimen",
				componentclassordered = "@componentclassordered",
				dateorderaccepted = "@dateorderaccepted",
				datewanted = "@datewanted",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptionspecimenguid = "@exceptionspecimenguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				extendedexpirationdate = "@extendedexpirationdate",
				lasttransfusiondatetime = "@lasttransfusiondatetime",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientantibodies = "@patientantibodies",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				specimenexpirationdate = "@specimenexpirationdate",
				specimenuid = "@specimenuid",
				testingtechname = "@testingtechname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptionspecimenguid", "exceptiontypeid", "exceptionuser", "patientantibodies", "patientguid", "patientid", "patientname", "specimenexpirationdate", "specimenuid", "testingtechname"
			};
		}

		/// <summary>
		/// spInsertExceptionTransfusionReactionWorkup
		/// </summary>
		public abstract class InsertExceptionTransfusionReactionWorkup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionTransfusionReactionWorkup",
				assignedpatientguid = "@assignedpatientguid",
				assignedpatientid = "@assignedpatientid",
				assignedpatientname = "@assignedpatientname",
				clericalcheckfailed = "@clericalcheckfailed",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontransfusionreactionworkupguid = "@exceptiontransfusionreactionworkupguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				issuedate = "@issuedate",
				issuetechid = "@issuetechid",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				productcode = "@productcode",
				productshortname = "@productshortname",
				trwdate = "@trwdate",
				trwpatientguid = "@trwpatientguid",
				trwpatientid = "@trwpatientid",
				trwpatientname = "@trwpatientname",
				trwtechid = "@trwtechid",
				unitaborh = "@unitaborh",
				unitdonationtype = "@unitdonationtype",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"assignedpatientguid", "assignedpatientid", "assignedpatientname", "clericalcheckfailed", "divisioncode", "exceptioncomment", "exceptiondate", "exceptiontransfusionreactionworkupguid", "exceptiontypeid", "exceptionuser", "issuedate", "issuetechid", "productcode", "productshortname", "trwdate", "trwpatientguid", "trwpatientid", "trwpatientname", "trwtechid", "unitaborh", "unitdonationtype", "unitexpirationdate", "unitguid", "unitid"
			};
		}

		/// <summary>
		/// spInsertExceptionTrwSpecimen
		/// </summary>
		public abstract class InsertExceptionTrwSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionTrwSpecimen",
				clericalcheckfailed = "@clericalcheckfailed",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontrwspecimenguid = "@exceptiontrwspecimenguid",
				exceptiontypeid = "@exceptiontypeid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				specimenpatientguid = "@specimenpatientguid",
				specimenpatientid = "@specimenpatientid",
				specimenpatientname = "@specimenpatientname",
				specimenuid = "@specimenuid",
				trwdate = "@trwdate",
				trwpatientguid = "@trwpatientguid",
				trwpatientid = "@trwpatientid",
				trwpatientname = "@trwpatientname",
				trwtechid = "@trwtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"clericalcheckfailed", "divisioncode", "exceptioncomment", "exceptiondate", "exceptiontrwspecimenguid", "exceptiontypeid", "exceptionuser", "specimenpatientguid", "specimenpatientid", "specimenpatientname", "specimenuid", "trwdate", "trwpatientguid", "trwpatientid", "trwpatientname", "trwtechid"
			};
		}

		/// <summary>
		/// spInsertExceptionUnitAboRH
		/// </summary>
		public abstract class InsertExceptionUnitAboRH
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionUnitAboRH",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionunitaborhguid = "@exceptionunitaborhguid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				loginunitaborh = "@loginunitaborh",
				testingtechname = "@testingtechname",
				unitaborhinterp = "@unitaborhinterp",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionunitaborhguid", "exceptionuser", "loginunitaborh", "testingtechname", "unitaborhinterp", "unitexpirationdate", "unitguid", "unitid", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertExceptionUnitIssue
		/// </summary>
		public abstract class InsertExceptionUnitIssue
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionUnitIssue",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionunitissueguid = "@exceptionunitissueguid",
				exceptionuser = "@exceptionuser",
				historicaborh = "@historicaborh",
				issuedatetime = "@issuedatetime",
				issuedtolocation = "@issuedtolocation",
				issuingtechname = "@issuingtechname",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				logintechname = "@logintechname",
				orderedby = "@orderedby",
				orderindicator = "@orderindicator",
				patientantibodies = "@patientantibodies",
				patientguid = "@patientguid",
				patientid = "@patientid",
				patientname = "@patientname",
				patienttransfusionrequirements = "@patienttransfusionrequirements",
				specimenuid = "@specimenuid",
				systemaborh = "@systemaborh",
				techaborh = "@techaborh",
				transportername = "@transportername",
				unitaborh = "@unitaborh",
				unitantigens = "@unitantigens",
				unitdonationtype = "@unitdonationtype",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitId = "@unitId",
				unitproducttype = "@unitproducttype",
				unittestingentry = "@unittestingentry";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionunitissueguid", "exceptionuser", "historicaborh", "issuedatetime", "issuedtolocation", "issuingtechname", "logintechname", "orderedby", "orderindicator", "patientantibodies", "patientid", "patientname", "patienttransfusionrequirements", "specimenuid", "systemaborh", "techaborh", "transportername", "unitaborh", "unitantigens", "unitdonationtype", "unitexpirationdate", "unitId", "unitproducttype", "unittestingentry"
			};
		}

		/// <summary>
		/// spInsertExceptionUnitModification
		/// </summary>
		public abstract class InsertExceptionUnitModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionUnitModification",
				componentname = "@componentname",
				divisioncode = "@divisioncode",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionunitmodificationguid = "@exceptionunitmodificationguid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				modificationdate = "@modificationdate",
				modificationtype = "@modificationtype",
				modifyingtech = "@modifyingtech",
				recommendedexpirationdate = "@recommendedexpirationdate",
				supplyexpirationdate = "@supplyexpirationdate",
				supplylotnumber = "@supplylotnumber",
				supplyname = "@supplyname",
				supplytype = "@supplytype",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproductcode = "@unitproductcode",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionunitmodificationguid", "exceptionuser", "modificationdate", "modificationtype", "modifyingtech", "unitaborh", "unitexpirationdate", "unitguid", "unitid", "unitproductcode", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertExceptionUnitSelection
		/// </summary>
		public abstract class InsertExceptionUnitSelection
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertExceptionUnitSelection",
				antigennegativerequirements = "@antigennegativerequirements",
				antigentypingresult = "@antigentypingresult",
				componentrequirements = "@componentrequirements",
				divisioncode = "@divisioncode",
				donationtype = "@donationtype",
				exceptioncomment = "@exceptioncomment",
				exceptiondate = "@exceptiondate",
				exceptiontypeid = "@exceptiontypeid",
				exceptionunitselectionguid = "@exceptionunitselectionguid",
				exceptionuser = "@exceptionuser",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				patientantibodies = "@patientantibodies",
				patientcurrentaborh = "@patientcurrentaborh",
				patientguid = "@patientguid",
				patienthistoricalaborh = "@patienthistoricalaborh",
				patientid = "@patientid",
				patientname = "@patientname",
				selectiondate = "@selectiondate",
				testingtechname = "@testingtechname",
				unitaborh = "@unitaborh",
				unitexpirationdate = "@unitexpirationdate",
				unitguid = "@unitguid",
				unitid = "@unitid",
				unitproducttype = "@unitproducttype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antigennegativerequirements", "antigentypingresult", "componentrequirements", "divisioncode", "donationtype", "exceptioncomment", "exceptiondate", "exceptiontypeid", "exceptionunitselectionguid", "exceptionuser", "patientantibodies", "patientcurrentaborh", "patientguid", "patienthistoricalaborh", "patientid", "patientname", "selectiondate", "testingtechname", "unitaborh", "unitexpirationdate", "unitguid", "unitid", "unitproducttype"
			};
		}

		/// <summary>
		/// spInsertHcpcsAssignment
		/// </summary>
		public abstract class InsertHcpcsAssignment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertHcpcsAssignment",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode",
				hcpcsassignmentguid = "@hcpcsassignmentguid",
				hcpcscode = "@hcpcscode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode", "hcpcsassignmentguid", "hcpcscode"
			};
		}

		/// <summary>
		/// spInsertHcpcsCache
		/// </summary>
		public abstract class InsertHcpcsCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertHcpcsCache",
				code = "@code",
				lastupdatedate = "@lastupdatedate",
				name = "@name";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"code", "name"
			};
		}

		/// <summary>
		/// spInsertHospitalLocationCache
		/// </summary>
		public abstract class InsertHospitalLocationCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertHospitalLocationCache",
				lastupdatedate = "@lastupdatedate",
				locationdivision = "@locationdivision",
				locationien = "@locationien",
				locationname = "@locationname",
				locationtype = "@locationtype";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"locationdivision", "locationien", "locationname", "locationtype"
			};
		}

		/// <summary>
		/// spInsertIssuedUnit
		/// </summary>
		public abstract class InsertIssuedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertIssuedUnit",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				inpatientlocationindicator = "@inpatientlocationindicator",
				issuedatetime = "@issuedatetime",
				issuedunitguid = "@issuedunitguid",
				issuesatisfactoryindicator = "@issuesatisfactoryindicator",
				issuetechid = "@issuetechid",
				issuetolocationname = "@issuetolocationname",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				physicianname = "@physicianname",
				remotestorageindicator = "@remotestorageindicator",
				remotestoragetext = "@remotestoragetext",
				transportername = "@transportername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "inpatientlocationindicator", "issuedatetime", "issuedunitguid", "issuesatisfactoryindicator", "issuetechid", "issuetolocationname", "patientguid", "remotestorageindicator", "transportername"
			};
		}

		/// <summary>
		/// spInsertIssuedUnitComment
		/// </summary>
		public abstract class InsertIssuedUnitComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertIssuedUnitComment",
				divisioncode = "@divisioncode",
				issuedunitcommentguid = "@issuedunitcommentguid",
				issuedunitcommenttext = "@issuedunitcommenttext",
				issuedunitguid = "@issuedunitguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "issuedunitcommentguid", "issuedunitguid"
			};
		}

		/// <summary>
		/// spInsertLocalSupplier
		/// </summary>
		public abstract class InsertLocalSupplier
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertLocalSupplier",
				addressguid = "@addressguid",
				collectionindicator = "@collectionindicator",
				divisioncode = "@divisioncode",
				facilityguid = "@facilityguid",
				facilityname = "@facilityname",
				facilityprefix = "@facilityprefix",
				faxnumber = "@faxnumber",
				fdaregistrationnumber = "@fdaregistrationnumber",
				iccbbaregistrationnumber = "@iccbbaregistrationnumber",
				labelunitidtrimindicator = "@labelunitidtrimindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				phonenumber = "@phonenumber",
				recordstatuscode = "@recordstatuscode",
				testingindicator = "@testingindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"addressguid", "divisioncode", "facilityname", "fdaregistrationnumber", "localsupplierguid", "recordstatuscode"
			};
		}

        /// <summary>
        /// spInsertLock
        /// </summary>
        public abstract class InsertVbecsLock
        {
            /// <summary>
            /// Stored procedure name and list of all parms written as const
            /// </summary>
            public const string
                StoredProcName = "dbo.spInsertVbecsLock",
                baselockedformid = "baselockedformid",
                divisioncode = "@divisioncode",
                lastupdatefunctionid = "@lastupdatefunctionid",
                lastupdateuser = "@lastupdateuser",
                lockedformid = "@lockedformid",
                lockedrecordguid = "@lockedrecordguid",
                lockedusecaseid = "@lockedusecaseid",
                lockfunctionid = "@lockfunctionid",
                lockinactivitytimeoutmin = "@lockinactivitytimeoutmin",
                multidivisionindicator = "@multidivisionindicator",
                sessionguid = "@sessionguid";

            /// <summary>
            /// Required stored procedure parameters written as static array of strings
            /// </summary>
            public static string[] RequiredParameters = new string[]
			{
				"lockedformid", "baselockedformid", "lockfunctionid", "sessionguid"
			};
        }


		/// <summary>
		/// spInsertModificationEquipment
		/// </summary>
		public abstract class InsertModificationEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertModificationEquipment",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				equipmentguid = "@equipmentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationequipmentguid = "@modificationequipmentguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "equipmentguid", "modificationequipmentguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertModificationSupply
		/// </summary>
		public abstract class InsertModificationSupply
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertModificationSupply",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationsupplyguid = "@modificationsupplyguid",
				recordstatuscode = "@recordstatuscode",
				supplyguid = "@supplyguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "modificationsupplyguid", "recordstatuscode", "supplyguid"
			};
		}

		/// <summary>
		/// spInsertMsbos
		/// </summary>
		public abstract class InsertMsbos
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertMsbos",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				msbosguid = "@msbosguid",
				nobloodrequiredindicator = "@nobloodrequiredindicator",
				recordstatuscode = "@recordstatuscode",
				surgeryname = "@surgeryname",
				typeandscreenindicator = "@typeandscreenindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "msbosguid", "nobloodrequiredindicator", "recordstatuscode", "surgeryname", "typeandscreenindicator"
			};
		}

		/// <summary>
		/// spInsertMsbosComponentClass
		/// </summary>
		public abstract class InsertMsbosComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertMsbosComponentClass",
				componentclassid = "@componentclassid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maximumsetupunitquantity = "@maximumsetupunitquantity",
				msboscomponentclassguid = "@msboscomponentclassguid",
				msbosguid = "@msbosguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid", "maximumsetupunitquantity", "msboscomponentclassguid", "msbosguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertOrderedTest
		/// </summary>
		public abstract class InsertOrderedTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertOrderedTest",
				autoinstrumentname = "@autoinstrumentname",
				cancellationcannedcommentguid = "@cancellationcannedcommentguid",
				cprsordernumber = "@cprsordernumber",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderabletestid = "@orderabletestid",
				orderedtestcomments = "@orderedtestcomments",
				orderedtestguid = "@orderedtestguid",
				orderstatuscode = "@orderstatuscode",
				orderurgencycode = "@orderurgencycode",
				patientorderguid = "@patientorderguid",
				patientspecimenguid = "@patientspecimenguid",
				relatedcomponentguid = "@relatedcomponentguid",
				relatedtestguid = "@relatedtestguid",
				requiredresultsdate = "@requiredresultsdate",
				specimenrequiredindicator = "@specimenrequiredindicator",
				taskstatuscode = "@taskstatuscode",
				testinterpretation = "@testinterpretation",
				testinterpretationcomments = "@testinterpretationcomments",
				vbecsordernumber = "@vbecsordernumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedtestguid", "patientorderguid", "vbecsordernumber"
			};
		}

		/// <summary>
		/// spInsertOrderedUnit
		/// </summary>
		public abstract class InsertOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertOrderedUnit",
				bloodunitguid = "@bloodunitguid",
				crossmatchdate = "@crossmatchdate",
				crossmatchrequiredindicator = "@crossmatchrequiredindicator",
				crossmatchresultcode = "@crossmatchresultcode",
				crossmatchtechid = "@crossmatchtechid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedcomponentguid = "@orderedcomponentguid",
				orderedtestguid = "@orderedtestguid",
				orderedunitguid = "@orderedunitguid",
				recordstatuscode = "@recordstatuscode",
				releasedate = "@releasedate",
				selecteddate = "@selecteddate",
				selectedtechid = "@selectedtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "orderedunitguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertOrderedUnitComment
		/// </summary>
		public abstract class InsertOrderedUnitComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertOrderedUnitComment",
				cannedcommentguid = "@cannedcommentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedunitcommentguid = "@orderedunitcommentguid",
				orderedunitcommenttext = "@orderedunitcommenttext",
				orderedunitguid = "@orderedunitguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedunitcommentguid", "orderedunitguid"
			};
		}

		/// <summary>
		/// spInsertPatient
		/// </summary>
		public abstract class InsertPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatient",
				aborhchangeindicator = "@aborhchangeindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientdeathdate = "@patientdeathdate",
				patientdob = "@patientdob",
				patientdobcode = "@patientdobcode",
				patientfirstname = "@patientfirstname",
				patientguid = "@patientguid",
				patienticn = "@patienticn",
				patientlastname = "@patientlastname",
				patientmiddlename = "@patientmiddlename",
				patientsexcode = "@patientsexcode",
				patientssn = "@patientssn",
				recordstatuscode = "@recordstatuscode",
				SsnPrefix = "@SsnPrefix",
				ssnpseudoindicator = "@ssnpseudoindicator",
				vistapatientid = "@vistapatientid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientdobcode", "patientfirstname", "patientguid", "patientlastname", "patientssn", "recordstatuscode", "vistapatientid"
			};
		}

		/// <summary>
		/// spInsertPatientOrder
		/// </summary>
		public abstract class InsertPatientOrder
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientOrder",
				divisioncode = "@divisioncode",
				informedconsentindicator = "@informedconsentindicator",
				institutiondivisioncode = "@institutiondivisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				ordercomments = "@ordercomments",
				orderenteredbyfirstname = "@orderenteredbyfirstname",
				orderenteredbyid = "@orderenteredbyid",
				orderenteredbylastname = "@orderenteredbylastname",
				orderenteredbymiddleinitial = "@orderenteredbymiddleinitial",
				ordergroupnumber = "@ordergroupnumber",
				orderinghospitallocation = "@orderinghospitallocation",
				orderingproviderfirstname = "@orderingproviderfirstname",
				orderingproviderid = "@orderingproviderid",
				orderingproviderlastname = "@orderingproviderlastname",
				orderingprovidermiddleinitial = "@orderingprovidermiddleinitial",
				orderplaceddatetime = "@orderplaceddatetime",
				orderreceiveddatetime = "@orderreceiveddatetime",
				patientorderguid = "@patientorderguid",
				patienttreatmentguid = "@patienttreatmentguid",
				requestreason = "@requestreason",
				specimenrequiredindicator = "@specimenrequiredindicator",
				surgeryname = "@surgeryname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientorderguid", "patienttreatmentguid"
			};
		}

		/// <summary>
		/// spInsertPatientSpecimen
		/// </summary>
		public abstract class InsertPatientSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientSpecimen",
				cannedcommentguid = "@cannedcommentguid",
				divisioncode = "@divisioncode",
				entrytechid = "@entrytechid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maintainablespecimenindicator = "@maintainablespecimenindicator",
				patientguid = "@patientguid",
				patientspecimenguid = "@patientspecimenguid",
				phlebotomistid = "@phlebotomistid",
				specimenaccessionnumber = "@specimenaccessionnumber",
				specimencollectiondate = "@specimencollectiondate",
				specimencomments = "@specimencomments",
				specimenexpirationdate = "@specimenexpirationdate",
				specimenreceiveddate = "@specimenreceiveddate",
				specimenstatuscode = "@specimenstatuscode",
				specimenuid = "@specimenuid",
				unacceptablespecimenindicator = "@unacceptablespecimenindicator",
				vbecsspecimennumber = "@vbecsspecimennumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid", "patientspecimenguid", "specimencollectiondate", "specimenexpirationdate", "specimenstatuscode"
			};
		}

		/// <summary>
		/// spInsertPatientTransfusion
		/// </summary>
		public abstract class InsertPatientTransfusion
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientTransfusion",
				applicationofrecordid = "@applicationofrecordid",
				bedsideverificationdate = "@bedsideverificationdate",
				bedsideverificationunitmanualentryreason = "@bedsideverificationunitmanualentryreason",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				interruptioncomment = "@interruptioncomment",
				interruptionindicator = "@interruptionindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				locationien = "@locationien",
				patientguid = "@patientguid",
				patienttransfusionguid = "@patienttransfusionguid",
				reactionindicator = "@reactionindicator",
				reactionsymptoms = "@reactionsymptoms",
				transfusedvolume = "@transfusedvolume",
				transfusionenddatetime = "@transfusionenddatetime",
				transfusionist1id = "@transfusionist1id",
				transfusionist2id = "@transfusionist2id",
				transfusionlocation = "@transfusionlocation",
				transfusionstartdatetime = "@transfusionstartdatetime";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "interruptionindicator", "patientguid", "patienttransfusionguid", "reactionindicator", "transfusionenddatetime", "transfusionlocation", "transfusionstartdatetime"
			};
		}

		/// <summary>
		/// spInsertPatientTransfusionComment
		/// </summary>
		public abstract class InsertPatientTransfusionComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientTransfusionComment",
				cannedcommentguid = "@cannedcommentguid",
				commentcategorycode = "@commentcategorycode",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusioncommentguid = "@patienttransfusioncommentguid",
				patienttransfusioncommenttext = "@patienttransfusioncommenttext",
				patienttransfusionguid = "@patienttransfusionguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				pretransfusionindicator = "@pretransfusionindicator",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusioncommentguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertPatientTransfusionReaction
		/// </summary>
		public abstract class InsertPatientTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientTransfusionReaction",
				divisioncode = "@divisioncode",
				entrydatetime = "@entrydatetime",
				entrytechid = "@entrytechid",
				investigateddatetime = "@investigateddatetime",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				medicaldirectorname = "@medicaldirectorname",
				noteddatetime = "@noteddatetime",
				orderedtestguid = "@orderedtestguid",
				partialsaveid = "@partialsaveid",
				patientguid = "@patientguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				postspecimenclericalchecksokindicator = "@postspecimenclericalchecksokindicator",
				postspecimenguid = "@postspecimenguid",
				postspecimenhemolysisinspectioncode = "@postspecimenhemolysisinspectioncode",
				postspecimennotavailableindicator = "@postspecimennotavailableindicator",
				prespecimenclericalchecksokindicator = "@prespecimenclericalchecksokindicator",
				prespecimenguid = "@prespecimenguid",
				prespecimenhemolysisinspectioncode = "@prespecimenhemolysisinspectioncode",
				prespecimennotavailableindicator = "@prespecimennotavailableindicator",
				recordstatuscode = "@recordstatuscode",
				transfusionreactiontypecode = "@transfusionreactiontypecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "partialsaveid", "patientguid", "patienttransfusionreactionguid", "postspecimenclericalchecksokindicator", "postspecimennotavailableindicator", "prespecimenclericalchecksokindicator", "prespecimennotavailableindicator", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertPatientTransfusionReactionSymptom
		/// </summary>
		public abstract class InsertPatientTransfusionReactionSymptom
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientTransfusionReactionSymptom",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientsymptomid = "@patientsymptomid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				sortcolumn = "@sortcolumn";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientsymptomid", "patienttransfusionreactionguid", "sortcolumn"
			};
		}

		/// <summary>
		/// spInsertPatientTreatment
		/// </summary>
		public abstract class InsertPatientTreatment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPatientTreatment",
				inpatientindicator = "@inpatientindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientadmittingdiagnosis = "@patientadmittingdiagnosis",
				patientguid = "@patientguid",
				patientlocation = "@patientlocation",
				patientroombed = "@patientroombed",
				patienttreatmentguid = "@patienttreatmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patientguid", "patienttreatmentguid"
			};
		}

		/// <summary>
		/// spInsertPoolCounter
		/// </summary>
		public abstract class InsertPoolCounter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertPoolCounter",
				countervalue = "@countervalue",
				counteryear = "@counteryear",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				poolcounterguid = "@poolcounterguid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"countervalue", "counteryear", "divisioncode", "poolcounterguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertProductShipper
		/// </summary>
		public abstract class InsertProductShipper
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertProductShipper",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				productcost = "@productcost",
				productshipperguid = "@productshipperguid",
				recordstatuscode = "@recordstatuscode",
				returncreditpercentage = "@returncreditpercentage";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode", "localsupplierguid", "productcost", "productshipperguid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertRackLot
		/// </summary>
		public abstract class InsertRackLot
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertRackLot",
				comments = "@comments",
				controlcellid = "@controlcellid",
				dailyqcworklistguid = "@dailyqcworklistguid",
				divisioncode = "@divisioncode",
				expectedminimumreactions = "@expectedminimumreactions",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				lotusedate = "@lotusedate",
				lotvialnumber = "@lotvialnumber",
				RackGuid = "@rackguid",
				racklotguid = "@racklotguid",
				reactivityphasecode = "@reactivityphasecode",
				reagentguid = "@reagentguid",
				recordstatuscode = "@recordstatuscode",
				satisfactoryresultindicator = "@satisfactoryresultindicator",
				testingmethodcode = "@testingmethodcode",
				testwithid = "@testwithid",
				testwithname = "@testwithname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lotusedate", "racklotguid", "reagentguid"
			};
		}

		/// <summary>
		/// spInsertRackTest
		/// </summary>
		public abstract class InsertRackTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertRackTest",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racklotguid = "@racklotguid",
				racktestguid = "@racktestguid",
				racktestresult = "@racktestresult",
				racktestresulttypecode = "@racktestresulttypecode",
				recordstatuscode = "@recordstatuscode",
				testdate = "@testdate",
				testtechid = "@testtechid",
				testwithreagentguid = "@testwithreagentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "racklotguid", "racktestguid", "racktestresulttypecode", "recordstatuscode", "testdate", "testtechid"
			};
		}

		/// <summary>
		/// spInsertReagent
		/// </summary>
		public abstract class InsertReagent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertReagent",
				comments = "@comments",
				divisioncode = "@divisioncode",
				inspectionindicator = "@inspectionindicator",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				lotexpirationdate = "@lotexpirationdate",
				lotnumber = "@lotnumber",
				numbervialsavailable = "@numbervialsavailable",
				numbervialsreceived = "@numbervialsreceived",
				reagentguid = "@reagentguid",
				reagentmanufacturername = "@reagentmanufacturername",
				reagentname = "@reagentname",
				reagenttypeid = "@reagenttypeid",
				receiptdate = "@receiptdate",
				receipttechid = "@receipttechid",
				recordstatuscode = "@recordstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"comments", "divisioncode", "inspectionindicator", "invoicenumber", "lotexpirationdate", "lotnumber", "numbervialsavailable", "numbervialsreceived", "reagentguid", "reagentmanufacturername", "reagentname", "reagenttypeid", "receiptdate", "receipttechid", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertReagentChange
		/// </summary>
		public abstract class InsertReagentChange
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertReagentChange",
				comments = "@comments",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				reagentchangedetailcode = "@reagentchangedetailcode",
				reagentchangeguid = "@reagentchangeguid",
				reagentguid = "@reagentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"comments", "reagentchangedetailcode", "reagentchangeguid", "reagentguid"
			};
		}

		/// <summary>
		/// spInsertReagentTestParameter
		/// </summary>
		public abstract class InsertReagentTestParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertReagentTestParameter",
				canchangeindicator = "@canchangeindicator",
				commercialindicator = "@commercialindicator",
				dailyuseindicator = "@dailyuseindicator",
				divisioncode = "@divisioncode",
				expectedminimumreactions = "@expectedminimumreactions",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				mustuseindicator = "@mustuseindicator",
				reactivityphasecode = "@reactivityphasecode",
				reagenttestparameterguid = "@reagenttestparameterguid",
				reagenttypeid = "@reagenttypeid",
				recordstatuscode = "@recordstatuscode",
				setvialid = "@setvialid",
				sortcolumn = "@sortcolumn",
				testwithid = "@testwithid",
				testwithname = "@testwithname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"canchangeindicator", "commercialindicator", "dailyuseindicator", "divisioncode", "expectedminimumreactions", "mustuseindicator", "reactivityphasecode", "reagenttestparameterguid", "reagenttypeid", "sortcolumn", "testwithid", "testwithname"
			};
		}

		/// <summary>
		/// spInsertReagentTypeParameter
		/// </summary>
		public abstract class InsertReagentTypeParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertReagentTypeParameter",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				minimumstocklevel = "@minimumstocklevel",
				reagenttypeid = "@reagenttypeid",
				reagenttypeparameterguid = "@reagenttypeparameterguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "minimumstocklevel", "reagenttypeid", "reagenttypeparameterguid"
			};
		}

		/// <summary>
		/// spInsertScheduledReport
		/// </summary>
		public abstract class InsertScheduledReport
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertScheduledReport",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				reportparameters = "@reportparameters",
				reportprintdate = "@reportprintdate",
				scheduledreportguid = "@scheduledreportguid",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"reportparameters", "reportprintdate", "scheduledreportguid"
			};
		}

		/// <summary>
		/// spInsertShipment
		/// </summary>
		public abstract class InsertShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertShipment",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				productshipperguid = "@productshipperguid",
				recordstatuscode = "@recordstatuscode",
				shipmentdate = "@shipmentdate",
				shipmentdirection = "@shipmentdirection",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicenumber", "localsupplierguid", "productshipperguid", "shipmentdirection", "shipmentguid"
			};
		}

		/// <summary>
		/// spInsertSpecialInstructions
		/// </summary>
		public abstract class InsertSpecialInstructions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertSpecialInstructions",
				createdate = "@createdate",
				createuser = "@createuser",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientspecialinstructionguid = "@patientspecialinstructionguid",
				patientspecialinstructions = "@patientspecialinstructions",
				recordstatuscode = "@recordstatuscode",
				vistaconversionindicator = "@vistaconversionindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid", "patientspecialinstructionguid", "patientspecialinstructions", "recordstatuscode"
			};
		}

		/// <summary>
		/// spInsertSpecimenTest
		/// </summary>
		public abstract class InsertSpecimenTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertSpecimenTest",
				antibodytypeid = "@antibodytypeid",
				autoinstrumentname = "@autoinstrumentname",
				autoinstrumentqcindicator = "@autoinstrumentqcindicator",
				bloodtesttypeid = "@bloodtesttypeid",
				cannedcommentguid = "@cannedcommentguid",
				correctedresultindicator = "@correctedresultindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				offsitecost = "@offsitecost",
				offsiteindicator = "@offsiteindicator",
				offsitelocation = "@offsitelocation",
				orderedtestguid = "@orderedtestguid",
				patientspecimenguid = "@patientspecimenguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				RackGuid = "@rackguid",
				reactivityphasecode = "@reactivityphasecode",
				specimentestguid = "@specimentestguid",
				testcomments = "@testcomments",
				testdate = "@testdate",
				testingmethodcode = "@testingmethodcode",
				testresultid = "@testresultid",
				testtechid = "@testtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtesttypeid", "divisioncode", "orderedtestguid", "patientspecimenguid", "specimentestguid", "testdate", "testtechid"
			};
		}

		/// <summary>
		/// spInsertSpecimenTestThreshold
		/// </summary>
		public abstract class InsertSpecimenTestThreshold
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertSpecimenTestThreshold",
				componentclassid = "@componentclassid",
				divisioncode = "@divisioncode",
				labtestid = "@labtestid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				reporttypeid = "@reporttypeid",
				specimentestthresholdguid = "@specimentestthresholdguid",
				specimentypecode = "@specimentypecode",
				thresholdresult = "@thresholdresult",
				vistalaboratorytestname = "@vistalaboratorytestname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "labtestid", "recordstatuscode", "specimentestthresholdguid", "specimentypecode", "vistalaboratorytestname"
			};
		}

		/// <summary>
		/// spInsertSupply
		/// </summary>
		public abstract class InsertSupply
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertSupply",
				availablequantity = "@availablequantity",
				comments = "@comments",
				divisioncode = "@divisioncode",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				lotexpirationdate = "@lotexpirationdate",
				lotnumber = "@lotnumber",
				lotquantity = "@lotquantity",
				manufacturername = "@manufacturername",
				receiptdate = "@receiptdate",
				receipttechid = "@receipttechid",
				satisfactoryindicator = "@satisfactoryindicator",
				supplyguid = "@supplyguid",
				supplyname = "@supplyname",
				supplytypeid = "@supplytypeid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "receiptdate", "receipttechid", "supplyguid", "supplytypeid"
			};
		}

		/// <summary>
		/// spInsertTransfusionReaction
		/// </summary>
		public abstract class InsertTransfusionReaction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertTransfusionReaction",
				bagclericalchecksokindicator = "@bagclericalchecksokindicator",
				baghemolysisinspectioncode = "@baghemolysisinspectioncode",
				bagreturnedindicator = "@bagreturnedindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionguid = "@patienttransfusionguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				tagnotscannedindicator = "@tagnotscannedindicator",
				transfusionreactionguid = "@transfusionreactionguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bagreturnedindicator", "patienttransfusionguid", "patienttransfusionreactionguid", "transfusionreactionguid"
			};
		}

		/// <summary>
		/// spInsertTransfusionRequirements
		/// </summary>
		public abstract class InsertTransfusionRequirements
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertTransfusionRequirements",
				antibodytypeid = "@antibodytypeid",
				antigentypeid = "@antigentypeid",
				componentrequirementid = "@componentrequirementid",
				createdate = "@createdate",
				createdivisioncode = "@createdivisioncode",
				createuser = "@createuser",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patienttransfusionrequirementguid = "@patienttransfusionrequirementguid",
				recordstatuscode = "@recordstatuscode",
				specimentestguid = "@specimentestguid",
				transfusionrequirementcategorycode = "@transfusionrequirementcategorycode",
				transfusionrequirementtext = "@transfusionrequirementtext",
				vistaconversionindicator = "@vistaconversionindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"createdate", "createuser", "divisioncode", "patientguid", "patienttransfusionrequirementguid", "recordstatuscode", "transfusionrequirementcategorycode", "transfusionrequirementtext"
			};
		}

		/// <summary>
		/// spInsertVamcDivisionBase
		/// </summary>
		public abstract class InsertVamcDivisionBase
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertVamcDivisionBase",
				accessionareaid = "@accessionareaid",
				daylightsavingsenddate = "@daylightsavingsenddate",
				daylightsavingsstartdate = "@daylightsavingsstartdate",
				daylightsavingstypeid = "@daylightsavingstypeid",
				divisioncode = "@divisioncode",
				divisionguid = "@divisionguid",
				divisionname = "@divisionname",
				facilityguid = "@facilityguid",
				invoicetemplatetext = "@invoicetemplatetext",
				labelprintercomportnumber = "@labelprintercomportnumber",
				labelprinteripaddress = "@labelprinteripaddress",
				labelprintertcpportnumber = "@labelprintertcpportnumber",
				labelprinteruseindicator = "@labelprinteruseindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				lockinactivitytimeoutmin = "@lockinactivitytimeoutmin",
				printername = "@printername",
				recordstatuscode = "@recordstatuscode",
				servicetypeindicator = "@servicetypeindicator",
				timezoneid = "@timezoneid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"accessionareaid", "daylightsavingstypeid", "divisioncode", "divisionguid", "divisionname", "facilityguid", "invoicetemplatetext", "labelprinteruseindicator", "localsupplierguid", "lockinactivitytimeoutmin", "recordstatuscode", "servicetypeindicator"
			};
		}

		/// <summary>
		/// spInsertVbecsUser
		/// </summary>
		public abstract class InsertVbecsUser
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertVbecsUser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				userduz = "@userduz",
				useremail = "@useremail",
				userinitials = "@userinitials",
				username = "@username",
				vbecsuserguid = "@vbecsuserguid",
				vbecsuserid = "@vbecsuserid",
				vistausername = "@vistausername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"recordstatuscode", "userduz", "userinitials", "username", "vbecsuserguid", "vbecsuserid", "vistausername"
			};
		}

		/// <summary>
		/// spInsertVbecsUserDivisionRole
		/// </summary>
		public abstract class InsertVbecsUserDivisionRole
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertVbecsUserDivisionRole",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				userroleid = "@userroleid",
				vbecsuserid = "@vbecsuserid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordstatuscode", "userroleid", "vbecsuserid"
			};
		}

		/// <summary>
		/// spInsertVistaCache
		/// </summary>
		public abstract class InsertVistaCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertVistaCache",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				vistadatasetname = "@vistadatasetname",
				vistaxml = "@vistaxml";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vistadatasetname", "vistaxml"
			};
		}

		/// <summary>
		/// spInsertVistALinkConfig
		/// </summary>
		public abstract class InsertVistALinkConfig
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertVistALinkConfig",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				serveralias = "@serveralias",
				serverapphandle = "@serverapphandle",
				vistadomainname = "@vistadomainname",
				vistaipaddress = "@vistaipaddress",
				vistaportnumber = "@vistaportnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"serveralias", "serverapphandle", "vistaportnumber"
			};
		}

		/// <summary>
		/// spInsertWorkloadCache
		/// </summary>
		public abstract class InsertWorkloadCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertWorkloadCache",
				code_id = "@code_id",
				cost = "@cost",
				lastupdatedate = "@lastupdatedate",
				lmip = "@lmip",
				procedure = "@procedure",
				weightmultiplier = "@weightmultiplier";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"code_id", "cost", "lmip", "procedure", "weightmultiplier"
			};
		}

		/// <summary>
		/// spInsertWorkloadEvents
		/// </summary>
		public abstract class InsertWorkloadEvents
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertWorkloadEvents",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				miscellaneousguid = "@miscellaneousguid",
				orderedcomponentguid = "@orderedcomponentguid",
				orderedtestguid = "@orderedtestguid",
				patientguid = "@patientguid",
				recordsentindicator = "@recordsentindicator",
				recordstatuscode = "@recordstatuscode",
				vistatechid = "@vistatechid",
				weightmultiplier = "@weightmultiplier",
				workloadeventdate = "@workloadeventdate",
				workloadeventguid = "@workloadeventguid",
				workloadeventstatuscode = "@workloadeventstatuscode",
				workloadprocessguid = "@workloadprocessguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordsentindicator", "recordstatuscode", "vistatechid", "workloadeventdate", "workloadeventguid", "workloadeventstatuscode", "workloadprocessguid"
			};
		}

		/// <summary>
		/// spInsertWorkLoadProcess
		/// </summary>
		public abstract class InsertWorkLoadProcess
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInsertWorkLoadProcess",
				assigneddate = "@assigneddate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				unassigneddate = "@unassigneddate",
				vbecsprocessid = "@vbecsprocessid",
				weightmultiplier = "@weightmultiplier",
				workloadcode = "@workloadcode",
				workloadprocedure = "@workloadprocedure",
				workloadprocessguid = "@workloadprocessguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "vbecsprocessid", "weightmultiplier", "workloadcode", "workloadprocedure", "workloadprocessguid"
			};
		}

		/// <summary>
		/// spInvalidateAntigenTypingAntiseraUnitTest
		/// </summary>
		public abstract class InvalidateAntigenTypingAntiseraUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateAntigenTypingAntiseraUnitTest",
				antiseraunittestguid = "@antiseraunittestguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraunittestguid", "rowversion"
			};
		}

		/// <summary>
		/// spInvalidateAntigenTypingBloodUnitTest
		/// </summary>
		public abstract class InvalidateAntigenTypingBloodUnitTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateAntigenTypingBloodUnitTest",
				bloodunittestguid = "@bloodunittestguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid", "rowversion"
			};
		}

		/// <summary>
		/// spInvalidateAntigenTypingRackLot
		/// </summary>
		public abstract class InvalidateAntigenTypingRackLot
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateAntigenTypingRackLot",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racklotguid = "@racklotguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"racklotguid", "rowversion"
			};
		}

		/// <summary>
		/// spInvalidateAntigenTypingRackTest
		/// </summary>
		public abstract class InvalidateAntigenTypingRackTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateAntigenTypingRackTest",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racktestguid = "@racktestguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"racktestguid", "rowversion"
			};
		}

		/// <summary>
		/// spInvalidateBloodUnitTestsForReleasedOrderedUnit
		/// </summary>
		public abstract class InvalidateBloodUnitTestsForReleasedOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateBloodUnitTestsForReleasedOrderedUnit",
				bloodunittestguid = "@bloodunittestguid",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				testcomments = "@testcomments";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid", "inactivatedate", "inactivateuser", "rowversion", "testcomments"
			};
		}

		/// <summary>
		/// spInvalidateTransfusionReactionWorkup
		/// </summary>
		public abstract class InvalidateTransfusionReactionWorkup
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spInvalidateTransfusionReactionWorkup",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionreactionguid", "rowversion"
			};
		}

		/// <summary>
		/// spIsBloodProductActive
		/// </summary>
		public abstract class IsBloodProductActive
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsBloodProductActive",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode"
			};
		}

		/// <summary>
		/// spIsBloodProductOnActiveUnits
		/// </summary>
		public abstract class IsBloodProductOnActiveUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsBloodProductOnActiveUnits",
				bloodproductguid = "@bloodproductguid",
				divisioncode = "@divisioncode",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "divisioncode", "localsupplierguid"
			};
		}

		/// <summary>
		/// spIsBloodUnitNotInFinalStatus
		/// </summary>
		public abstract class IsBloodUnitNotInFinalStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsBloodUnitNotInFinalStatus",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spIsBloodUnitOnPendingOutgoingShipmentList
		/// </summary>
		public abstract class IsBloodUnitOnPendingOutgoingShipmentList
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsBloodUnitOnPendingOutgoingShipmentList",
				BloodUnitGuid = "@BloodUnitGUID";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid"
			};
		}

		/// <summary>
		/// spIsLocalSupplierActiveByIccbbaRegNum
		/// </summary>
		public abstract class IsLocalSupplierActiveByIccbbaRegNum
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsLocalSupplierActiveByIccbbaRegNum",
				divisioncode = "@divisioncode",
				iccbbaregistrationnumber = "@iccbbaregistrationnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "iccbbaregistrationnumber"
			};
		}

		/// <summary>
		/// spIsLocalSupplierOnActiveBloodProducts
		/// </summary>
		public abstract class IsLocalSupplierOnActiveBloodProducts
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsLocalSupplierOnActiveBloodProducts",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"localsupplierguid"
			};
		}

		/// <summary>
		/// spIsLocalSupplierOnActiveBloodUnits
		/// </summary>
		public abstract class IsLocalSupplierOnActiveBloodUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsLocalSupplierOnActiveBloodUnits",
				divisioncode = "@divisioncode",
				fdaregistrationnumber = "@fdaregistrationnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "fdaregistrationnumber"
			};
		}

		/// <summary>
		/// spIsOrderedComponentPending
		/// </summary>
		public abstract class IsOrderedComponentPending
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsOrderedComponentPending",
				componentclassid = "@componentclassid",
				divisioncode = "@divisioncode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spIsOrderedTestPending
		/// </summary>
		public abstract class IsOrderedTestPending
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsOrderedTestPending",
				divisionCode = "@divisionCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisionCode"
			};
		}

		/// <summary>
		/// spIsProductShipperActive
		/// </summary>
		public abstract class IsProductShipperActive
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsProductShipperActive",
				bloodproductguid = "@bloodproductguid",
				localsupplierguid = "@localsupplierguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "localsupplierguid"
			};
		}

		/// <summary>
		/// spIsSpecimenAssociatedWithDiagnosticTest
		/// </summary>
		public abstract class IsSpecimenAssociatedWithDiagnosticTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsSpecimenAssociatedWithDiagnosticTest",
				divisioncode = "@divisioncode",
				patientspecimenguid = "@patientspecimenguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecimenguid"
			};
		}

		/// <summary>
		/// spIsTransfusionHistoryforPatient
		/// </summary>
		public abstract class IsTransfusionHistoryforPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsTransfusionHistoryforPatient",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spIsValidFdaRegistrationNumber
		/// </summary>
		public abstract class IsValidFdaRegistrationNumber
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spIsValidFdaRegistrationNumber",
				divisioncode = "@divisioncode",
				fdaregistrationnumber = "@fdaregistrationnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "fdaregistrationnumber"
			};
		}

		/// <summary>
		/// spOutGoingInvoiceReport2
		/// </summary>
		public abstract class OutGoingInvoiceReport2
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spOutGoingInvoiceReport2",
				divisioncode = "@divisioncode",
				shipmentguid = "@shipmentguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "shipmentguid"
			};
		}

		/// <summary>
		/// spPatientOrderAlertPrint
		/// </summary>
		public abstract class PatientOrderAlertPrint
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spPatientOrderAlertPrint",
				cprsordernumber = "@cprsordernumber",
				divisioncode = "@divisioncode",
				patientorderguid = "@patientorderguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientorderguid"
			};
		}

		/// <summary>
		/// spPatientSearch
		/// </summary>
		public abstract class PatientSearch
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spPatientSearch",
				DivisionCode = "@DivisionCode",
				PatientLastName = "@PatientLastName",
				PatientSsn = "@PatientSSN",
				specimenuid = "@specimenuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode"
			};
		}

		/// <summary>
		/// spReleaseOrderedUnits
		/// </summary>
		public abstract class ReleaseOrderedUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spReleaseOrderedUnits",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedunitguid = "@orderedunitguid",
				releasedate = "@releasedate",
				releasetechid = "@releasetechid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedunitguid", "releasedate", "releasetechid", "rowversion"
			};
		}

		/// <summary>
		/// spReleaseOrderedUnitsByBloodUnit
		/// </summary>
		public abstract class ReleaseOrderedUnitsByBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spReleaseOrderedUnitsByBloodUnit",
				BloodUnitGuid = "@BloodUnitGUID",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				ReleaseDate = "@ReleaseDate",
				ReleaseTechId = "@ReleaseTechId",
				RowVersion = "@RowVersion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"BloodUnitGuid", "divisioncode", "ReleaseDate", "ReleaseTechId", "RowVersion"
			};
		}

		/// <summary>
		/// spReleaseRestriction
		/// </summary>
		public abstract class ReleaseRestriction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spReleaseRestriction",
				bloodunitmediaguid = "@bloodunitmediaguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				removerestrictiondate = "@removerestrictiondate",
				removerestrictiontechid = "@removerestrictiontechid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmediaguid", "comments", "divisioncode", "removerestrictiondate", "removerestrictiontechid", "rowversion"
			};
		}

		/// <summary>
		/// spRemoveAllUnitsFromBloodUnitShipment
		/// </summary>
		public abstract class RemoveAllUnitsFromBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spRemoveAllUnitsFromBloodUnitShipment",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				shipmentGuid = "@shipmentGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"shipmentGuid"
			};
		}

		/// <summary>
		/// spRemoveAllUnitsFromInvoice
		/// </summary>
		public abstract class RemoveAllUnitsFromInvoice
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spRemoveAllUnitsFromInvoice",
				bloodunitrowversion = "@bloodunitrowversion",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				shipmentGuid = "@shipmentGuid",
				shipmentrowversion = "@shipmentrowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"shipmentGuid"
			};
		}

		/// <summary>
		/// spRemoveAllUnitsFromShipment
		/// </summary>
		public abstract class RemoveAllUnitsFromShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spRemoveAllUnitsFromShipment",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				shipmentGuid = "@shipmentGuid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"shipmentGuid"
			};
		}

		/// <summary>
		/// spRestoreRestriction
		/// </summary>
		public abstract class RestoreRestriction
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spRestoreRestriction",
				bloodunitmediaguid = "@bloodunitmediaguid",
				comments = "@comments",
				directedpatientguid = "@directedpatientguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				removerestrictiondate = "@removerestrictiondate",
				removerestrictiontechid = "@removerestrictiontechid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmediaguid", "comments", "directedpatientguid", "divisioncode", "removerestrictiontechid", "rowversion"
			};
		}

		/// <summary>
		/// spSeedAllDayOneTemplatesForDivision
		/// </summary>
		public abstract class SeedAllDayOneTemplatesForDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedAllDayOneTemplatesForDivision",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedAntibodyParameterFromTemplate
		/// </summary>
		public abstract class SeedAntibodyParameterFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedAntibodyParameterFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedCannedCommentFromTemplate
		/// </summary>
		public abstract class SeedCannedCommentFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedCannedCommentFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedComponentClassParameter
		/// </summary>
		public abstract class SeedComponentClassParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedComponentClassParameter",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedMSBOSFromTemplate
		/// </summary>
		public abstract class SeedMSBOSFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedMSBOSFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedProductModParameterFromTemplate
		/// </summary>
		public abstract class SeedProductModParameterFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedProductModParameterFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedRackFromTemplate
		/// </summary>
		public abstract class SeedRackFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedRackFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedReagentTestParameterFromTemplate
		/// </summary>
		public abstract class SeedReagentTestParameterFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedReagentTestParameterFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedVbecsUserDivisionRoleFromTemplate
		/// </summary>
		public abstract class SeedVbecsUserDivisionRoleFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedVbecsUserDivisionRoleFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSeedVbecsUserFromTemplate
		/// </summary>
		public abstract class SeedVbecsUserFromTemplate
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSeedVbecsUserFromTemplate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode"
			};
		}

		/// <summary>
		/// spSingleBloodProductModification
		/// </summary>
		public abstract class SingleBloodProductModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spSingleBloodProductModification",
				pBloodProductGuid = "@pBloodProductGuid",
				pMethodSelect = "@pMethodSelect",
				pProductModificationCode = "@pProductModificationCode",
				pReturnData = "@pReturnData";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"pBloodProductGuid", "pProductModificationCode"
			};
		}

		/// <summary>
		/// spUpdateAddress
		/// </summary>
		public abstract class UpdateAddress
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAddress",
				addresscity = "@addresscity",
				addressguid = "@addressguid",
				addressline1 = "@addressline1",
				addressline2 = "@addressline2",
				addressline3 = "@addressline3",
				addressrowversion = "@addressrowversion",
				addresszipcode = "@addresszipcode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				statecode = "@statecode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"addressguid", "addressrowversion"
			};
		}

		/// <summary>
		/// spUpdateAntibodyTypes
		/// </summary>
		public abstract class UpdateAntibodyTypes
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAntibodyTypes",
				antibodytypeid = "@antibodytypeid",
				compatibilitypercentage = "@compatibilitypercentage",
				divisioncode = "@divisioncode",
				higherleveloverrideindicator = "@higherleveloverrideindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antibodytypeid", "divisioncode", "higherleveloverrideindicator", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateAntiseraOrderedTestStatus
		/// </summary>
		public abstract class UpdateAntiseraOrderedTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAntiseraOrderedTestStatus",
				antiseraorderedtestguid = "@antiseraorderedtestguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraorderedtestguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateAntiseraUnitTestStatus
		/// </summary>
		public abstract class UpdateAntiseraUnitTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAntiseraUnitTestStatus",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				LastUpdateUser = "@LastUpdateUser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateAntiseraWorklistStatus
		/// </summary>
		public abstract class UpdateAntiseraWorklistStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAntiseraWorklistStatus",
				antiseraworklistguid = "@antiseraworklistguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				LastUpdateUser = "@LastUpdateUser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateAntiseraWorklistTaskStatus
		/// </summary>
		public abstract class UpdateAntiseraWorklistTaskStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAntiseraWorklistTaskStatus",
				antiseraworklistguid = "@antiseraworklistguid",
				lastupdatedate = "@lastupdatedate",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklistguid", "rowversion", "taskstatuscode"
			};
		}

		/// <summary>
		/// spUpdateAssociatedInstitution
		/// </summary>
		public abstract class UpdateAssociatedInstitution
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateAssociatedInstitution",
				associatedinstitutionguid = "@associatedinstitutionguid",
				divisioncode = "@divisioncode",
				institutiondivisioncode = "@institutiondivisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"associatedinstitutionguid", "divisioncode", "institutiondivisioncode", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnit
		/// </summary>
		public abstract class UpdateBloodUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnit",
				bloodproductguid = "@bloodproductguid",
				bloodunitguid = "@bloodunitguid",
				discardedplasmavolume = "@discardedplasmavolume",
				donationtypeid = "@donationtypeid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				originalvolume = "@originalvolume",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				unitproductcode = "@unitproductcode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodproductguid", "bloodunitguid", "donationtypeid", "originalvolume", "recordstatuscode", "rowversion", "unitproductcode"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitAntigen
		/// </summary>
		public abstract class UpdateBloodUnitAntigen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitAntigen",
				antigentypeid = "@antigentypeid",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				positive = "@positive",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antigentypeid", "bloodunitguid", "divisioncode", "positive", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitFinance
		/// </summary>
		public abstract class UpdateBloodUnitFinance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitFinance",
				bloodunitfinanceguid = "@bloodunitfinanceguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				returncreditamount = "@returncreditamount",
				rowversion = "@rowversion",
				specialtestingcost = "@specialtestingcost",
				unitcost = "@unitcost";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitfinanceguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitMedia
		/// </summary>
		public abstract class UpdateBloodUnitMedia
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitMedia",
				bloodtypecode = "@bloodtypecode",
				bloodunitmediaguid = "@bloodunitmediaguid",
				comments = "@comments",
				directedpatientguid = "@directedpatientguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				removerestrictiondate = "@removerestrictiondate",
				removerestrictiontechid = "@removerestrictiontechid",
				rhfactorcode = "@rhfactorcode",
				rowversion = "@rowversion",
				testingstatusid = "@testingstatusid",
				unitexpirationdate = "@unitexpirationdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtypecode", "bloodunitmediaguid", "divisioncode", "rhfactorcode", "rowversion", "unitexpirationdate"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitModification
		/// </summary>
		public abstract class UpdateBloodUnitModification
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitModification",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationcost = "@modificationcost",
				modificationdate = "@modificationdate",
				modificationtechid = "@modificationtechid",
				newlabelverificationdatetime = "@newlabelverificationdatetime",
				originalunitindicator = "@originalunitindicator",
				pooleditedindicator = "@pooleditedindicator",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "divisioncode", "modificationcost", "modificationdate", "modificationtechid", "originalunitindicator", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitModificationStatus
		/// </summary>
		public abstract class UpdateBloodUnitModificationStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitModificationStatus",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitShipment
		/// </summary>
		public abstract class UpdateBloodUnitShipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitShipment",
				bloodunitshipmentguid = "@bloodunitshipmentguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitshipmentguid", "divisioncode", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitStatus
		/// </summary>
		public abstract class UpdateBloodUnitStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitStatus",
				biohazardouswarningindicator = "@biohazardouswarningindicator",
				bloodunitstatusguid = "@bloodunitstatusguid",
				discardcannedcommentguid = "@discardcannedcommentguid",
				divisioncode = "@divisioncode",
				emergencyissueindicator = "@emergencyissueindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				presumedtransfusedindicator = "@presumedtransfusedindicator",
				quarantinecannedcommentguid = "@quarantinecannedcommentguid",
				quarantineindicator = "@quarantineindicator",
				rowversion = "@rowversion",
				testinglimitindicator = "@testinglimitindicator",
				unitstatuscomments = "@unitstatuscomments",
				unitstatusdate = "@unitstatusdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"biohazardouswarningindicator", "bloodunitstatusguid", "divisioncode", "quarantineindicator", "rowversion", "testinglimitindicator"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitTestRecordStatus
		/// </summary>
		public abstract class UpdateBloodUnitTestRecordStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitTestRecordStatus",
				bloodunittestguid = "@bloodunittestguid",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				testcomments = "@testcomments";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid", "divisioncode", "recordstatuscode", "rowversion", "testcomments"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitTestResult
		/// </summary>
		public abstract class UpdateBloodUnitTestResult
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitTestResult",
				bloodunittestguid = "@bloodunittestguid",
				divisioncode = "@divisioncode",
				entrytechid = "@entrytechid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				testcomments = "@testcomments",
				testdate = "@testdate",
				testresultid = "@testresultid",
				testtechid = "@testtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid", "divisioncode", "entrytechid", "rowversion", "testdate", "testtechid"
			};
		}

		/// <summary>
		/// spUpdateBloodUnitTestStatus
		/// </summary>
		public abstract class UpdateBloodUnitTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateBloodUnitTestStatus",
				antiseraworklisttypingguid = "@antiseraworklisttypingguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antiseraworklisttypingguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateCannedComment
		/// </summary>
		public abstract class UpdateCannedComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateCannedComment",
				cannedcommentguid = "@cannedcommentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				sortcolumn = "@sortcolumn";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"cannedcommentguid", "recordstatuscode", "rowversion", "sortcolumn"
			};
		}

		/// <summary>
		/// spUpdateComponentClassParameter
		/// </summary>
		public abstract class UpdateComponentClassParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateComponentClassParameter",
				componentclassid = "@componentclassid",
				componentclassparameterguid = "@componentclassparameterguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maximumtransfusiontime = "@maximumtransfusiontime",
				orderableindicator = "@orderableindicator",
				rowversion = "@rowversion",
				specimenrequiredindicator = "@specimenrequiredindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"componentclassid", "componentclassparameterguid", "divisioncode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateConfigurableRackQC
		/// </summary>
		public abstract class UpdateConfigurableRackQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateConfigurableRackQC",
				dailycontrolguid = "@dailycontrolguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				RackGuid = "@rackguid",
				rackname = "@rackname",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailycontrolguid", "divisioncode", "RackGuid", "rackname", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateConfigureReagentQC
		/// </summary>
		public abstract class UpdateConfigureReagentQC
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateConfigureReagentQC",
				commercialindicator = "@commercialindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				reagenttestparameterguid = "@reagenttestparameterguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commercialindicator", "divisioncode", "reagenttestparameterguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateCrossmatchTestStatus
		/// </summary>
		public abstract class UpdateCrossmatchTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateCrossmatchTestStatus",
				bloodunittestguid = "@bloodunittestguid",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				testcomments = "@testcomments";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunittestguid", "divisioncode", "recordstatuscode", "rowversion", "testcomments"
			};
		}

		/// <summary>
		/// spUpdateDailyControl
		/// </summary>
		public abstract class UpdateDailyControl
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDailyControl",
				comments = "@comments",
				commercialtemplateindicator = "@commercialtemplateindicator",
				dailyalerttime = "@dailyalerttime",
				dailycontrolguid = "@dailycontrolguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				numberofracks = "@numberofracks",
				primaryenhancementmediaid = "@primaryenhancementmediaid",
				racknamesindicator = "@racknamesindicator",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				secondaryenhancementmediaid = "@secondaryenhancementmediaid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commercialtemplateindicator", "dailyalerttime", "dailycontrolguid", "divisioncode", "numberofracks", "primaryenhancementmediaid", "racknamesindicator", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateDailyQcWorklist
		/// </summary>
		public abstract class UpdateDailyQcWorklist
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDailyQcWorklist",
				dailyqcworklistguid = "@dailyqcworklistguid",
				dailyuseindicator = "@dailyuseindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				partiallytestedindicator = "@partiallytestedindicator",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid", "dailyuseindicator", "divisioncode", "partiallytestedindicator", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateDailyQcWorklistStatus
		/// </summary>
		public abstract class UpdateDailyQcWorklistStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDailyQcWorklistStatus",
				dailyqcworklistguid = "@dailyqcworklistguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateDiscardStatus
		/// </summary>
		public abstract class UpdateDiscardStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDiscardStatus",
				bloodunitstatusguid = "@bloodunitstatusguid",
				discardcannedcommentguid = "@discardcannedcommentguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				unitstatuscomments = "@unitstatuscomments",
				unitstatusdate = "@unitstatusdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitstatusguid", "discardcannedcommentguid", "divisioncode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateDivision
		/// </summary>
		public abstract class UpdateDivision
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDivision",
				antibodyscreendisplaycode = "@antibodyscreendisplaycode",
				autoinstrumentindicator = "@autoinstrumentindicator",
				divisioncode = "@divisioncode",
				divisionguid = "@divisionguid",
				electroniccrossmatchindicator = "@electroniccrossmatchindicator",
				iccbbaregistrationnumber = "@iccbbaregistrationnumber",
				iconalertsindicator = "@iconalertsindicator",
				iconorderalerttypecode = "@iconorderalerttypecode",
				iconordersneededhours = "@iconordersneededhours",
				iconrefreshrate = "@iconrefreshrate",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				loginmessagetext = "@loginmessagetext",
				maximumspecimenexpirationdays = "@maximumspecimenexpirationdays",
				medicaldirectorname = "@medicaldirectorname",
				printeralertsindicator = "@printeralertsindicator",
				printeralertsprintername = "@printeralertsprintername",
				printerorderalerttypecode = "@printerorderalerttypecode",
				printerordersneededhours = "@printerordersneededhours",
				reactivityphasecode = "@reactivityphasecode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"antibodyscreendisplaycode", "autoinstrumentindicator", "divisioncode", "electroniccrossmatchindicator", "iccbbaregistrationnumber", "maximumspecimenexpirationdays", "medicaldirectorname", "reactivityphasecode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateDssExtractSuccessIndicator
		/// </summary>
		public abstract class UpdateDssExtractSuccessIndicator
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateDssExtractSuccessIndicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionguid = "@patienttransfusionguid",
				rowversion = "@rowversion",
				successindicator = "@successindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patienttransfusionguid", "rowversion", "successindicator"
			};
		}

		/// <summary>
		/// spUpdateEquipment
		/// </summary>
		public abstract class UpdateEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateEquipment",
				addressguid = "@addressguid",
				comments = "@comments",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid",
				equipmentname = "@equipmentname",
				equipmenttype = "@equipmenttype",
				inspectionindicator = "@inspectionindicator",
				invoicenumber = "@invoicenumber",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localidentifier = "@localidentifier",
				maintenancecontractdate = "@maintenancecontractdate",
				maintenancecontractnumber = "@maintenancecontractnumber",
				manufacturername = "@manufacturername",
				manufacturerphonenumber = "@manufacturerphonenumber",
				nextmaintenancetext = "@nextmaintenancetext",
				outofserviceindicator = "@outofserviceindicator",
				receiptdate = "@receiptdate",
				receipttechid = "@receipttechid",
				rowversion = "@rowversion",
				serialnumber = "@serialnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"addressguid", "divisioncode", "equipmentguid", "equipmentname", "localidentifier", "manufacturername", "receiptdate", "rowversion", "serialnumber"
			};
		}

		/// <summary>
		/// spUpdateEquipmentMaintenance
		/// </summary>
		public abstract class UpdateEquipmentMaintenance
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateEquipmentMaintenance",
				divisioncode = "@divisioncode",
				equipmentguid = "@equipmentguid",
				equipmentmaintenanceguid = "@equipmentmaintenanceguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maintenancedate = "@maintenancedate",
				maintenanceresults = "@maintenanceresults",
				maintenancetype = "@maintenancetype",
				pendingissues = "@pendingissues",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "equipmentguid", "equipmentmaintenanceguid", "maintenancedate", "maintenanceresults", "maintenancetype", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateFinalMergeToPatient
		/// </summary>
		public abstract class UpdateFinalMergeToPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateFinalMergeToPatient",
				finalmergetopatient = "@finalmergetopatient",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"finalmergetopatient", "patientguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateHcpcsAssignment
		/// </summary>
		public abstract class UpdateHcpcsAssignment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateHcpcsAssignment",
				divisioncode = "@divisioncode",
				hcpcsassignmentguid = "@hcpcsassignmentguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "hcpcsassignmentguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateInvoiceText
		/// </summary>
		public abstract class UpdateInvoiceText
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateInvoiceText",
				divisioncode = "@divisioncode",
				invoicetemplatetext = "@invoicetemplatetext",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "invoicetemplatetext", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateIssuedUnit
		/// </summary>
		public abstract class UpdateIssuedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateIssuedUnit",
				divisioncode = "@divisioncode",
				issuedunitguid = "@issuedunitguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				returndatetime = "@returndatetime",
				returnfromlocationname = "@returnfromlocationname",
				returnsatisfactoryindicator = "@returnsatisfactoryindicator",
				returntechid = "@returntechid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "issuedunitguid", "returndatetime", "returnfromlocationname", "returnsatisfactoryindicator", "returntechid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateLabTest
		/// </summary>
		public abstract class UpdateLabTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateLabTest",
				componentclassid = "@componentclassid",
				divisioncode = "@divisioncode",
				labtestid = "@labtestid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				reporttypeid = "@reporttypeid",
				rowversion = "@rowversion",
				specimentestthresholdguid = "@specimentestthresholdguid",
				specimentypecode = "@specimentypecode",
				thresholdresult = "@thresholdresult",
				vistalaboratorytestname = "@vistalaboratorytestname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "labtestid", "recordstatuscode", "reporttypeid", "rowversion", "specimentestthresholdguid", "specimentypecode", "vistalaboratorytestname"
			};
		}

		/// <summary>
		/// spUpdateLocalSupplier
		/// </summary>
		public abstract class UpdateLocalSupplier
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateLocalSupplier",
				collectionindicator = "@collectionindicator",
				facilityname = "@facilityname",
				facilityprefix = "@facilityprefix",
				faxnumber = "@faxnumber",
				iccbbaregistrationnumber = "@iccbbaregistrationnumber",
				labelunitidtrimindicator = "@labelunitidtrimindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				phonenumber = "@phonenumber",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				testingindicator = "@testingindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"facilityname", "localsupplierguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateMergeFromPatient
		/// </summary>
		public abstract class UpdateMergeFromPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateMergeFromPatient",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				mergefrompatient = "@mergefrompatient",
				mergetopatient = "@mergetopatient",
				patientmergedate = "@patientmergedate",
				patientmergegroup = "@patientmergegroup",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "mergefrompatient", "mergetopatient", "patientmergedate", "patientmergegroup", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateMergeToPatient
		/// </summary>
		public abstract class UpdateMergeToPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateMergeToPatient",
				aborhchangeindicator = "@aborhchangeindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				mergefrompatient = "@mergefrompatient",
				mergetopatient = "@mergetopatient",
				patientmergedate = "@patientmergedate",
				patientmergegroup = "@patientmergegroup",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "mergefrompatient", "mergetopatient", "patientmergedate", "patientmergegroup", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateModificationEquipment
		/// </summary>
		public abstract class UpdateModificationEquipment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateModificationEquipment",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationequipmentguid = "@modificationequipmentguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "modificationequipmentguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateModificationSupply
		/// </summary>
		public abstract class UpdateModificationSupply
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateModificationSupply",
				bloodunitmodificationguid = "@bloodunitmodificationguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				modificationsupplyguid = "@modificationsupplyguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitmodificationguid", "modificationsupplyguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateMsbos
		/// </summary>
		public abstract class UpdateMsbos
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateMsbos",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				msbosguid = "@msbosguid",
				nobloodrequiredindicator = "@nobloodrequiredindicator",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				surgeryname = "@surgeryname",
				typeandscreenindicator = "@typeandscreenindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "msbosguid", "nobloodrequiredindicator", "recordstatuscode", "rowversion", "surgeryname", "typeandscreenindicator"
			};
		}

		/// <summary>
		/// spUpdateMsbosComponentClass
		/// </summary>
		public abstract class UpdateMsbosComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateMsbosComponentClass",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maximumsetupunitquantity = "@maximumsetupunitquantity",
				msboscomponentclassguid = "@msboscomponentclassguid",
				msbosguid = "@msbosguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"maximumsetupunitquantity", "msboscomponentclassguid", "msbosguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateOrderedComponentStatus
		/// </summary>
		public abstract class UpdateOrderedComponentStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateOrderedComponentStatus",
				cancellationcannedcommentguid = "@cancellationcannedcommentguid",
				cancellationtext = "@cancellationtext",
				emergencyorderindicator = "@emergencyorderindicator",
				inappropriaterequestindicator = "@inappropriaterequestindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				noinappropriatereporttext = "@noinappropriatereporttext",
				orderedcomponentguid = "@orderedcomponentguid",
				orderstatuscode = "@orderstatuscode",
				patientSpecimenguid = "@patientSpecimenguid",
				rowversion = "@rowversion",
				specimenAccessionNumber = "@specimenAccessionNumber",
				specimenworkloaduid = "@specimenworkloaduid",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedcomponentguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateOrderedTestStatus
		/// </summary>
		public abstract class UpdateOrderedTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateOrderedTestStatus",
				cancellationcannedcommentguid = "@cancellationcannedcommentguid",
				cancellationtext = "@cancellationtext",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedtestguid = "@orderedtestguid",
				orderstatuscode = "@orderstatuscode",
				patientspecimenguid = "@patientspecimenguid",
				rowversion = "@rowversion",
				specimenAccessionNumber = "@specimenAccessionNumber",
				specimenworkloaduid = "@specimenworkloaduid",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedtestguid", "orderstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateOrderedTestTaskStatus
		/// </summary>
		public abstract class UpdateOrderedTestTaskStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateOrderedTestTaskStatus",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedtestguid = "@orderedtestguid",
				orderstatuscode = "@orderstatuscode",
				rowversion = "@rowversion",
				taskstatusCode = "@taskstatusCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"orderedtestguid", "rowversion", "taskstatusCode"
			};
		}

		/// <summary>
		/// spUpdateOrderedUnit
		/// </summary>
		public abstract class UpdateOrderedUnit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateOrderedUnit",
				crossmatchdate = "@crossmatchdate",
				crossmatchresultcode = "@crossmatchresultcode",
				crossmatchtechid = "@crossmatchtechid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				orderedunitguid = "@orderedunitguid",
				recordstatuscode = "@recordstatuscode",
				releasedate = "@releasedate",
				releasetechid = "@releasetechid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "orderedunitguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientAboRHChangeIndicator
		/// </summary>
		public abstract class UpdatePatientAboRHChangeIndicator
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientAboRHChangeIndicator",
				aborhchangeindicator = "@aborhchangeindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"aborhchangeindicator", "patientguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientChangeStatus
		/// </summary>
		public abstract class UpdatePatientChangeStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientChangeStatus",
				ActiveDivisionsAlertViewed = "@ActiveDivisionsAlertViewed",
				LastUpdateDate = "@LastUpdateDate",
				LastUpdateFunctionId = "@LastUpdateFunctionId",
				LastUpdateUser = "@LastUpdateUser",
				PatientChangeGuid = "@PatientChangeGuid",
				PatientChangeStatusCode = "@PatientChangeStatusCode",
				RowVersion = "@RowVersion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"PatientChangeGuid", "PatientChangeStatusCode", "RowVersion"
			};
		}

		/// <summary>
		/// spUpdatePatientSpecimen
		/// </summary>
		public abstract class UpdatePatientSpecimen
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientSpecimen",
				cannedcommentguid = "@cannedcommentguid",
				divisioncode = "@divisioncode",
				entrytechid = "@entrytechid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				maintainablespecimenindicator = "@maintainablespecimenindicator",
				patientguid = "@patientguid",
				patientspecimenguid = "@patientspecimenguid",
				phlebotomistid = "@phlebotomistid",
				rowversion = "@rowversion",
				specimenaccessionnumber = "@specimenaccessionnumber",
				specimencollectiondate = "@specimencollectiondate",
				specimencomments = "@specimencomments",
				specimenexpirationdate = "@specimenexpirationdate",
				specimenreceiveddate = "@specimenreceiveddate",
				specimenstatuscode = "@specimenstatuscode",
				specimenuid = "@specimenuid",
				unacceptablespecimenindicator = "@unacceptablespecimenindicator",
				vbecsspecimennumber = "@vbecsspecimennumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid", "patientspecimenguid", "rowversion", "specimencollectiondate", "specimenexpirationdate", "specimenstatuscode", "unacceptablespecimenindicator"
			};
		}

		/// <summary>
		/// spUpdatePatientTransfusionComment
		/// </summary>
		public abstract class UpdatePatientTransfusionComment
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientTransfusionComment",
				cannedcommentguid = "@cannedcommentguid",
				commentcategorycode = "@commentcategorycode",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusioncommentguid = "@patienttransfusioncommentguid",
				patienttransfusioncommenttext = "@patienttransfusioncommenttext",
				patienttransfusionguid = "@patienttransfusionguid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"commentcategorycode", "patienttransfusioncommentguid", "patienttransfusionguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientTransfusionReactionPartialSaveId
		/// </summary>
		public abstract class UpdatePatientTransfusionReactionPartialSaveId
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientTransfusionReactionPartialSaveId",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				partialsaveid = "@partialsaveid",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "partialsaveid", "patienttransfusionreactionguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientTransfusionReactionStatus
		/// </summary>
		public abstract class UpdatePatientTransfusionReactionStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientTransfusionReactionStatus",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionreactionguid = "@patienttransfusionreactionguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionreactionguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientTransfusionRecord
		/// </summary>
		public abstract class UpdatePatientTransfusionRecord
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientTransfusionRecord",
				applicationofrecordid = "@applicationofrecordid",
				bedsideverificationdate = "@bedsideverificationdate",
				bedsideverificationunitmanualentryreason = "@bedsideverificationunitmanualentryreason",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				interruptioncomment = "@interruptioncomment",
				interruptionindicator = "@interruptionindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				locationien = "@locationien",
				patientguid = "@patientguid",
				patienttransfusionguid = "@patienttransfusionguid",
				reactionindicator = "@reactionindicator",
				reactionsymptoms = "@reactionsymptoms",
				rowversion = "@rowversion",
				transfusedvolume = "@transfusedvolume",
				transfusionenddatetime = "@transfusionenddatetime",
				transfusionist1id = "@transfusionist1id",
				transfusionist2id = "@transfusionist2id",
				transfusionlocation = "@transfusionlocation",
				transfusionstartdatetime = "@transfusionstartdatetime";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid", "patienttransfusionguid", "reactionindicator", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePatientTransfusionStatus
		/// </summary>
		public abstract class UpdatePatientTransfusionStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePatientTransfusionStatus",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionguid = "@patienttransfusionguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"patienttransfusionguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdatePoolCounter
		/// </summary>
		public abstract class UpdatePoolCounter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdatePoolCounter",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				poolcounterguid = "@poolcounterguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"poolcounterguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateProductModifications
		/// </summary>
		public abstract class UpdateProductModifications
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateProductModifications",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				productmodificationcode = "@productmodificationcode",
				productmodificationcost = "@productmodificationcost",
				productmodificationparameterguid = "@productmodificationparameterguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "productmodificationcode", "productmodificationcost", "productmodificationparameterguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateProductShipper
		/// </summary>
		public abstract class UpdateProductShipper
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateProductShipper",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				productcost = "@productcost",
				productshipperguid = "@productshipperguid",
				recordstatuscode = "@recordstatuscode",
				returncreditpercentage = "@returncreditpercentage",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"productcost", "productshipperguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateQuarantineStatus
		/// </summary>
		public abstract class UpdateQuarantineStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateQuarantineStatus",
				bloodunitguid = "@bloodunitguid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				quarantinecannedcommentguid = "@quarantinecannedcommentguid",
				quarantineindicator = "@quarantineindicator",
				rowversion = "@rowversion",
				unitstatuscomments = "@unitstatuscomments",
				unitstatusdate = "@unitstatusdate";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitguid", "divisioncode", "quarantineindicator", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateRackDailyUse
		/// </summary>
		public abstract class UpdateRackDailyUse
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateRackDailyUse",
				dailyqcexpirationdate = "@dailyqcexpirationdate",
				dailyqcworklistguid = "@dailyqcworklistguid",
				dailyuseindicator = "@dailyuseindicator",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				qcofflineindicator = "@qcofflineindicator",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"dailyqcworklistguid", "dailyuseindicator", "divisioncode", "qcofflineindicator", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateRackLot
		/// </summary>
		public abstract class UpdateRackLot
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateRackLot",
				comments = "@comments",
				controlcellid = "@controlcellid",
				divisioncode = "@divisioncode",
				expectedminimumreactions = "@expectedminimumreactions",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				lotusedate = "@lotusedate",
				lotvialnumber = "@lotvialnumber",
				RackGuid = "@rackguid",
				racklotguid = "@racklotguid",
				reactivityphasecode = "@reactivityphasecode",
				reagentguid = "@reagentguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				satisfactoryresultindicator = "@satisfactoryresultindicator",
				testwithid = "@testwithid",
				testwithname = "@testwithname";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "lotusedate", "racklotguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateRackLotResultStatus
		/// </summary>
		public abstract class UpdateRackLotResultStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateRackLotResultStatus",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racklotguid = "@racklotguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"racklotguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateRackTest
		/// </summary>
		public abstract class UpdateRackTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateRackTest",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racktestguid = "@racktestguid",
				racktestresult = "@racktestresult",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				testdate = "@testdate",
				testtechid = "@testtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "racktestguid", "rowversion", "testdate", "testtechid"
			};
		}

		/// <summary>
		/// spUpdateRackTestResultStatus
		/// </summary>
		public abstract class UpdateRackTestResultStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateRackTestResultStatus",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				racktestguid = "@racktestguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"racktestguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateReagent
		/// </summary>
		public abstract class UpdateReagent
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateReagent",
				comments = "@comments",
				inspectionindicator = "@inspectionindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				numbervialsavailable = "@numbervialsavailable",
				reagentguid = "@reagentguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"comments", "inspectionindicator", "numbervialsavailable", "reagentguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateReagentTypeParameter
		/// </summary>
		public abstract class UpdateReagentTypeParameter
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateReagentTypeParameter",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				minimumstocklevel = "@minimumstocklevel",
				reagenttypeparameterguid = "@reagenttypeparameterguid",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"minimumstocklevel", "reagenttypeparameterguid", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateReturnCreditAmount
		/// </summary>
		public abstract class UpdateReturnCreditAmount
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateReturnCreditAmount",
				bloodunitfinanceguid = "@bloodunitfinanceguid",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				returncreditamount = "@returncreditamount",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodunitfinanceguid", "returncreditamount", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateScheduledReportStatus
		/// </summary>
		public abstract class UpdateScheduledReportStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateScheduledReportStatus",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				scheduledreportguid = "@scheduledreportguid",
				taskstatuscode = "@taskstatuscode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"rowversion", "scheduledreportguid", "taskstatuscode"
			};
		}

		/// <summary>
		/// spUpdateSpecialInstructions
		/// </summary>
		public abstract class UpdateSpecialInstructions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateSpecialInstructions",
				createdate = "@createdate",
				createuser = "@createuser",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				inactivationcomment = "@inactivationcomment",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patientguid = "@patientguid",
				patientspecialinstructionguid = "@patientspecialinstructionguid",
				patientspecialinstructions = "@patientspecialinstructions",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				vistaconversionindicator = "@vistaconversionindicator";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientspecialinstructionguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateSpecimenTest
		/// </summary>
		public abstract class UpdateSpecimenTest
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateSpecimenTest",
				aborhchangeindicator = "@aborhchangeindicator",
				aborhchangejustification = "@aborhchangejustification",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				specimentestguid = "@specimentestguid",
				testresultid = "@testresultid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"aborhchangeindicator", "aborhchangejustification", "rowversion", "specimentestguid", "testresultid"
			};
		}

		/// <summary>
		/// spUpdateSpecimenTestForPatientTesting
		/// </summary>
		public abstract class UpdateSpecimenTestForPatientTesting
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateSpecimenTestForPatientTesting",
				bloodtesttypeid = "@bloodtesttypeid",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				specimentestguid = "@specimentestguid",
				testcomments = "@testcomments",
				testdate = "@testdate",
				testresultid = "@testresultid",
				testtechid = "@testtechid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"bloodtesttypeid", "divisioncode", "rowversion", "specimentestguid", "testdate", "testtechid"
			};
		}

		/// <summary>
		/// spUpdateSpecimenTestStatus
		/// </summary>
		public abstract class UpdateSpecimenTestStatus
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateSpecimenTestStatus",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivateuser = "@inactivateuser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				specimentestguid = "@specimentestguid",
				testcomments = "@testcomments";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordstatuscode", "rowversion", "specimentestguid", "testcomments"
			};
		}

		/// <summary>
		/// spUpdateSupplyUsage
		/// </summary>
		public abstract class UpdateSupplyUsage
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateSupplyUsage",
				availablequantity = "@availablequantity",
				comments = "@comments",
				divisioncode = "@divisioncode",
				inventorychangedate = "@inventorychangedate",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				supplyguid = "@supplyguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"availablequantity", "comments", "divisioncode", "inventorychangedate", "rowversion", "supplyguid"
			};
		}

		/// <summary>
		/// spUpdateTransfusionRequirements
		/// </summary>
		public abstract class UpdateTransfusionRequirements
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateTransfusionRequirements",
				divisioncode = "@divisioncode",
				inactivatedate = "@inactivatedate",
				inactivatedivisioncode = "@inactivatedivisioncode",
				inactivateuser = "@inactivateuser",
				inactivationcomment = "@inactivationcomment",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				patienttransfusionrequirementguid = "@patienttransfusionrequirementguid",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patienttransfusionrequirementguid", "recordstatuscode", "rowversion"
			};
		}

		/// <summary>
		/// spUpdateVamcDivisionBase
		/// </summary>
		public abstract class UpdateVamcDivisionBase
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateVamcDivisionBase",
				accessionareaid = "@accessionareaid",
				daylightsavingsenddate = "@daylightsavingsenddate",
				daylightsavingsstartdate = "@daylightsavingsstartdate",
				daylightsavingstypeid = "@daylightsavingstypeid",
				divisioncode = "@divisioncode",
				divisionguid = "@divisionguid",
				divisionname = "@divisionname",
				facilityguid = "@facilityguid",
				labelprintercomportnumber = "@labelprintercomportnumber",
				labelprinteripaddress = "@labelprinteripaddress",
				labelprintertcpportnumber = "@labelprintertcpportnumber",
				labelprinteruseindicator = "@labelprinteruseindicator",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				localsupplierguid = "@localsupplierguid",
				lockinactivitytimeoutmin = "@lockinactivitytimeoutmin",
				printername = "@printername",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				servicetypeindicator = "@servicetypeindicator",
				timezoneid = "@timezoneid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"accessionareaid", "daylightsavingstypeid", "divisioncode", "divisionguid", "divisionname", "facilityguid", "labelprinteruseindicator", "localsupplierguid", "lockinactivitytimeoutmin", "recordstatuscode", "rowversion", "servicetypeindicator"
			};
		}

		/// <summary>
		/// spUpdateVbecsUser
		/// </summary>
		public abstract class UpdateVbecsUser
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateVbecsUser",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				userduz = "@userduz",
				useremail = "@useremail",
				userinitials = "@userinitials",
				username = "@username",
				vbecsuserguid = "@vbecsuserguid",
				vbecsuserid = "@vbecsuserid",
				vistausername = "@vistausername";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"recordstatuscode", "rowversion", "userduz", "userinitials", "username", "vbecsuserguid", "vbecsuserid", "vistausername"
			};
		}

		/// <summary>
		/// spUpdateVbecsUserDivisionRole
		/// </summary>
		public abstract class UpdateVbecsUserDivisionRole
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateVbecsUserDivisionRole",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				userroleid = "@userroleid",
				vbecsuserid = "@vbecsuserid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordstatuscode", "rowversion", "userroleid", "vbecsuserid"
			};
		}

		/// <summary>
		/// spUpdateVistaCache
		/// </summary>
		public abstract class UpdateVistaCache
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateVistaCache",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				vistadatasetname = "@vistadatasetname",
				vistaxml = "@vistaxml";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vistadatasetname", "vistaxml"
			};
		}

		/// <summary>
		/// spUpdateVistALinkConfig
		/// </summary>
		public abstract class UpdateVistALinkConfig
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateVistALinkConfig",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				rowversion = "@rowversion",
				serveralias = "@serveralias",
				serverapphandle = "@serverapphandle",
				vistadomainname = "@vistadomainname",
				vistaipaddress = "@vistaipaddress",
				vistaportnumber = "@vistaportnumber";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"rowversion", "serveralias", "serverapphandle", "vistaportnumber"
			};
		}

		/// <summary>
		/// spUpdateWorkLoadProcess
		/// </summary>
		public abstract class UpdateWorkLoadProcess
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUpdateWorkLoadProcess",
				assigneddate = "@assigneddate",
				divisioncode = "@divisioncode",
				lastupdatedate = "@lastupdatedate",
				lastupdatefunctionid = "@lastupdatefunctionid",
				lastupdateuser = "@lastupdateuser",
				recordstatuscode = "@recordstatuscode",
				rowversion = "@rowversion",
				unassigneddate = "@unassigneddate",
				weightmultiplier = "@weightmultiplier",
				workloadprocessguid = "@workloadprocessguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "recordstatuscode", "rowversion", "workloadprocessguid"
			};
		}

		/// <summary>
		/// spUserPermissions
		/// </summary>
		public abstract class UserPermissions
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spUserPermissions",
				vbecsuserid = "@vbecsuserid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"vbecsuserid"
			};
		}

		/// <summary>
		/// spValidSpecimenExists
		/// </summary>
		public abstract class ValidSpecimenExists
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spValidSpecimenExists",
				divisioncode = "@divisioncode",
				patientguid = "@patientguid";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"divisioncode", "patientguid"
			};
		}

		/// <summary>
		/// spVistaGetLabTestResults
		/// </summary>
		public abstract class VistaGetLabTestResults
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetLabTestResults",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spVistaGetXmlAntibodiesIdentified
		/// </summary>
		public abstract class VistaGetXmlAntibodiesIdentified
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlAntibodiesIdentified",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlAvailableUnits
		/// </summary>
		public abstract class VistaGetXmlAvailableUnits
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlAvailableUnits",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlBloodBankData
		/// </summary>
		public abstract class VistaGetXmlBloodBankData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlBloodBankData",
				DivisionCode = "@DivisionCode",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"DivisionCode", "VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlComponentClass
		/// </summary>
		public abstract class VistaGetXmlComponentClass
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlComponentClass",
				No_parameters = "No_parameters";
		}

		/// <summary>
		/// spVistaGetXmlPatientAboRh
		/// </summary>
		public abstract class VistaGetXmlPatientAboRh
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlPatientAboRh",
				VistaPatientId = "@VistaPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistaPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlPatientData
		/// </summary>
		public abstract class VistaGetXmlPatientData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlPatientData",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlPatientReportData
		/// </summary>
		public abstract class VistaGetXmlPatientReportData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlPatientReportData",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlSpecimenTestForPatient
		/// </summary>
		public abstract class VistaGetXmlSpecimenTestForPatient
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlSpecimenTestForPatient",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlTransfusionHistory
		/// </summary>
		public abstract class VistaGetXmlTransfusionHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlTransfusionHistory",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlTransfusionReactionHistory
		/// </summary>
		public abstract class VistaGetXmlTransfusionReactionHistory
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlTransfusionReactionHistory",
				VistAPatientId = "@VistAPatientId";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"VistAPatientId"
			};
		}

		/// <summary>
		/// spVistaGetXmlWorkloadData
		/// </summary>
		public abstract class VistaGetXmlWorkloadData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaGetXmlWorkloadData",
				WorkloadEventStatusCode = "@WorkloadEventStatusCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"WorkloadEventStatusCode"
			};
		}

		/// <summary>
		/// spVistaUpdateWorkloadEventData
		/// </summary>
		public abstract class VistaUpdateWorkloadEventData
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spVistaUpdateWorkloadEventData",
				ErrorText = "@ErrorText",
				PceEncounterNumber = "@PceEncounterNumber",
				ProcessedDate = "@ProcessedDate",
				WorkloadEventGuid = "@WorkloadEventGuid",
				WorkloadEventStatusCode = "@WorkloadEventStatusCode";

			/// <summary>
			/// Required stored procedure parameters written as static array of strings
			/// </summary>
			public static string [] RequiredParameters = new string[]
			{
				"ProcessedDate", "WorkloadEventGuid", "WorkloadEventStatusCode"
			};
		}

		/// <summary>
		/// spWasBloodUnitPooledOrSplit
		/// </summary>
		public abstract class WasBloodUnitPooledOrSplit
		{
			/// <summary>
			/// Stored procedure name and list of all parms written as const
			/// </summary>
			public const string
				StoredProcName = "dbo.spWasBloodUnitPooledOrSplit",
				bloodunitguid = "@bloodunitguid";
		}
        /// <summary>
        /// spGetAllVbecsGlobalConfigValue
        /// </summary>
        public abstract class GetAllVbecsGlobalConfigValue
        {
            /// <summary>
            /// Stored procedure name and list of all parms written as const
            /// </summary>
            public const string
                StoredProcName = "dbo.spGetAllVbecsGlobalConfigValue",
                ApplicationName = "@applicationname";
        }
 

        /// <summary>
        /// spGetVbecsGlobalConfigValue
        /// </summary>
        public abstract class GetVbecsGlobalConfigValue
        {
            /// <summary>
            /// Stored procedure name and list of all parms written as const
            /// </summary>
            public const string
                StoredProcName = "dbo.spGetVbecsGlobalConfigValue",
                ApplicationName ="@applicationname",
                ParameterName = "@parametername";
        }
    }
}